
local L = MK_MOD_LANGUAGE_SETTING
local function AddPlayerActionWithSg(action, state, noboating)
    AddAction(action)
    AddStategraphActionHandler("wilson", ActionHandler(action, state))
    if noboating then return end
    AddStategraphActionHandler("wilsonboating", ActionHandler(action, state))
end

local OldPick = ACTIONS.PICKUP.fn
GLOBAL.ACTIONS.PICKUP.fn = function(act)
    if act.doer.components.inventory ~= nil and act.target ~= nil and act.target.components.flagpickupable ~= nil and not act.target:IsInLimbo() then
        act.doer:PushEvent("onpickupitem", {item = act.target})
        return act.target.components.flagpickupable:OnPickup(act.doer)
    end
    return OldPick(act)
end

local MK_LUNGE = Action({},10, false, true, 100, true)
MK_LUNGE.id = "MK_LUNGE"
MK_LUNGE.str = MK_MOD_LANGUAGE_SETTING and "Sprint" or "烈焰突刺"
MK_LUNGE.fn = function(act)
    local weapon = act.invobject
    if not (weapon and weapon.components.myth_weaponreticule) then
        return false
    end
    local pos = act.pos
    if not weapon.components.myth_weaponreticule:CanCast(act.doer, pos) then
        return true
    end
    weapon.components.myth_weaponreticule:CastSpell(act.doer, pos)
    return true
end

AddPlayerActionWithSg(MK_LUNGE, 'mk_lunge_start', true)

local FlyAttack = Action({},10, true, true, 100)
FlyAttack.id = "NZ_36"
FlyAttack.str = GLOBAL.MK_MOD_LANGUAGE_SETTING and 'Three heads and six arms' or '三头六臂'
FlyAttack.fn = function(act)
    act.doer.sg:GoToState('nz_superjump_start',act.pos or act.target:GetPosition())
end

AddAction(FlyAttack)

local MK_Drink = Action({mount_enabled=true})
MK_Drink.id = 'MK_DRINK'
MK_Drink.str = GLOBAL.MK_MOD_LANGUAGE_SETTING and 'Drink' or '就泯一小口'
MK_Drink.fn = function(act)
    if act.doer:HasTag('player') then
        act.doer.components.sanity:DoDelta(50)
        act.doer.components.hunger:DoDelta(12.5)
        act.doer.components.health:DoDelta(2)
    end
    act.invobject.components.wined:Drink()
    return true
end

AddPlayerActionWithSg(MK_Drink, 'mk_drink')

local MK_ADDWINE = Action({mount_enabled=true})
MK_ADDWINE.id = 'MK_ADDWINE'
MK_ADDWINE.str = GLOBAL.MK_MOD_LANGUAGE_SETTING and 'Add wine' or '满上'
MK_ADDWINE.fn = function(act)
    act.invobject.components.wine:Add(act.target)
    return true
end

AddPlayerActionWithSg(MK_ADDWINE, 'doshortaction')

local  MK_MOUGH = Action({})
MK_MOUGH.instant = true
MK_MOUGH.id = "MK_MOUGH"
MK_MOUGH.str = MK_MOD_LANGUAGE_SETTING and 'change' or '变化'
MK_MOUGH.fn = function(act)
    if act.doer and act.doer.prefab == 'monkey_king' then
        act.doer.sg:GoToState('mkhide')
        return true
    end
    return false
end
AddAction(MK_MOUGH)

local WB_HAUNT = Action({})
WB_HAUNT.id = 'WB_HAUNT'
WB_HAUNT.strfn = function(act)
    return act.target and act.target.components.wb_bone and 'WB_SPIRIT' or 'WB_HAUNT'
end
WB_HAUNT.fn = function(act)
    --print(act.doer, act.target)
    if act.target and act.target.components.wb_bone then
        act.target.components.wb_bone:Spirited(act.doer)
        return true
    elseif act.target and act.target.teleporter then
        act.target.components.teleporter:Activate(act.doer)
    else
        local pos = act.pos or act.target:GetPosition()
        act.doer:DoHaunt(pos)
        return true
    end
end
AddAction(WB_HAUNT)
GLOBAL.STRINGS.ACTIONS.WB_HAUNT = {
    WB_SPIRIT = MK_MOD_LANGUAGE_SETTING and 'Spirit' or '附身',
    WB_HAUNT  = MK_MOD_LANGUAGE_SETTING and 'Haunt' or '作祟',
}

local BONE_FIX = Action({mount_enabled = true})
BONE_FIX.id = "WB_BONE_FIX"
BONE_FIX.strfn = function(act)
    return (act.target == nil or act.target == GetPlayer()) and 'PLAYER' or 'NORMAL'
end
BONE_FIX.fn = function(act)
    if act.invobject and act.invobject.components.wb_bonehealer then
        act.invobject.components.wb_bonehealer:Use()
    else
        return false
    end
    if act.target == nil or act.target == GetPlayer() then
        GetPlayer():DoFix(act.invobject.components.wb_bonehealer.value)
        return true
    else
        if act.target.prefab and act.target.prefab:find('wb_') and act.target.DoFix then
            act.target:DoFix(act.invobject.components.wb_bonehealer.value* 5)
        end
        return true
    end
end

AddPlayerActionWithSg(BONE_FIX, 'wb_dofix')
STRINGS.ACTIONS.WB_BONE_FIX = {
    PLAYER = MK_MOD_LANGUAGE_SETTING and 'Fix body' or '多补钙',
    NORMAL = MK_MOD_LANGUAGE_SETTING and 'Fix' or '修复',
}
--[[
local WB_CUT = Action({mount_enabled = true})
WB_CUT.id = 'WB_CUT'
WB_CUT.str = MK_MOD_LANGUAGE_SETTING and 'dissect' or '剔骨'
WB_CUT.fn = function(act)
    if act.invobject and act.invobject.components.wb_meatcutter then
        return act.invobject.components.wb_meatcutter:CutMeat(act.doer, act.target)
    end
end
AddAction(WB_CUT)
AddStategraphActionHandler('wilson', ActionHandler(WB_CUT, 'dolongaction'))
AddStategraphActionHandler('wilsonboating', ActionHandler(WB_CUT, 'dolongaction'))
--]]
local FOG = Action({})
FOG.id = 'WB_FOG'
FOG.str = MK_MOD_LANGUAGE_SETTING and 'Fog' or '化雾'
FOG.fn = function(act)
    if act.doer and act.doer.components.wb_fog then
        act.doer.components.wb_fog:Start()
    end
    return true
end

AddPlayerActionWithSg(FOG, 'wb_fog')

local PLACE = Action({})
PLACE.id = 'RHI_PLACEITEM'
PLACE.str = MK_MOD_LANGUAGE_SETTING and 'Place' or '放置贡品'
PLACE.fn = function(act)
    if act.invobject and act.target and act.target.prefab == 'myth_rhino_desk' then
        return act.target:GetItem(act.invobject)
    end
end

AddPlayerActionWithSg(PLACE, 'give')

AddPrefabPostInit('monkey_king', function(inst)
    inst.components['由于技术原因而暂时咕咕咕的72变'] = {
        inst = inst,
        CollectSceneActions = function(self, doer, actions, right)
            if right and not inst:HasTag('mk_miao') and
                inst.components.inventory:GetActiveItem() == nil and
                inst.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS) == nil and 
                not (inst.components.rider and inst.components.rider:IsRiding()) and 
                not inst.components.health:IsDead() then

                table.insert(actions, ACTIONS.MK_MOUGH)
            end
        end,
    }
end)

--玩家右键动作
AddComponentPostInit('playeractionpicker',function(self)
    local OldFn = self.DoGetMouseActions
    function self:DoGetMouseActions(force_target, ...)
        local second_action = nil
        local target = nil
        local ents = TheInput:GetAllEntitiesUnderMouse()
            for k,v in pairs(ents) do
                if v:HasTag("player") then
                    target = v
                    break
                end
            end
        local target_in_light = target and target:IsValid() and target.Transform and TheSim:GetLightAtPoint(target.Transform:GetWorldPosition()) > TUNING.DARK_CUTOFF
        local position = TheInput:GetWorldPosition()
        if target_in_light then
            local acts = self:GetRightClickActions(target, position)
            if acts[1] and acts[1].action == ACTIONS.MK_MOUGH then
                second_action = acts[1]
            end
            if acts[1] and acts[1].action == ACTIONS.WB_FOG then
                second_action = acts[1]
            end
        end
        if second_action then
            return nil,second_action 
        else
            return
            OldFn(self,force_target,...)
        end
    end
end)
--AddStategraphActionHandler("wilson",ActionHandler(ACTIONS.MK_MOUGH, "give"))

local old_harvest = ACTIONS.HARVEST.fn
ACTIONS.HARVEST.fn = function(act)
	if old_harvest(act) then
		return true
	end
	if act.target.components.stewer_fur then
		return act.target.components.stewer_fur:Harvest(act.doer)
	end
end

local old_cook = ACTIONS.COOK.fn
ACTIONS.COOK.fn = function(act)
    if old_cook(act) then
        return true
    end
    if act.target.components.stewer_fur then
        act.target.components.stewer_fur:StartCooking()
        return true
    end
end


local old_mount = ACTIONS.MOUNT.fn
ACTIONS.MOUNT.fn = function(act)
    local obj = act.target
    if obj and obj.prefab == 'nz_wheel_single' then
        act.target = obj.wheel  
        if not act.target or not act.target:IsValid() then
            return true
        end
    end

    return old_mount(act) 
end

