
local function MakeFloatable (inst,build)
	inst.AnimState:SetBank('lw_floatable')
	inst.AnimState:SetBuild('lw_floatable')
	inst.AnimState:OverrideSymbol('item',build,'item')
	inst.AnimState:OverrideSymbol('swap_item',build,'swap_item')
	if MakeInventoryFloatable ~= nil then
        MakeInventoryFloatable(inst, 'idle_water', 'idle')
    end
end

local function MakeFxAt(pos, bank, build, animname, loop, fn)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	local snd = inst.entity:AddSoundEmitter()

	anim:SetBank(bank)
	anim:SetBuild(build)
	if animname then anim:PlayAnimation(animname, loop) end

	trans:SetPosition(pos:Get())

	inst:AddTag('FX')
	inst:AddTag('NOCLICK')
	inst.persists = false

	if fn then
		fn(inst)
	end

	return inst
end

local function SetPhysicsCollision(inst, groups)
	local phy = inst.Physics or inst.entity:AddPhysics()
	phy:ClearCollisionMask()
	for _,v in pairs(groups)do
		if v == 'world' then
			phy:CollidesWith(GetWorldCollision ~= nil and GetWorldCollision() or COLLISION.WORLD)
			phy:CollidesWith(GetWaterCollision ~= nil and GetWaterCollision() or COLLISION.WORLD)
			if COLLISION.INTWALL ~= nil then phy:CollidesWith(COLLISION.INTWALL) end
		elseif v == 'ground' then
			phy:CollidesWith(COLLISION.GROUND)
		elseif v:find('obs') then
			phy:CollidesWith(COLLISION.OBSTACLES)
		elseif v:find('char') then
			phy:CollidesWith(COLLISION.CHARACTERS)
		elseif v:find('wav') then
			if COLLISION.WAVES ~= nil then phy:CollidesWith(COLLISION.WAVES) end
		elseif v:find('item') then
			phy:CollidesWith(COLLISION.ITEMS)
		end
	end
end

local ent = CreateEntity()
local function IsOnWater(pos)
	return ent:GetIsOnWater(pos:Get())
end

local function IsOnGround(pos)
	return ent:GetIsOnLand(pos:Get())
end

GLOBAL.MK_MOD_UTIL = 
{
	MakeFloatable = MakeFloatable,
	MakeFxAt = MakeFxAt,
	SetPhysicsCollision = SetPhysicsCollision,
	IsOnWater = IsOnWater,
	IsOnGround = IsOnGround,
}