local peach_wine =
    {
        name = "peach_wine",
        test = function(cooker, names, tags) return tags.peach and tags.peach >= 3  and tags.frozen end,
        priority = 50,
        weight = 1,
        foodtype = "VEGGIE",
        health = 3,
        hunger = 12.5,
        perishtime = TUNING.TRUNKVEST_PERISHTIME,
        temperature = TUNING.COLD_FOOD_BONUS_TEMP,
        temperatureduration = TUNING.FOOD_TEMP_BRIEF,
        sanity = 30,
        cooktime = 3,
        tags = {"catfood"},
    }
local peach_banquet =
    {
        name = "peach_banquet",
        test = function(cooker, names, tags) return tags.peach and tags.peach == 2 and names.butterflywings and names.berries  end,
        priority = 50,
        weight = 1,
        foodtype = "VEGGIE",
        health = 40,
        hunger = 37.5,
        perishtime = TUNING.WINTERHAT_PERISHTIME,
        temperature = TUNING.COLD_FOOD_BONUS_TEMP,
        temperatureduration = TUNING.FOOD_TEMP_BRIEF,
        sanity = 10,
        cooktime = 0.5,
        tags = {"catfood"},
    }
local honey_pie =
    {
        name = "honey_pie",
        test = function(cooker, names, tags) return tags.veggie and tags.veggie == 2 and tags.sweetener and tags.sweetener == 2 and not tags.meat  end,
        priority = 50,
        weight = 1,
        foodtype = 'VEGGIE',
        health = 0,
        hunger = 37.5,
        perishtime = TUNING.AUTOSAVE_INTERVAL* 25,
        sanity = 5,
        cooktime = 0.75,
        tags = {"catfood"},
    }
    
local vegetarian_food =
    {
        name = "vegetarian_food",
        test = function(cooker, names, tags) return tags.veggie and tags.veggie >= 3.5 and not tags.meat  end,
        priority = 50,
        weight = 1,
        foodtype = 'VEGGIE',
        health = 0,
        hunger = 75,
        perishtime = TUNING.AUTOSAVE_INTERVAL* 10,
        sanity = 0,
        cooktime = 1,
        tags = {"catfood"},
    }
    
local gourd_soup =
    {
        name = "gourd_soup",
        test = function(cooker, names, tags) return tags.gourd and tags.gourd >= 2 and not tags.meat end,
        priority = 55,
        weight = 1,
        foodtype = 'VEGGIE',
        health = 20,
        hunger = 18.5,
        perishtime = TUNING.AUTOSAVE_INTERVAL* 15,
        sanity = 5,
        cooktime = 0.6,
        tags = {"catfood"},
    }

local gourd_omelet =
    {
        name = "gourd_omelet",
        test = function(cooker, names, tags) return tags.gourd and tags.gourd >= 2 and tags.egg and tags.egg >= 2 and not tags.meat end,
        priority = 60,
        weight = 1,
        foodtype = 'VEGGIE',
        health = 40,
        hunger = 37.5,
        perishtime = TUNING.AUTOSAVE_INTERVAL* 20,
        sanity = 5,
        cooktime = 0.6,
        tags = {"catfood"},
    }


AddIngredientValues({"bigpeach"},{fruit = 2, peach = 1},true)
AddIngredientValues({"peach"}, {fruit = 1 ,peach = 1},true)
AddIngredientValues({"peach_cooked"}, {fruit = 1})
AddIngredientValues({"gourd"}, {veggie = 1, gourd = 1}, true)
AddIngredientValues({"gourd_cooked"}, {veggie = 1, gourd = 1})

AddCookerRecipe("cookpot", peach_banquet)
AddCookerRecipe("cookpot", peach_wine)
AddCookerRecipe("cookpot", honey_pie)
AddCookerRecipe("cookpot", vegetarian_food)

AddCookerRecipe("cookpot", gourd_soup)
AddCookerRecipe("cookpot", gourd_omelet)

--wb
AddIngredientValues({'wb_tinymeat'}, {meat = .1}, true)
AddIngredientValues({'wb_tinymeat_cooked'}, {meat = .1})


