local Button = require "widgets/button"
local ImageButton = require "widgets/imagebutton"
local Text = require "widgets/text"
local Image = require "widgets/image"
local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local TextButton = require "widgets/textbutton"

local assets = { 
	Asset( "ATLAS", "bigportraits/monkey_king_none.xml" ),
	Asset( "ATLAS", "bigportraits/monkey_king_sea.xml" ),
	Asset( "ATLAS", "bigportraits/monkey_king_horse.xml"),

	Asset( "ATLAS", "images/skinicons/monkey_king_none.xml"),
	Asset( "ATLAS", "images/skinicons/monkey_king_sea.xml"),
	Asset( "ATLAS", "images/skinicons/monkey_king_horse.xml"),
}
for _,v in pairs(assets)do
	table.insert(Assets, v)
end

local L = L

function Lw_GetCharSkins(character)
	if character == 'monkey_king' then
		return {'monkey_king_none', 'monkey_king_sea',}
	end
end

local path = (MODROOT..modname):sub(4)
local function Save(char, skin)
	--print('save >> ', skin)
	SavePersistentString(path..'skin_choice'..char, skin, ENCODE_SAVES)
end

local function Load(char, data)
	TheSim:GetPersistentString(path..'skin_choice'..char, function(load_success, str)
		data[1] = load_success and str
		--print('load >> ', str)
	end)
end

local internal = 100

local function CharacterSelectScreenPost(self)
	local this = self

	local mainroot = self.heroportait:AddChild(Widget('lw_skinpicker')) 
	self.lw_skinpicker = mainroot
	mainroot:SetPosition(0, -300)

	local info = self.lw_skinpicker:AddChild(Text(BODYTEXTFONT, 30))
	self.lw_skinpicker.skininfo = info

	local unlock = self.lw_skinpicker.skininfo:AddChild(TextButton())
	self.lw_skinpicker.skinunlock = unlock
	--unlock:SetPosition(50, 0)
	unlock:SetFont(BODYTEXTFONT)
	unlock:Hide()
	unlock:SetOnClick(function()
		if unlock.state == 'on' then
			PushHtmlPage()
		elseif unlock.state == 'off' then
			MK_MOD_SKINS.syncdata()
		end
	end)
	unlock.adjusttoinfo = function()
		local size = info:GetRegionSize()
		unlock:SetPosition(size/2 + 50, 0)
	end
	unlock.setoffline = function()
		unlock:SetColour(0.7, 0.7, 0.7, 1)
		unlock:SetOverColour(0.9, 0.9, 0.9, 1)
		unlock:SetClickable(true)
		unlock:SetText(L and '[Offline]' or '[离线]')
		unlock.state = 'off'
	end
	unlock.setonline = function()
		unlock:SetColour(1.0, 0.5, 0.5, 1)
		unlock:SetOverColour(1, 0.8, 0.8, 1)
		unlock:SetClickable(true)
		unlock:SetText(L and '[Unlock]' or '[解锁]')
		unlock.state = 'on'
		if self.lw_skinpicked_name and MK_MOD_SKINS.hasskin(self.lw_skinpicked_name) then
			--重新刷新一次界面
			self:SelectPortrait(self.portrait_idx or 1)
		end
	end
	unlock.setlinking = function()
		unlock:SetColour(1, 1, 0, 1)
		unlock:SetClickable(false)
		unlock.state = 'ing'
	end

	-----------...
	local dots = 1
	unlock.inst:DoPeriodicTask(1, function()
		if unlock.state == 'ing' then
			dots = (dots == 3) and 1 or (dots + 1)
			unlock:SetText((' '):rep(dots)..(L and 'Linking' or '连接中') .. ('.'):rep(dots))
		end
	end)
	------------

	local function dorefresh(online)
		if online then unlock.setonline() else unlock.setoffline() end
	end
	local function dolink()
		dots = 0 unlock.setlinking()
	end
	dorefresh(MK_MOD_SKINS.getisonline())
	self.inst:ListenForEvent('skinEvent_linkdone', function(_, success) dorefresh(success) end, MK_evententity)
	self.inst:ListenForEvent('skinEvent_trylink', function() dolink() end, MK_evententity)

	local id = unlock:AddChild(Text(BODYTEXTFONT, 30))
	id:SetString('  你的id是 '..GetIDHash8())
	id:Hide()
	id:SetPosition(125, 0, 0)
	id.inst:DoPeriodicTask(0, function ()
		if unlock.state == 'on' and unlock.focus then id:Show() else id:Hide() end
	end)
	

	local free = self.lw_skinpicker.skininfo:AddChild(Text(BODYTEXTFONT, 25))
	self.lw_skinpicker.skinfree = free
	free:SetColour(0.75, 1, 0.75, 1)
	free:SetPosition(0, -30)
	free.OnUpdate = function(self)
		if not self.shown then return end
		if this.lw_skinpicked_name and MK_MOD_SKINS.hasskin(this.lw_skinpicked_name) == 'Free' then
			self:SetString(MK_MOD_SKINS.getfreetimeleft(this.lw_skinpicked_name))
		end
	end
	free.inst:DoPeriodicTask(1, function(inst, self)
		self:OnUpdate()
	end, nil, free)

	local icons = self.lw_skinpicker:AddChild(Widget('lw_skinpicker_icons'))
	self.lw_skinpicker.skinicons = icons
	
	--------------------------
	self.lw_skinpicked_name = nil
	--------------------------------------------

	local old_sel = self.SelectPortrait
	function self:SelectPortrait(portrait) --传入number
		print('call SelectPortrait -> ', portrait)
		local old_char = self.currentcharacter
		old_sel(self, portrait)
		if self.can_accept then
			local character = self.currentcharacter
			if 1 then --character ~= old_char then
				icons:KillAllChildren()
				local character_skins = Lw_GetCharSkins(character) --获得所有皮肤
				if character_skins then
					mainroot:Show()

					local data = {}
					Load(character, data)
					this.lw_skinpicked_name = data[1] or 'monkey_king_sea'

					local total = #character_skins
					for i, v in ipairs(character_skins)do
						local bt = icons:AddChild(ImageButton("images/skinicons/"..v..".xml", v..".tex", v..'.tex', v..'.tex'))
						bt:SetPosition(internal*(-total/2+i-1/2), -100)
						bt:SetScale(0.3)
						if not MK_MOD_SKINS.hasskin(v) then
							bt.image:SetTint(1,1,1,0.5)
						end
						bt:SetOnClick(function()
							this.heroportait:SetTexture("bigportraits/"..v..".xml", v..".tex")
							this.lw_skinpicked_name = v
							Save(character, v)
							info:SetString(MK_MOD_SKINS.str[v])
							if MK_MOD_SKINS.hasskin(v) == 'Free' then
								this.startbutton:Enable()
								this.can_accept = true
								free:Show()
								unlock:Show()
								unlock.adjusttoinfo()
							elseif MK_MOD_SKINS.hasskin(v) then
								this.startbutton:Enable()
								this.can_accept = true 
								free:Hide()
								unlock:Hide()
							else
								this.startbutton:Disable()
								this.can_accept = false
								free:Hide()
								unlock:Show()
								unlock.adjusttoinfo()
							end
						end)

						if this.lw_skinpicked_name == v then 
							bt.onclick()
						end
						bt.inst:ListenForEvent('mkEvent_link', function()
							if this.lw_skinpicked_name == v then bt.onclick()end
						end, MK_evententity)
					end
				else
					mainroot:Hide()
				end
			end
		end
	end

	-------------------------------------
	if self.currentcharacter == 'monkey_king' then
		self:SelectPortrait(1)
	end
end

assert(nil, '本模块已弃用')
AddClassPostConstruct('screens/characterselectscreen', CharacterSelectScreenPost)
