-- 2021.1.12 关闭网络连接和验证函数, 放开皮肤权限
local savepath = (MODROOT..modname):sub(4)
local L = MK_MOD_LANGUAGE_SETTING
local hashcollection = {}
local function GetIDHash8() local ID = TheSim:GetUserID() if type(ID) == type('') and (ID:sub(-6) == '@steam' or ID:sub(-5) == '@rail') then local atpos = string.find(ID, '@') ID = string.sub(ID, 1, atpos-1)..string.sub(ID, atpos+1, atpos+1) if hashcollection[ID] then return hashcollection[ID] end local hash = 0 local F12 = 2^32 local multer = 2^6 + 2^16 - 1 local bytes = {string.byte(ID, 0, 100)} for _, v in ipairs(bytes)do hash = v + hash * multer while hash > F12 do hash = hash - F12 end end hash = string.upper(string.sub(string.format("%#x", hash), 3)) hashcollection[ID] = hash return hash end return '0'end
env.GetIDHash8 = GetIDHash8
GLOBAL.GetIDHash8 = GetIDHash8
function GLOBAL.id8() print('\228\189\160\231\154\132\73\68\230\152\175: '..GetIDHash8()) return GetIDHash8() end

local Button = require "widgets/button"
local ImageButton = require "widgets/imagebutton"
local Text = require "widgets/text"
local Image = require "widgets/image"
local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local TextButton = require "widgets/textbutton"
local L = L

function Lw_GetCharSkins(character)
	if character == 'monkey_king' then
		return {'monkey_king_none', 'monkey_king_sea', "monkey_king_horse"}
	end
end

for _,v in ipairs(Lw_GetCharSkins('monkey_king'))do
	if v ~= "monkey_king_none" then
		table.insert(Assets, Asset("ANIM", "anim/"..v..".zip"))
	end
	table.insert(Assets, Asset("ATLAS", "images/skinicons/"..v..".xml"))
	table.insert(Assets, Asset("ATLAS", "bigportraits/"..v..".xml"))
end

local path = (MODROOT..modname):sub(4)
local function Save(char, skin)
	print('mythsave -> ', skin)
	SavePersistentString(path..'skin_choice'..char, skin, ENCODE_SAVES)
end

local function Load(char, data)
	TheSim:GetPersistentString(path..'skin_choice'..char, function(load_success, str)
		data[1] = load_success and str
		print('mythload -> ', str)
	end)
end

AddClassPostConstruct('screens/characterselectscreen', function(self)
	local this = self

	local mainroot = self.heroportait:AddChild(Widget('lw_skinpicker')) 
	self.lw_skinpicker = mainroot
	mainroot:SetPosition(0, -300)

	local info = self.lw_skinpicker:AddChild(Text(BODYTEXTFONT, 30))
	self.lw_skinpicker.skininfo = info

	local icons = self.lw_skinpicker:AddChild(Widget('lw_skinpicker_icons'))
	self.lw_skinpicker.skinicons = icons
	
	--------------------------
	self.lw_skinpicked_name = nil
	--------------------------------------------

	local old_sel = self.SelectPortrait
	function self:SelectPortrait(portrait) --传入number
		local old_char = self.currentcharacter
		old_sel(self, portrait)
		local character = self.currentcharacter
		if 1 then --character ~= old_char then
			icons:KillAllChildren()
			local character_skins = Lw_GetCharSkins(character) --获得所有皮肤
			if character_skins then
				mainroot:Show()

				local data = {}
				Load(character, data)
				this.lw_skinpicked_name = data[1] or 'monkey_king_none'

				local total = #character_skins
				for i, v in ipairs(character_skins)do
					local bt = icons:AddChild(ImageButton("images/skinicons/"..v..".xml", v..".tex", v..'.tex', v..'.tex'))
					bt:SetPosition(100*(-total/2+i-1/2), -80)
					bt:SetScale(0.3)
					bt:SetOnClick(function()
						this.heroportait:SetTexture("bigportraits/"..v..".xml", v..".tex")
						this.lw_skinpicked_name = v
						Save(character, v)
						info:SetString(MK_MOD_SKINS.str[v])
						if this.startbutton then
							this.startbutton:Enable()
						end
						this.can_accept = true 
					end)

					if this.lw_skinpicked_name == v then 
						bt.onclick()
					end
				end
			else
				mainroot:Hide()
			end
		end
	end

	-------------------------------------
	if self.currentcharacter == 'monkey_king' then
		self:SelectPortrait(1)
	end

	self.inst:ListenForEvent('skinEvent_linkdone', function(_, link)
		if link then 
			self:SelectPortrait(self.portrait_idx or 1)
		end
	end, MK_evententity)
end)

local skinUI = (require'widgets/widget')('')
skinUI.Make = function(self)
	self:SetHAnchor(ANCHOR_MIDDLE)
    self:SetVAnchor(ANCHOR_MIDDLE)
    self:SetPosition(0, -100)
	local player = GetPlayer().prefab
	local character_skins = Lw_GetCharSkins(player)
	if character_skins then
		for i, v in ipairs(character_skins)do
			local bt = self:AddChild((require'widgets/imagebutton')(
				"images/skinicons/"..v..".xml",
			 	v..".tex", v..'.tex', v..'.tex'))
			local offset = 80*(-#character_skins/2+i-1/2)
			local tooltip = MK_MOD_SKINS.str[v]

			bt:SetScale(0.3)
			bt:SetPosition(offset, 0)
			bt:SetTooltip(tooltip)

			bt:SetOnClick(function()
				MK_MOD_SKINS.setskin(GetPlayer(), v)
				SpawnPrefab('collapse_small').Transform:SetPosition(GetPlayer():GetPosition():Get())
			end)
		end
	end
end

AddClassPostConstruct('widgets/controls', function(self)
	self.lw_skinchanger = self.containerroot:AddChild(skinUI)
	self.lw_skinchanger:Make()
	self.lw_skinchanger:Hide()
end)