-- 2021.1.12 关闭网络连接和验证函数, 放开皮肤权限

local savepath = (MODROOT..modname):sub(4)
local L = MK_MOD_LANGUAGE_SETTING

local allskins = json.decode(io.open(MODROOT..'skindata.json'):read('*all')) --皮肤相关信息

local getskininfo = function(key, value)
	if key and value then
		for _, v in pairs(allskins)do
			if v[key] == value then return v end
		end
	end
	return {}
end

local syncdata = function() return true end

local isskin = function (skin)
	return table.contains({'monkey_king_sea', 'monkey_king_horse'}, skin)
end

local isanimbuild = function(inst, build)
	local str = inst.entity:GetDebugString()
	if str:find(' build: '..build..' ') then return true end
end

local getanimbuild = function(inst)
    local str = inst.entity:GetDebugString()
    local i1 = str:find('AnimState: ')
    local str_AnimState = str:sub(i1)
    local i3 = str_AnimState:find(' build: ')
    local i4 = str_AnimState:find(' anim: ')
    local build = str_AnimState:sub(i3+8,i4-1)
    return build
end

local setskin = function(player, skin)
	if player and player:IsValid() then
		local info = getskininfo('skin', skin) or {}
		local build = info.build
		local prefab = info.prefab
		if build and player.prefab == prefab then
			player.AnimState:SetBuild(build)
			player:PushEvent('mythskin_change', skin)
			local slot = SaveGameIndex:GetCurrentSaveSlot()
			print('save >> ', SavePersistentString(savepath..'skin/slot'..slot, skin, ENCODE_SAVES))
		end
    end
end

MK_MOD_SKINS = {
	syncdata = function(...) return syncdata(...)end,
	getskininfo = function(...) return getskininfo(...)end,
	isanimbuild = function(...) return isanimbuild(...) end,
	setskin = function(...) return setskin(...) end,
	getplayerskin = function() return '' end,

	str = {
		monkey_king_none = L and 'Classic' or '孙悟空',
		monkey_king_sea  = L and 'Seafarer' or '出海学艺',
		monkey_king_horse = L and "Horse keeper" or '弼马温',
	},
}
GLOBAL.MK_MOD_SKINS = MK_MOD_SKINS

local skinmanager = Class(function(self, player)
	local skin = ''

	function self:Save()
		local slot = SaveGameIndex:GetCurrentSaveSlot()
    	print('save >> ', SavePersistentString(savepath..'skin/slot'..slot, skin, ENCODE_SAVES))
	end

	function self:Load()
		local slot = SaveGameIndex:GetCurrentSaveSlot()
		TheSim:GetPersistentString(savepath..'skin/slot'..slot, function(load_success, str)
			if load_success == true then skin = str end
		end)
	end

	function self:Init(playerprefab)
		self:Load()
		print('skin of this slot -> ', skin)
		if skin and skin:len() > 1 then
			local info = getskininfo('skin', skin) or {}
			local prefab, build = info.prefab, info.build
			if prefab == playerprefab and build then
				player.AnimState:SetBuild(build)
				player:DoTaskInTime(0, function()
					player:PushEvent('mythskin_change', skin)
				end)
			end
		else
			self:FromUI(playerprefab)
		end
	end

	function self:FromUI(playerprefab)
		TheSim:GetPersistentString(savepath..'skin_choice'..playerprefab, function(suc, str)
			if suc and str then
				skin = str
				self:Save()
				self:Init(playerprefab)
			end
		end)
	end

	MK_MOD_SKINS.getplayerskin = function() return skin end
end)

--清除存档记录
AddGlobalClassPostConstruct('saveindex', 'SaveIndex', function(self)
	local old = self.OnGenerateNewWorld
	function self:OnGenerateNewWorld(saveslot, ...)
		if saveslot then
			TheSim:ErasePersistentString(savepath..'skin/slot'..saveslot)
		end
		old(self, saveslot, ...)
	end
end)

function MK_MOD_SKINS.handler(inst, prefab)
	skinmanager(inst):Init(prefab)
end
