
local L = MK_MOD_LANGUAGE_SETTING
local showid = GetModConfigData('id')
local function Addwatermark(self)
    local Text = require ("widgets/text")
    local watermark = self.status:AddChild(Text(UIFONT, 25))
    watermark:SetPosition(0,-70)
    watermark:SetHAnchor(ANCHOR_MIDDLE)
    watermark:SetVAnchor(ANCHOR_TOP)
    if GetPlayer().prefab == "monkey_king" or GetPlayer().prefab == 'neza' or GetPlayer().prefab == 'white_bone' then
        if not IsDLCEnabled(PORKLAND_DLC) then
            if IsDLCEnabled(CAPY_DLC) then
                watermark:SetString(L and 
                    '[myth words]\nWarning: This save is not compatible with Hamlet DLC,\nwhich may cause some logical errors.' or 
                    '[神话书说]\n警告: 本存档未兼容哈姆雷特DLC,\n可能会引起部分数据错误.'
                )
            else
                watermark:SetString(L and 
                    '[myth words]\nFetal Error: This save is not compatible with Hamlet DLC or Shipwrecked DLC,\nwhich may cause game crash! It is suggested to new a world.' or 
                    '[神话书说]\n严重警告: 本存档未兼容海难DLC或哈姆雷特DLC,\n可能会引起数据错误或游戏崩溃! 建议重开地图.'
                )
            end
        end
    end
end
AddClassPostConstruct("widgets/controls",Addwatermark)


local function rechargeable(self)
    local UIAnim = require "widgets/uianim"
    if self.item:HasTag("rechargeable") then
        self.rechargeframe = self:AddChild(UIAnim())
        self.rechargeframe:GetAnimState():SetBank("recharge_meter")
        self.rechargeframe:GetAnimState():SetBuild("recharge_meter_myth")
        self.rechargeframe:GetAnimState():PlayAnimation("frame")
        self.rechargeframe:Hide()
    end
    if self.rechargeframe ~= nil then
        self.recharge = self:AddChild(UIAnim())
        self.recharge:GetAnimState():SetBank("recharge_meter")
        self.recharge:GetAnimState():SetBuild("recharge_meter_myth")
        self.recharge:SetClickable(false)
    end
    if  self.rechargeframe ~= nil then
        self.inst:ListenForEvent("rechargechange",function(invitem, data)
        self:SetChargePercent(data.percent)
        end, self.item)
    end
    function self:SetChargePercent(percent)
        if percent < 1 then
            self.recharge:GetAnimState():SetPercent("recharge", percent)
            if self.item and not self.item == self.item.components.inventoryitem:GetGrandOwner().components.inventory.activeitem then
                self.rechargeframe:Show()
            end
        else
            if not self.recharge:GetAnimState():IsCurrentAnimation("frame_pst") then
                self.recharge:GetAnimState():PlayAnimation("frame_pst")
            end
            if self.rechargeframe.shown then
                self.rechargeframe:Hide()
            end
        end
    end 

    local old_startdrag = self.StartDrag
    function self:StartDrag(...)
        old_startdrag(self,...)
        if self.recharge then
            self.recharge:Hide()
        end
        if self.rechargeframe then
            self.rechargeframe:Hide()
        end
     end
end
AddClassPostConstruct( "widgets/itemtile", rechargeable)

local function fog(self)
    local old_update = self.OnUpdate
    function self:OnUpdate(dt)
        old_update(self,dt)
        if self.owner and self.owner.fireeye then
            self:Hide()
        end
    end
end
AddClassPostConstruct( "widgets/fogover", fog)

local function container(self)
    local old_open = self.Open
    function self:Open(container, doer, boatwidget,...)
        old_open(self,container, doer, boatwidget,...)
        if container and container.components.container.type == "boat" then
            if container.prefab == 'mk_cloud' then
                self.inst:ListenForEvent("cloudhealthchange", function(boat, data) self:BoatDelta(boat, data) end, container)
                self.boatbadge:SetPercent(container.components.fueled:GetPercent(), container.components.fueled.maxfuel)
                self.boatbadge.anim:GetAnimState():SetBuild('cloud_health')
            elseif container.prefab == 'nz_wheel' then
                self.inst:ListenForEvent("cloudhealthchange", function(boat, data) self:BoatDelta(boat, data) end, container)
                self.boatbadge:SetPercent(container.components.fueled:GetPercent(), container.components.fueled.maxfuel)
                self.boatbadge.anim:GetAnimState():SetBuild('wheel_health')
            end
        else
            if self.boatbadge then
                self.boatbadge.anim:GetAnimState():SetBuild('boat_health')
                self.boatbadge.anim:GetAnimState():SetBank('boat_health')
            end
        end
        --self.boatbadge:MoveToFront()
    end
end
AddClassPostConstruct( "widgets/containerwidget", container)

local function Hunger(self)
    local UIAnim = require "widgets/uianim"
    self.fireeye_warning = self.underNumber:AddChild(UIAnim())
    self.fireeye_warning:GetAnimState():SetBank("sanity_arrow")
    self.fireeye_warning:GetAnimState():SetBuild("sanity_arrow")
    self.fireeye_warning:GetAnimState():PlayAnimation("neutral")
    self.fireeye_warning:SetClickable(false)

    function self:OnUpdate(dt)
        local down = self.owner and self.owner.fireeye and not self.owner:HasTag('fireeye_boost_mk')
        if down then
            if self.fireeye_warning.enabled then
                return
            else
                self.fireeye_warning.enabled = true
                self.fireeye_warning:GetAnimState():PlayAnimation('arrow_loop_decrease_most',true)
            end
        else
            self.fireeye_warning.enabled = false
            self.fireeye_warning:GetAnimState():PlayAnimation('neutral')
        end
    end
    self:StartUpdating()
end

AddClassPostConstruct('widgets/hungerbadge', Hunger)

local function getbuffdesc(name)
    return STRINGS.NAMES[name:upper()] ..' Buff'
end
local Widget = require'widgets/widget'
local Image = require 'widgets/image'
local BuffIcons = Class(Widget, function(self, owner)
    Widget._ctor(self, "BuffIcons")
    self.owner = owner
    self:SetHAnchor(ANCHOR_LEFT)
    self:SetVAnchor(ANCHOR_TOP)

    local root = self:AddChild(Widget('_root'))
    root:SetPosition(100, -100)

    local intervel = 70
    local scale = 1

    for i,v in ipairs({'bloodthirsty_pill','condensed_pill','armor_pill','fly_pill','detoxic_pill'})do
        self[v] = root:AddChild(Image('images/monkey_king_item.xml', v..'.tex'))
        self[v]:SetScale(scale)
        self[v]:Hide()
    end

    do
        self.yamarajabuff = root:AddChild(Image('images/yamaraja_icon.xml', 'yamaraja_icon.tex'))
        self.yamarajabuff:SetScale(scale)
        self.yamarajabuff:Hide()
        self.yamarajabuff:SetTooltip('免疫一次致命伤害')
    end

    self.inst:DoPeriodicTask(3/30, function()
        local infos = owner.components.mk_timerbuff_manager:GetAllBuffInfos()
        local hasyamaraja = owner.components.yamarajabuff.hasbuff
        for k in pairs(root.children)do k:Hide() end

        local offset = 0
        for i, v in ipairs(infos)do
            local name = v.name
            local time = v.time
            self[name]:Show()
            self[name]:SetPosition(offset*intervel, 0)
            self[name]:SetTooltip(getbuffdesc(name)..(time > 0 and string.format(' (%d)',time) or ''))
            offset = offset + 1
        end
        if hasyamaraja then
            self.yamarajabuff:Show()
            self.yamarajabuff:SetPosition(offset*intervel, 0)
        end
    end)
end)

local function AddBuffIcon(self)
    self:AddChild(BuffIcons(self.owner))
end
AddClassPostConstruct('widgets/controls', AddBuffIcon)

local ui1 = require 'widgets/white_bone_ui'
local ui2 = require 'widgets/monkey_king_ui'
local function AddWBbutton(self) --白骨的伪装按钮
    local show = GetModConfigData('BT')
    if self.owner and self.owner.prefab == 'white_bone' then
        self.wb_button = self:AddChild(ui1(self.owner))
        self.wb_button:SetPosition(-120, 20, 0)
        if not show then
            self.wb_button:Hide()
        end
    end
    if self.owner and self.owner.prefab == 'monkey_king' then
        self.mk_button = self:AddChild(ui2(self.owner))
        self.mk_button:SetPosition(-120, 20, 0)
        if not show then
            self.mk_button:Hide()
        end
    end
end
AddClassPostConstruct('widgets/statusdisplays', AddWBbutton)


-- 一些DST的函数
local function SetForceProcessTextInput(takeText, widget)
    local self = TheFrontEnd

    if takeText and widget then
        if self.textProcessorWidget then
            local ui = self.textProcessorWidget
            if ui.editing then
                ui:SetEditing(false)
                if ui.OnStopForceEdit then
                    ui:OnStopForceEdit()
                end
            end
        end
        self.textProcessorWidget = widget
        self.forceProcessText = true
    elseif widget == nil or widget == self.textProcessorWidget then
        if self.textProcessorWidget then
            local ui = self.textProcessorWidget
            if ui.editing then
                ui:SetEditing(false)
                if ui.OnStopForceEdit then
                    ui:OnStopForceEdit()
                end
            end
        end
        self.textProcessorWidget = nil
        self.forceProcessText = false
    end
end

AddClassPostConstruct('widgets/textedit', function(self)
    local old_editing = self.SetEditing
    function self:SetEditing(editing)
        if editing and not self.editing and self.force_edit then
            self.editing = true
            SetForceProcessTextInput(true, self)
            self.editing = false
        end
        if not editing and self.editing and self.force_edit then
            self.editing = false
            SetForceProcessTextInput(false, self)
            self.editing = true
        end
        old_editing(self, editing)
    end
end)

AddGlobalClassPostConstruct('frontend', 'FrontEnd', function(self)
    local old_key = self.OnRawKey
    function self:OnRawKey(key, down, ...)
        if self.forceProcessText and self.textProcessorWidget then
            return self.textProcessorWidget:OnRawKey(key, down, ...)
        end
        return old_key(self, key, down, ...)
    end

    local old_input = self.OnTextInput
    function self:OnTextInput(text, ...)
        if self.forceProcessText and self.textProcessorWidget then
            return self.textProcessorWidget:OnTextInput(text, ...)
        end
        return old_input(self, text, ...)
    end
end)

