local L = MK_MOD_LANGUAGE_SETTING

local bones = {
	boneshard = 10,
	houndstooth = 20,
	spoiled_fish = 20,
	snake_bone = 20,
    walrus_tusk = 75,
	skeleton = 75,
    --houndbone = 50, --犬遗骸
    --houndmound = 0,
}

for k,v in pairs(bones)do
	AddPrefabPostInit(k, function(inst)
		inst:AddComponent('wb_bone')
		inst.components.wb_bone:SetValue(v)
		inst:AddComponent('wb_bonehealer')
		inst.components.wb_bonehealer:SetValue(v)
	end)
end

AddPrefabPostInit('goatmilk', function(inst)
	local old_eaten = inst.components.edible.oneaten
	inst.components.edible.oneaten = function(inst, eater)
		if eater and eater.prefab == 'white_bone' then
			eater:DoFix(30)
		end
        if old_eaten then
            old_eaten(inst, eater)
        end
	end
end)

AddPrefabPostInit('nightmarefuel', function(inst)
    if GetPlayer() and GetPlayer().prefab == 'white_bone' then
        inst:AddComponent("edible")
        inst.components.edible.foodtype = "WB_NIGHTMAREFUEL"
        inst.components.edible.healthvalue = 0
        inst.components.edible.hungervalue = 25
        inst.components.edible.sanityvalue = 0
    end
end)

--临时性修复, 还需要后续优化...
AddPrefabPostInitAny(function(inst)
    if inst.components.equippable and not inst.components.trader then
        inst:AddComponent('tradable')
    end
end
)
--白骨精boss
--AddPrefabPostInit('porkland', function(inst) inst:AddComponent('wb_spawner') end)

AddPrefabPostInitAny(function(inst)
    local world = GetWorld()
    if not (world and world.components.wb_spawner) then return end
    --噩梦光环
    if inst.components.sanityaura then
        local old = inst.components.sanityaura.aurafn
        if old == nil then
            old = function() return inst.components.sanityaura.aura end
        end
        inst.components.sanityaura.aurafn = function(...)
            if inst:HasTag('wb_pig')then return -25/60 else return old(...) end
        end
    end

    if inst:HasTag('pig') and inst:HasTag('city_pig') and inst.female == true then
        world.components.wb_spawner:AddPig(inst)
    end
end)

--禁用复活
AddPrefabPostInit('white_bone', function(inst)
    if inst.components.resurrectable then
        inst.components.resurrectable.CanResurrect = function() return false end
    end
end)
--复活道具相关提示
local AVOID_RES = MK_MOD_LANGUAGE_SETTING and 'I was dead thousands of years ago' or '老娘几千年前就已经死透了'
local say_hint = function() 
    GetPlayer().components.talker:StopIgnoringAll()
    GetPlayer().components.talker:Say(AVOID_RES,4) 
end

AddPrefabPostInit("resurrectionstatue", function(inst)
    if GetPlayer().prefab == 'white_bone' then
        inst.components.resurrector.penalty = 0 
        inst:ListenForEvent( "onbuilt", function () inst:DoTaskInTime(.5, say_hint) end)
    end
end)

AddPrefabPostInit("resurrectionstone", function(inst)
    local old_fn = inst.components.activatable.OnActivate 
    inst.components.activatable.OnActivate  = function(inst)
        old_fn(inst)
        if GetPlayer().prefab == 'white_bone' then
            say_hint()  
        end
    end
end)

AddPrefabPostInit("lifeplant", function(inst)
    if GetPlayer().prefab == 'white_bone' then
        inst.components.resurrector.penalty = 0
    end
end)

AddPrefabPostInit("waterdrop", function(inst)
    local old_fn = inst.components.deployable.ondeploy
    inst.components.deployable.ondeploy = function(inst, ...)
        old_fn(inst, ...)
        if GetPlayer().prefab == 'white_bone' then
            say_hint()
        end
    end
end)

--灵魂状态切换的sg
local event = EventHandler('wbEvent_changetoghost', function(inst, data)
    if inst.sg:HasStateTag('wb_2ghost') then return end
    inst.components.playercontroller:Enable(false)
    inst:ClearBufferedAction()
    if inst.components.rider:IsRiding()then
        inst.sg:GoToState("wb_2ghost_mounted")
    elseif data.cause == "drowning" then
        inst.sg:GoToState("wb_2ghost_boat")
        inst.SoundEmitter:PlaySound("dontstarve_DLC002/characters/sinking_death")
    else
        inst.sg:GoToState("wb_2ghost")
        inst.SoundEmitter:PlaySound("WhiteBone/sfx/death_voice")
    end
end)
--AddStategraphEvent('wilson', event)
AddStategraphPostInit('wilson', function(sg) 
    sg.events['wbEvent_changetoghost'] = event 
end)
--AddStategraphEvent('wilsonboating', event)
AddStategraphPostInit('wilsonboating', function(sg) 
    sg.events['wbEvent_changetoghost'] = event 
end)


--灵魂出壳
local event = EventHandler('wbEvent_eatheart', function(inst, data)
    if inst.sg:HasStateTag('wb_2ghost') then return end
    inst.components.playercontroller:Enable(false)
    inst:ClearBufferedAction()
    if inst.components.rider:IsRiding() then
        inst.sg:GoToState('wb_2ghost_mounted', 'nodrop')
    else
        inst.sg:GoToState('wb_2ghost', 'nodrop')
        inst.SoundEmitter:PlaySound('WhiteBone/sfx/death_voice')
    end
end)

--AddStategraphEvent('wilson', event)
AddStategraphPostInit('wilson', function(sg) 
    sg.events['wbEvent_eatheart'] = event 
end)
--AddStategraphEvent('wilsonboating', event)
AddStategraphPostInit('wilsonboating', function(sg) 
    sg.events['wbEvent_eatheart'] = event 
end)

local event = EventHandler('wbEvent_changetobeauty', function(inst, data)
    if not inst.components.health:IsDead() and not inst.sg:HasStateTag('wb_2ghost')
        and not inst._isghost and not inst.sg:HasStateTag('wb_2beauty')
        and not inst.sg:HasStateTag("busy")
        and not (inst.components.playercontroller and not inst.components.playercontroller:IsEnabled()) then

        inst.sg:GoToState('wb_2beauty')
    end
end)

AddStategraphPostInit('wilson', function(sg)
    sg.events['wbEvent_changetobeauty'] = event
end)
AddStategraphPostInit('wilsonboating', function(sg)
    sg.events['wbEvent_changetobeauty'] = event
end)
AddStategraphEvent('wilson', event)
AddStategraphEvent('wilsonboating', event)


local newstates = {
    State{
        name = "wb_2ghost", --陆地 死亡
        tags = {"busy", 'wb_2ghost', 'mythSGtag_locked'},
        
        onenter = function(inst, p)
            if p == 'nodrop' then
                inst.sg.statemem.nodrop = true
                inst.sg:AddStateTag('wb_2ghost_heart')
            end
            inst.components.locomotor:Stop()
            inst.last_death_position = inst:GetPosition()
            inst.AnimState:Hide("swap_arm_carry")
            inst.AnimState:PlayAnimation("death")
            if p == 'nodrop' then
                inst.components.inventory:DropActiveItem()
                for _, item in pairs(inst.components.inventory.equipslots)do
                    if item.prefab == 'wb_bonelock' then
                        item.components.equippable.myth_unequipable = nil
                        item:Remove()
                    else
                        inst.components.inventory:DropItem(item, true, true)
                    end
                end
            else
                inst.components.inventory:DropEverything(true)
            end
        end,

        events = {
            EventHandler('animover', function(inst)
                --播放特效?
                local nodrop = inst.sg.statemem.nodrop
                if nodrop then
                    inst:SpawnMyBody()
                else
                    inst:SpawnBoneOnDeath() --生成骨片
                end
                inst:ChangeToGhost()    --切换为鬼魂状态
                inst.components.sanity:DoDelta(50, true)
                inst.sg:RemoveStateTag('mythSGtag_locked')
                inst.sg:GoToState('haunt', nodrop and 'heart' or 'death') 
            end),
        },
    },

    State{
        name = "wb_2ghost_boat", --溺水
        tags = {"busy", 'wb_2ghost', 'mythSGtag_locked'},

        onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.Physics:Stop()
            inst.last_death_position = inst:GetPosition()
            inst.AnimState:Hide("swap_arm_carry")
            inst.AnimState:PlayAnimation("boat_death")

            local death_fx = SpawnPrefab("boat_death")
            death_fx.Transform:SetPosition(inst:GetPosition():Get())

            local sound_name = inst.soundsname or inst.prefab
            local path =  "dontstarve_DLC002/characters/vanilla/"
            inst.SoundEmitter:PlaySound(path..sound_name.."_drown_voice")
        end,

        onexit= function(inst) 
            inst.DynamicShadow:Enable(true) 
        end,

        timeline=
        {
            TimeEvent(50*FRAMES, function(inst)
                inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/boat_sinking_shadow")
            end),
            TimeEvent(70*FRAMES, function(inst)
                inst.DynamicShadow:Enable(false)
            end),
            TimeEvent(90*FRAMES, function(inst)
                inst:ChangeToGhost()
                inst.sg:RemoveStateTag('mythSGtag_locked')
                inst.sg:GoToState('haunt', true)
            end),
        },
    },

    State{
        name = "wb_2ghost_mounted", --骑行 死亡
        tags = {"busy", 'wb_2ghost', 'mythSGtag_locked',},
        onenter = function(inst, p)
            inst.sg.statemem.arg = p
            inst.AnimState:PlayAnimation("fall_off")
            --死亡音效
            local path = inst.talker_path_override
            inst.SoundEmitter:PlaySound(path.."sfx/death_voice")          
            inst.SoundEmitter:PlaySound("dontstarve/beefalo/saddle/dismount")            
        end,

        events =
        {
            EventHandler("animover", function(inst)
                inst.components.rider:ActualDismount()
                inst.sg:RemoveStateTag('mythSGtag_locked')
                inst.sg:GoToState("wb_2ghost", inst.sg.statemem.arg)
            end),
        } ,
    },  

    State{
        name = 'wb_getup',  --复活 人物部分
        tags = {'busy'},
        onenter = function(inst)
            inst.AnimState:PlayAnimation('corpse_revive')
        end,
        events = {
            EventHandler('animover', function(inst) inst.sg:GoToState('idle') end),
        },
        onexit = function(inst)
            inst.components.playercontroller:Enable(true)
            TheCamera:SetDefault()
        end,
    },

    State{
        name = 'wb_2beauty', --扭一扭, 变美人
        tags = {'notalking', 'wb_2beauty',},
        onenter = function(inst)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("emote_strikepose")
        end,
        timeline = {
            TimeEvent(35*FRAMES, function(inst)
                MK_MOD_UTIL.MakeFxAt(inst:GetPosition(), 
                    'statue_ruins_fx', 'white_bone_changefx', 'transform_nightmare')
                inst:ChangeToBeauty()
            end),
        },
        events = {
            EventHandler('animover', function(inst)
                inst.sg:GoToState('idle')
            end),
        },
    },

    State{
        name = "wb_fog", --拍拍手, 铺个烟
        tags = { "wb_fog", 'notalking',},
        
        onenter = function(inst, data)
            inst.components.locomotor:Stop()
            inst.AnimState:PlayAnimation("emote_slowclap", false)
        end,        
        timeline ={
            TimeEvent(1.8, function(inst)
                inst:PerformBufferedAction()
            end),
        },
        events = {
            EventHandler("animover", function(inst) inst.sg:GoToState("idle") end),
        },
    },
}

for _, state in ipairs(newstates)do
    AddStategraphState('wilson', state)
    AddStategraphState('wilsonboating', state)
end

--强制锁定型sg
AddGlobalClassPostConstruct('stategraph', 'StateGraphInstance', function(self)
    local old_go = self.GoToState
    function self:GoToState(name, ...)
        if self:HasStateTag('mythSGtag_locked') then return end
        old_go(self, name, ...)
    end
end)

--关于仇恨的一些api
AddComponentPostInit('combat', function(self)
    self.inst:ListenForEvent('wbEvent_changetoghost', function()
        if self.target == GetPlayer() and self.inst ~= GetPlayer() then
            self:GiveUp()
        end
    end, GetPlayer())

    local old_fn = self.IsValidTarget
    function self:IsValidTarget(target, ...)
        if target and target.prefab == 'white_bone' then 
            if target.sg:HasStateTag('wb_2ghost') or target._isghost then
                return false
            end
        end
        return old_fn(self, target, ...)
    end

    local old_share = self.ShareTarget
    function self:ShareTarget(target, ...)
        if target and target:HasTag('wb_fog') then
            return
        end
        old_share(self, target, ...)
    end

    local old_set = self.SetTarget
    function self:SetTarget(target, ...)
        if target and target:HasTag('wb_fog') and GetTime() - (self.myth_last_atk_by_player or 0) > 5 then
            return 
        end
        old_set(self, target, ...)
    end
    if self.inst then
        self.inst:ListenForEvent('attacked', function(_, data)
            if data and data.attacker == GetPlayer() then
                self.myth_last_atk_by_player = GetTime()
            end
        end)
    end
end)

AddComponentPostInit('keeponland', function(self)
    local old_fn = self.OnUpdate
    function self:OnUpdate(dt, ...)
        if self.inst and self.inst.prefab == 'white_bone' and self.inst._isghost then
            return
        else
            return old_fn(self, dt, ...)
        end
    end
end)

AddComponentPostInit('moisture', function(self)
    local old_fn = self.OnUpdate
    function self:OnUpdate(dt, ...)
        if self.inst and self.inst.prefab == 'white_bone' and self.inst._isghost then
            self.delta = 0
            self.moisture = self.moistureclamp.min
            return
        else
            return old_fn(self, dt, ...)
        end
    end
end)

--无法卸下的物品
--参考官方dlc0003薇尔芭源码
AddComponentPostInit('inventory', function(self)
    local old_equip = self.Equip 
    function self:Equip(item, ...)
        if not (item and item:IsValid() and item.components.equippable) then
            return 
        end

        local eslot = item.components.equippable.equipslot
        local olditem = eslot and self:GetEquippedItem(eslot)
        if olditem and olditem.components.equippable.myth_unequipable then
            self.inst:PushEvent("mythEvent_cantequip", {item=item, eslot=eslot,olditem=olditem })
            return
        end

        return old_equip(self,item,...)
    end

    local old_dropitem = self.DropItem
    function self:DropItem(item,...)
        if item and item:IsValid() 
            and item.components.equippable and item.components.equippable.myth_unequipable then
            return 
        end

        return old_dropitem(self,item,...)
    end

end)

AddClassPostConstruct('widgets/invslot', function(self)
    local old_fn = self.Click
    function self:Click(...)
        local container = self.container
        local container_item = container and container:GetItemInSlot(self.num)
        if container_item and container_item.components.equippable and container_item.components.equippable.myth_unequipable then
            return
        end    
        return old_fn(self, ...)
    end
end)

--制造栏
AddPrefabPostInit('white_bone', function(inst)
    local Ig = Ingredient --偷懒一下
    local WB_TAB={str='WB_TAB',sort=100,icon="white_bone_tab.tex",icon_atlas="images/hud/white_bone_tab.xml"}
    STRINGS.TABS.WB_TAB=MK_MOD_LANGUAGE_SETTING and 'bone'or '骨头'

    inst.components.builder:AddRecipeTab(WB_TAB)

    if IsDLCEnabled(PORKLAND_DLC) and false then
        local boneshard = Recipe('wb_honeshard', {Ig(CHARACTER_INGREDIENT.HEALTH, 20)}, WB_TAB, TECH.NONE)
        boneshard.atlas = GetInventoryItemAtlas('boneshard.tex')
        boneshard.image = 'boneshard.tex'
        boneshard.product = 'boneshard'
        STRINGS.NAMES.WB_HONESHARD = STRINGS.NAMES.BONESHARD
        STRINGS.RECIPE_DESC.WB_HONESHARD = MK_MOD_LANGUAGE_SETTING and 'Bone shard' or '富含磷和钙'
    end

    local skeleton = Recipe('wb_predecessor', {Ig('boneshard', 4)}, WB_TAB, TECH.NONE)
    skeleton.atlas = 'images/monkey_king_item.xml'
    skeleton.product = 'skeleton'
    skeleton.placer = 'wb_predecessor_placer'
    skeleton.min_spacing = 2

    --local knife = Recipe('wb_knife', {Ig('boneshard', 2), Ig('bluegem', 1)}, WB_TAB, TECH.NONE)
    --knife.atlas = 'images/monkey_king_item.xml'

    local blade = Recipe('wb_blade', {Ig("boneshard", 4),Ig("livinglog", 1),Ig("nightmarefuel", 1)}, WB_TAB, TECH.NONE)
    blade.atlas = 'images/monkey_king_item.xml'

    local whip = Recipe('wb_whip', {Ig("boneshard", 4),Ig("livinglog", 1),Ig("nightmarefuel", 2)}, WB_TAB, TECH.NONE)
    whip.atlas = 'images/monkey_king_item.xml'

    local staff = Recipe('wb_staff', {Ig("boneshard", 4),Ig("livinglog", 2),Ig("purplegem", 2)}, WB_TAB, TECH.NONE)
    staff.atlas = 'images/monkey_king_item.xml'

    if IsDLCEnabled(PORKLAND_DLC) then
        local heart = Recipe('wb_heart', {Ig("boneshard", 2),Ig("spidergland", 2),Ig(CHARACTER_INGREDIENT.HEALTH, 20)}, WB_TAB, TECH.NONE)
        heart.atlas = 'images/monkey_king_item.xml'
    end
    
end)


--关于复活骷髅
AddPrefabPostInit('skeleton', function(inst)
    inst.wb_revive = function(inst, doer)
        inst:RemoveComponent('workable')
        inst:AddTag("NOCLICK")
        --MK_MOD_UTIL.MakeFxAt(inst:GetPosition(), '')
        SpawnPrefab('small_puff').Transform:SetPosition(inst:GetPosition():Get())
        local pet = SpawnPrefab('wb_skeleton')
        pet.Transform:SetPosition(inst:GetPosition():Get())
        if doer and doer.components.leader then
            print(11111)
            doer.components.leader:AddFollower(pet)
            pet.components.follower:AddLoyaltyTime(480)
            pet.components.follower:SetLeader(GetPlayer())
            --
            SetDebugEntity(pet)
        end
    end
end)

AddPrefabPostInit('nightmarefuel', function(inst)
    inst.components['空组件'] = {
        inst = inst,
        CollectUseActions = function(self, doer, target, actions, right)
            if target.prefab == 'skeleton' and not target:HasTag('NOCLICK') then 
                table.insert(actions, ACTIONS.WB_REVIVE_SKELETON)
            end
        end,
    }
end)

local REVIVE = Action({})
REVIVE.id = 'WB_REVIVE_SKELETON'
REVIVE.str = MK_MOD_LANGUAGE_SETTING and 'Revive' or '复活'
REVIVE.fn = function(act)
    act.target:wb_revive(act.doer)
    act.target:RemoveFromScene()--@--
    act.target.persists = false
    if act.invobject.components.stackable then
        act.invobject.components.stackable:Get():Remove()
    else
        act.invobject:Remove()
    end
    return true
end
AddAction(REVIVE)
AddStategraphActionHandler("wilson", ActionHandler(REVIVE, "dolongaction"))
AddStategraphActionHandler("wilsonboating", ActionHandler(REVIVE, "dolongaction"))

--雾气ui
AddClassPostConstruct("screens/playerhud", function(self)
    local FogOver = require "widgets/white_bone_fogover"
    local old_CreateOverlays = self.CreateOverlays
    function self:CreateOverlays(owner,...)
        old_CreateOverlays(self,owner,...)
        self.white_bonefogover = self.overlayroot:AddChild(FogOver(owner))
    end
end)

--雾气的隐身效果
--我tm解释了无数遍, 饥荒没有所谓的隐身
--但是为什么总是要坚持做这个, 很好玩吗?

--直接修改RunAway的逻辑
--可能引发其他bug, 注意!!!   --@--
AddGlobalClassPostConstruct('behaviours/runaway', 'RunAway', function(self)
    local old_sh = self.shouldrunfn
    self.shouldrunfn = function(hunter, ...)
        if hunter and hunter.prefab == 'white_bone' and hunter:HasTag('wb_fog') then
            return false
        end
        if old_sh then
            return old_sh(hunter, ...)
        end
        return true
    end
end)

--鸟
AddBrainPostInit("birdbrain",function(brain)
    for i,node in ipairs(brain.bt.root.children) do
        if node.name == "Sequence" and node.children[1].name == "Threat Near"  then
            local old = node.children[1].fn 
            node.children[1].fn = function() 
                local inst = brain.bt.inst
                local player = GetClosestInstWithTag('player', inst, 20)
                if player and player:HasTag('wb_fog') then
                    return false
                end
                return old()
            end
            break
        end
    end
end)

--关于解剖尸体
local notags = {
    'wall', 'shadow', 'shadowminion', 'shadowchesspiece', 'chess', 'veggie', 
    'wb_skeleton', 'hive', 'houndmound', 'wb_nocorpse', 'twister', 'elephantcactus',
    'birchnutdrake',
}
local nocorpseprefabs = {
    'jellyfish', 'rainbowjellyfish', 'bill',
}
for _,v in ipairs(nocorpseprefabs)do AddPrefabPostInit(v, function(inst) inst:AddTag('wb_nocorpse') end) end

AddPrefabPostInitAny(function(inst)
    for _,tag in ipairs(notags)do
        if inst:HasTag(tag) then return end
    end
    if inst.components.health and inst.components.health.maxhealth >= 50 and not inst.components.health.nofadeout then
        local old_fn = inst.components.health.SetVal 
        inst.components.health.SetVal = function(self, val, cause, ...)
            if val <= 0 and cause == 'white_bone' then
                inst:AddTag('killed_by_wb')
                inst.components.health.destroytime = math.max(inst.components.health.destroytime or 0, 10)
                inst:DoTaskInTime(0.1, function(inst) inst:RemoveTag('NOCLICK') end)
                inst:DoTaskInTime(inst.components.health.destroytime, function(inst) 
                    inst:AddTag('NOCLICK') inst:RemoveTag('killed_by_wb') 
                    if inst.components.lootdropper and inst.components.lootdropper.wb_cached then
                        inst.components.lootdropper:DropLoot()
                    end
                end)
            end
            old_fn(self, val, cause, ...)
        end
    end
end)
--copy from dst ~
AddComponentPostInit("lootdropper",function(self)
    local old_GenerateLoot = self.GenerateLoot
    self.GenerateLoot = function(self,...)
        local loots = old_GenerateLoot(self,...)
        if self.inst.white_bone_right then
            for i, v in ipairs(loots) do 
                if loots[i] ~= nil then
                    loots[i] = "nightmarefuel"
                end
            end
        elseif self.inst.white_bone_left then
            if self.inst:HasTag("largecreature") then
                table.insert(loots, "boneshard")
            end
            if math.random() < (self.inst:HasTag("largecreature") and 0.5 or 0.2 )then 
                table.insert(loots, "boneshard")
            end
            if math.random() < 0.1 then 
                table.insert(loots, "boneshard")
            end
        end
        return loots
    end
    
    local old = self.DropLoot
    self.DropLoot = function(self,pt,...)
        if self.inst:HasTag('killed_by_wb') then
            self.wb_cached = true
            return
        end
        old(self,pt,...)
    end
end)

local function destroy(inst)
    local time_to_erode = 1
    local tick_time = TheSim:GetTickTime()

    if inst.DynamicShadow then
        inst.DynamicShadow:Enable(false)
    end

    inst:StartThread( function()
        local ticks = 0
        while ticks * tick_time < time_to_erode do
            local erode_amount = ticks * tick_time / time_to_erode
            inst.AnimState:SetErosionParams( erode_amount, 0.1, 1.0 )
            ticks = ticks + 1
            Yield()
        end
        inst:Remove()
    end)
end

local WHITE_BONE_RIGHT = Action({})  
WHITE_BONE_RIGHT.priority = 1
WHITE_BONE_RIGHT.id = "WHITE_BONE_RIGHT"
WHITE_BONE_RIGHT.str = MK_MOD_LANGUAGE_SETTING and 'Melt' or '化尸'
WHITE_BONE_RIGHT.fn = function(act)
    if act and act.target ~= nil then
        if act.target.prefab == 'wb_body' then
            act.target:onkilled()
            return true 
        end
        if not act.target:HasTag('killed_by_wb') then 
            return
        end
        act.target:RemoveTag('killed_by_wb')
        act.target.white_bone_right = true
        if act.target.components.lootdropper then
            act.target.components.lootdropper:DropLoot()
        end
        if act.doer and act.doer.components.sanity then
            act.doer.components.sanity:DoDelta(-5)
        end
        act.target:AddTag("NOCLICK")
        act.target:DoTaskInTime(0.1, destroy)
        return true
    end
end

local WHITE_BONE_LEFT = Action({})   
WHITE_BONE_LEFT.priority = 1
WHITE_BONE_LEFT.id = "WHITE_BONE_LEFT"
WHITE_BONE_LEFT.str = MK_MOD_LANGUAGE_SETTING and 'Dissection' or '剖尸'
WHITE_BONE_LEFT.fn = function(act)
    if act and act.target ~= nil then
        if act.target.prefab == 'wb_body' then
            act.target:onkilled()
            return true 
        end
        if not act.target:HasTag('killed_by_wb') then
            return
        end
        act.target:RemoveTag('killed_by_wb')
        act.target.white_bone_left = true
        if act.target.components.lootdropper then
            act.target.components.lootdropper:DropLoot()
        end
        if act.doer and act.doer.components.sanity then
            act.doer.components.sanity:DoDelta(5)
        end
        act.target:AddTag("NOCLICK")
        act.target:DoTaskInTime(0.1, destroy)
        return true
    end
end
AddAction(WHITE_BONE_RIGHT)
AddAction(WHITE_BONE_LEFT)

AddComponentPostInit('lootdropper', function(self)
    local old_fn = self.CollectSceneActions
    self.CollectSceneActions = function(self, doer, actions, right)
        if (self.inst.prefab == 'wb_body' or self.inst:HasTag('killed_by_wb')) and doer and doer.prefab == 'white_bone' then
            table.insert(actions, right and WHITE_BONE_RIGHT or WHITE_BONE_LEFT)
        end
        if old_fn then
            old_fn(self, doer, actions, right)
        end
    end
end)
AddStategraphActionHandler("wilson",ActionHandler(ACTIONS.WHITE_BONE_RIGHT, "dolongaction"))
AddStategraphActionHandler("wilsonboating",ActionHandler(ACTIONS.WHITE_BONE_RIGHT, "dolongaction"))
AddStategraphActionHandler("wilson",ActionHandler(ACTIONS.WHITE_BONE_LEFT, "dolongaction"))
AddStategraphActionHandler("wilsonboating",ActionHandler(ACTIONS.WHITE_BONE_LEFT, "dolongaction"))



