GLOBAL.setmetatable(env,{__index=function(t,k) return GLOBAL.rawget(GLOBAL,k) end})

AddSimPostInit(function()
	local function _docompatible(...)
		for _,v in ipairs{...} do
			if rawget(GLOBAL, v) then return end

			rawset(GLOBAL, v, function()
				if v == 'GetInventoryItemAtlas' then
					return 'images/inventoryimages.xml'
				end
				print('DLC compatible: ' .. v .. ' is an empty function.')
			end)
		end
	end

	_docompatible('MakeInventoryFloatable', 'MakeBlowInHurricane', 'GetInventoryItemAtlas')
end)

MK_evententity = CreateEntity() --用于事件通讯

PrefabFiles = {
	"mk_jgb",'jgb_spawner',
	"mk_pills",	--丹药
	"mk_battle_flag", --旗帜
	"monkey_king",'neza',
	'mk_striker',
	'alchmy_fur',
	'mk_firefx',
	'mk_cloudpuff',
	'myth_reticuleprefabs',
	'mk_cloud',
	'mk_foods',
	'peachtrees',
	'peach_sapling',
	'yamaraja_book',
	'yamaraja_boss',
	'yamaraja_follower',
	'yamaraja_mist',
	'lavaarena_battle_fx',
	'armors_mk','hat_mk',
	'armors_nz',
	'nz_ring','nz_lance','nz_wheel',
	'xzhat_mk',
	'mk_items',

	'laozi','laozi_sp',
	'gourd',
	'bananafan',
	
	'skinmirror',
	'blackbear','myth_rhino3', 'myth_rhino3_spell', 'myth_rhino_desk',

	'mk_blueprints',

	'white_bone',
	'wb_staff','wb_skeleton','wb_items','wb_weapons',
}

Assets = {
    Asset( "ATLAS", "images/saveslot_portraits/monkey_king.xml" ),
    Asset( "ATLAS", "images/selectscreen_portraits/monkey_king.xml" ), 
    Asset( "ATLAS", "bigportraits/monkey_king.xml" ),

    Asset( "ATLAS", "images/saveslot_portraits/neza.xml" ),
    Asset( "ATLAS", "images/selectscreen_portraits/neza.xml" ), 
    Asset( "ATLAS", "bigportraits/neza.xml" ),

    Asset( "ATLAS", "images/saveslot_portraits/white_bone.xml"),
    Asset( "ATLAS", "images/selectscreen_portraits/white_bone.xml"),
    Asset( "ATLAS", "bigportraits/white_bone.xml"),

	Asset( "ATLAS", "images/map_icons/monkey_king.xml" ),
	Asset( "ATLAS", "images/map_icons/neza.xml"),
	Asset( "ATLAS", "images/map_icons/white_bone.xml"),
	Asset( "ATLAS", "images/map_icons/nz_ring.xml"),	
	Asset( "ATLAS", "images/map_icons/nz_lance.xml"),	
	Asset( "ATLAS", "images/map_icons/nz_damask.xml"),	
	Asset( "ATLAS", "images/map_icons/nz_wheel.xml"),	
	Asset( "ATLAS", "images/map_icons/peachtree.xml" ),
	Asset( "ATLAS", "images/map_icons/mk_battle_flag.xml" ),
	Asset( "ATLAS", "images/map_icons/alchmy_fur.xml" ),
	Asset( "ATLAS", "images/map_icons/mk_jgb.xml" ),

	Asset( "ANIM", "anim/dst_myth/player_emotesxl.zip"),
	Asset( "ANIM", "anim/dst_myth/player_actions_whip.zip"),
	Asset( "ANIM", 'anim/dst_myth/player_emotes_dance0.zip'),
	Asset( "ANIM", 'anim/dst_myth/player_emotes_dance2.zip'),
	Asset( "ANIM", "anim/dst_myth/player_lunge_myth.zip"),
	Asset( "ANIM", "anim/dst_myth/player_actions_whip_myth.zip"),
	Asset( "ANIM", "anim/dst_myth/recharge_meter_myth.zip"),
	Asset( "ANIM", 'anim/dst_myth/spider_spike_myth.zip'),
	Asset( "ANIM", 'anim/dst_myth/player_revive_from_corpse.zip'),
	Asset( "ANIM", 'anim/dst_myth/player_emotes.zip'),
	Asset( "ANIM", 'anim/dst_myth/player_emote_extra_myth.zip'), --为了减少冲突, 只保留anim
	Asset( "ANIM" ,'anim/dst_myth/wb_revive_myth.zip'),

	Asset( "ANIM", "anim/wb_spellring.zip"),

	Asset( "ANIM", "anim/cloud_health.zip"),
	Asset( "ANIM", "anim/wheel_health.zip"),
	Asset( "ANIM", "anim/white_boneui.zip"),
	Asset( "ANIM", "anim/monkey_kingui.zip"),
	
	Asset( "IMAGE", "images/monkey_king_item.tex" ),
    Asset( "ATLAS", "images/monkey_king_item.xml" ),

    Asset( "ATLAS", "images/hud/myth_tab.xml" ),
    Asset( "ATLAS", "images/hud/white_bone_tab.xml"),
    Asset("ATLAS", "images/hud/white_bonefogover.xml"),

	Asset("ATLAS_BUILD", "images/monkey_king_item.xml", 256),

	Asset("ANIM", 'anim/mk_miao.zip'),
	Asset("ANIM", 'anim/myth_frozen.zip'),

	Asset("ATLAS", "images/yamaraja_icon.xml"),

	Asset("SOUNDPACKAGE", "sound/WhiteBone.fev"),
    Asset("SOUND", "sound/WhiteBone.fsb"),
    Asset("SOUNDPACKAGE", "sound/MK.fev"),
    Asset("SOUND", "sound/MonkeyKing.fsb"),
    Asset("SOUNDPACKAGE", "sound/Nezha.fev"),
    Asset("SOUND", "sound/Nezha.fsb"),

    Asset("ATLAS", "images/hud/myth_skin_unlock.xml"),
    Asset("ANIM", "anim/myth_playtimebar.zip"),


}
local function IsChi()
	if not softresolvefilepath('scripts/languages/loc.lua') then
        return
    end
    local loc = require "languages/loc"
    local syslang = loc and loc.GetLanguage and loc.GetLanguage()
    if syslang and (syslang == LANGUAGE.CHINESE_T or syslang == LANGUAGE.CHINESE_S or syslang == LANGUAGE.CHINESE_S_RAIL)then
        return true
    end
end

local function HasChiMod()
    for name, data in pairs(GLOBAL.KnownModIndex.savedata.known_mods) do
        if data.enabled and data.modinfo and data.modinfo.restart_required 
        	and (data.modinfo.name:upper():find('CHINESE') or data.modinfo.name:find('汉化') or data.modinfo.name:upper():find('L.M.U')) then
            return true
        end
    end
end

MK_MOD_LANGUAGE_SETTING = true   --英语
if GetModConfigData('Language') == 1 and (IsChi() or HasChiMod()) or GetModConfigData('Language') == 3 then
    MK_MOD_LANGUAGE_SETTING = false    --中文
end
GLOBAL.MK_MOD_LANGUAGE_SETTING = MK_MOD_LANGUAGE_SETTING
GLOBAL.MK_MOD_CLOUD_BGM = GetModConfigData('cloudBGM')

modimport "modimport/sg.lua" --有关stategraph的api
modimport "modimport/ui.lua" --界面修改
modimport "modimport/component.lua" --组件修改
modimport "modimport/fn.lua" --偷懒函数
modimport "modimport/actions.lua" --动作
modimport "modimport/foods.lua" --食谱
modimport "modimport/skinutil.lua"
modimport "modimport/whiteboneAPI.lua"--白骨精
modimport "modimport/skinfree.lua"

--debug
modimport "modimport/hot.lua"
----命名相关
if language then 

STRINGS.CHARACTERS.MONKEY_KING = require 'speech_monkey_king_eng'

local old_GetSpecialCharacterString = GetSpecialCharacterString
function GLOBAL.GetSpecialCharacterString(character, stringtype, modifier)
	character = character == 'monkey_king' and 'wilton' or character
	return old_GetSpecialCharacterString(character, stringtype, modifier)
end

STRINGS.CHARACTER_TITLES.monkey_king = "Great Sage Equalling Heaven"
STRINGS.CHARACTER_NAMES.monkey_king = "Monkey King"
STRINGS.CHARACTER_DESCRIPTIONS.monkey_king = "*He was the Monkey King of Huaguo Mountain.\n*Except for the golden cudgel, other weapons are not suitable.\n*Is not a good swimmer and hates dampness."
STRINGS.CHARACTER_QUOTES.monkey_king = "\"Ohooo...\""
STRINGS.NAMES.MONKEY_KING = "Monkey King"

STRINGS.CHARACTER_TITLES.neza = "Third prince Nezha"
STRINGS.CHARACTER_NAMES.neza = "Ne zha"
STRINGS.CHARACTER_DESCRIPTIONS.neza = "*He is a Legendary warrior.\n*He was a reckless child.\n*Lotus root body."
STRINGS.CHARACTER_QUOTES.neza = "\"Eye for an Eye,Lotus blooming in the blood pool\""
STRINGS.NAMES.NEZA = "Ne zha"

STRINGS.CHARACTER_TITLES.white_bone = "Third prince Nezha"
STRINGS.CHARACTER_NAMES.white_bone = "Ne zha"
STRINGS.CHARACTER_DESCRIPTIONS.white_bone = "*He is a Legendary warrior.\n*He was a reckless child.\n*Lotus root body."
STRINGS.CHARACTER_QUOTES.white_bone = "\"Eye for an Eye,Lotus blooming in the blood pool\""
STRINGS.NAMES.white_bone = "Ne zha"

STRINGS.NAMES.MK_JGB = "Golden Cudgel" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_JGB = "What a powerful weapon!" 

STRINGS.NAMES.GOLDEN_ARMOR_MK = 'Armor monkey king'
STRINGS.RECIPE_DESC.GOLDEN_ARMOR_MK = 'Turn this place upside down!'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOLDEN_ARMOR_MK = 'The invincible armor!'
STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.GOLDEN_ARMOR_MK = ''

STRINGS.NAMES.GOLDEN_HAT_MK = 'Phoenix tail crown'
STRINGS.RECIPE_DESC.GOLDEN_HAT_MK = 'Majestic!'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOLDEN_HAT_MK = 'What a magnificent crown!'
STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.GOLDEN_HAT_MK = ''

STRINGS.NAMES.HEAT_RESISTANT_PILL = "Heat Tesistant Pill" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.HEAT_RESISTANT_PILL = "I can’t feel the fire and the scorching sun!" 

STRINGS.NAMES.COLD_RESISTANT_PILL = "Cold Tesistant Pill" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.COLD_RESISTANT_PILL = "I’m not afraid df the cold any more,nor the rain!" 

STRINGS.NAMES.DUST_RESISTANT_PILL = "Dust Tesistant Pill" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DUST_RESISTANT_PILL = "Don't worry about the sandstorm anymore!" 

STRINGS.NAMES.FLY_PILL = "Fly Pill" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FLY_PILL = "Sure?I can fly too?" 

STRINGS.NAMES.BLOODTHIRSTY_PILL = "Bloodthirsty Pill" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BLOODTHIRSTY_PILL = "Crazy as a bat!" 

STRINGS.NAMES.CONDENSED_PILL = "Condensed Pill" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.CONDENSED_PILL = "Eating it makes me have to concentrate!" 

STRINGS.NAMES.THORNS_PILL = 'Thorn pill'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.THORNS_PILL = 'Thorns to protect me.'

STRINGS.NAMES.DETOXIC_PILL = 'Detoxify pill'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DETOXIC_PILL = "It's used to detoxify."

STRINGS.NAMES.ARMOR_PILL = 'Fit pill'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARMOR_PILL = 'To keep fit.'

STRINGS.NAMES.MK_BATTLE_FLAG = "Battle Flag"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_BATTLE_FLAG = "I can write on it!" 
STRINGS.NAMES.MK_BATTLE_FLAG_ITEM = "Battle Flag"
STRINGS.RECIPE_DESC.MK_BATTLE_FLAG_ITEM = "Raise a flag for battle!"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_BATTLE_FLAG_ITEM = "I can write on it!" 

STRINGS.NAMES.MK_CLOUD = 'Somersault Cloud'
STRINGS.RECIPE_DESC.MK_CLOUD = 'To break through the sky.'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_CLOUD = 'Can I fly, too?'
STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.MK_CLOUD = ''

STRINGS.NAMES.PEACH = "Peach" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACH = "This is not a normal peach!" 
STRINGS.NAMES.PEACH_COOKED = "Roasted Peach" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACH_COOKED = "It became ordinary now" 
STRINGS.NAMES.PEACH_BANQUET = "Peach Banquet" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACH_BANQUET = "The simple fruit platter is given magic by this peach!" 
STRINGS.NAMES.PEACH_WINE = "Peach Wine" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACH_WINE = "It's special." 

STRINGS.NAMES.HONEY_PIE = "Honey Pie"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.HONEY_PIE = "The coarse food was sweetened with honey." 

STRINGS.NAMES.VEGETARIAN_FOOD = "Vegetarian Food"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.VEGETARIAN_FOOD = "What a mild taste!" 

STRINGS.NAMES.CASSOCK = "Cassock"
STRINGS.RECIPE_DESC.CASSOCK = "Far from dust"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.CASSOCK = "Let's be calm." 

STRINGS.NAMES.KAM_LAN_CASSOCK = "Kam Lan Cassock"
STRINGS.RECIPE_DESC.KAM_LAN_CASSOCK = "Protect me from shadow!"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.KAM_LAN_CASSOCK = "It's so shiny!"

STRINGS.NAMES.PEACHTREE = "Peach Tree" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACHTREE =  {
	GENERIC = "According to legend, it takes thousands of years for the tree to blossom and bear fruit",
	CHOPPED = "what a pity",
	BURNT = "It's completely ruined.",
	FIRE = "What a waste!",
}

STRINGS.NAMES.ALCHMY_FUR = "Alchemy Furnace" 
STRINGS.RECIPE_DESC.ALCHMY_FUR = "Only this stove can control the Samadhi Fire"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ALCHMY_FUR =  {  
	EMPTY = "The legendary furnace of alchemy in Chinese tales？",
	GENERIC = "My God, the heat of the flames is unimaginable!",
	DONE = "What happened to the pill in the furnace?",
}

STRINGS.NAMES.XZHAT_MK = "Traveler Cap"
STRINGS.RECIPE_DESC.XZHAT_MK = "Be a traveler to the west"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XZHAT_MK = "What a comfy hat."

STRINGS.NAMES.MK_FLOWERFEATHER = "Phoenix Plume"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_FLOWERFEATHER = "What a beautiful plume! "

STRINGS.NAMES.MK_ROCK = "Heart of Stone"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_ROCK = "A heart of stone that Burns！"

STRINGS.NAMES.MK_DRAGONSCALE = "Loong Scale Satin"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_DRAGONSCALE = "Hot Satin."

STRINGS.NAMES.BIGPEACH = "Big Peach"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BIGPEACH = "This peach is bigger than the others!"

STRINGS.RECIPE_DESC.LOTUS_FLOWER = "Life for life"

STRINGS.NAMES.NZ_LANCE ="Fire Tiplance"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.NZ_LANCE = "There is a magic power in this spear."	
STRINGS.NAMES.NZ_DAMASK ="Sky MuddlingDamask"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.NZ_DAMASK = "What beautiful silk!!"	
STRINGS.NAMES.NZ_RING ="Universal Ring"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.NZ_RING = "This is no ordinary circle."

STRINGS.MONKEY_COOK = "Alchemy"
--STRINGS.MJ_JGB = "Too heavy!I can't afford this!!"
STRINGS.MKONEATMEAT = "OoO"
STRINGS.MKINSANDSTORM = "OoO"
STRINGS.MKINWIND = "OoO"
STRINGS.MKDROPWEAPON = "OoO"

STRINGS.UI.MONKEYKING_MOD_DLCWARNING = '[Warning]\nThis mod must be compatible with HAM!'

else 

STRINGS.CHARACTERS.MONKEY_KING = require 'speech_monkeyking_ch'
STRINGS.CHARACTERS.NEZA = require 'speech_neza_ch'
STRINGS.CHARACTERS.WHITE_BONE = require 'speech_white_bone_ch'

STRINGS.CHARACTER_TITLES.monkey_king = "齐天大圣"
STRINGS.CHARACTER_NAMES.monkey_king = "孙悟空"
STRINGS.CHARACTER_DESCRIPTIONS.monkey_king = "*他神通广大，曾是花果山猴王\n*除了金箍棒，其他兵器不称手\n*水性不好，讨厌潮湿"
STRINGS.CHARACTER_QUOTES.monkey_king = "\"睥睨意笑满天仙神皆无用\""
STRINGS.NAMES.MONKEY_KING = "孙悟空"

STRINGS.CHARACTER_TITLES.neza = "哪吒三太子"
STRINGS.CHARACTER_NAMES.neza = "哪吒"
STRINGS.CHARACTER_DESCRIPTIONS.neza = "*他是天生神将\n*曾是个不羁少年\n*落得莲藕之躯"
STRINGS.CHARACTER_QUOTES.neza = "\"以命偿命，灼灼天池血莲生\""
STRINGS.NAMES.NEZA = "哪吒"

STRINGS.CHARACTER_TITLES.white_bone = "白骨夫人"
STRINGS.CHARACTER_NAMES.white_bone = "白骨夫人"
STRINGS.CHARACTER_DESCRIPTIONS.white_bone = "*是只食人血肉的妖精\n*两幅面孔, 阴险狡猾\n*精通亡灵妖术"
STRINGS.CHARACTER_QUOTES.white_bone = "\"千年白骨化阴风\""
STRINGS.NAMES.white_bone = "白骨夫人"

STRINGS.NAMES.MK_JGB = "金箍棒" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_JGB = "是一把璀璨的宝贝武器！"

STRINGS.NAMES.MK_JGB_REC = "一柱擎天"
STRINGS.RECIPE_DESC.MK_JGB_REC = "金箍棒速来!"

STRINGS.NAMES.MK_JGB_SP = '插在地上的金箍棒'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_JGB_SP = '嘿嘿，好宝贝！'

STRINGS.NAMES.GOLDEN_ARMOR_MK = '大圣锁子甲'
STRINGS.RECIPE_DESC.GOLDEN_ARMOR_MK = '再闹个天翻地覆！'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOLDEN_ARMOR_MK = '战无不胜的盔甲！'
STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.GOLDEN_ARMOR_MK = '还有谁要拦俺老孙？'
STRINGS.CHARACTERS.NEZA.DESCRIBE.GOLDEN_ARMOR_MK = '哪吒也想要这般宝物'

STRINGS.NAMES.GOLDEN_HAT_MK = '凤翅紫金冠'
STRINGS.RECIPE_DESC.GOLDEN_HAT_MK = '威风堂堂！'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOLDEN_HAT_MK = '好一个威风堂堂的头冠！'
STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.GOLDEN_HAT_MK = '五百年了...'
STRINGS.CHARACTERS.NEZA.DESCRIBE.GOLDEN_HAT_MK = '讲究'

STRINGS.NAMES.HEAT_RESISTANT_PILL = "避暑丹" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.HEAT_RESISTANT_PILL = "有了它我感觉不到火焰和毒辣的太阳了！" 

STRINGS.NAMES.COLD_RESISTANT_PILL = "避寒丹" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.COLD_RESISTANT_PILL = "我不用怕冷了，雨也淋不着我！" 

STRINGS.NAMES.DUST_RESISTANT_PILL = "避尘丹" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DUST_RESISTANT_PILL = "不用再担心粉尘干扰！" 

STRINGS.NAMES.FLY_PILL = "腾云丹" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.FLY_PILL = "真的？我也能够飞起来？" 

STRINGS.NAMES.BLOODTHIRSTY_PILL = "嗜血丹" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BLOODTHIRSTY_PILL = "像蝙蝠一样疯狂！" 

STRINGS.NAMES.CONDENSED_PILL = "凝味丹" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.CONDENSED_PILL = "吃下去让我不得不集中精神了！" 

STRINGS.NAMES.THORNS_PILL = '荆棘丹'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.THORNS_PILL = '荆棘护我'
STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.THORNS_PILL = '嘿嘿嘿跟俺老孙比比谁更扎人？'

STRINGS.NAMES.DETOXIC_PILL = '化毒丹'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.DETOXIC_PILL = '用来解世间百毒'
STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.DETOXIC_PILL = '百毒不侵！'

STRINGS.NAMES.ARMOR_PILL = '壮骨丹'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ARMOR_PILL = '强身健体'
STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.ARMOR_PILL = '俺老孙铜头铁臂钢筋铁骨！'

STRINGS.NAMES.MK_BATTLE_FLAG = "战旗"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_BATTLE_FLAG = "这是一面战旗，可以写字！" 
STRINGS.NAMES.MK_BATTLE_FLAG_ITEM = "战旗"
STRINGS.RECIPE_DESC.MK_BATTLE_FLAG_ITEM = "为战斗竖起旗帜！"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_BATTLE_FLAG_ITEM = "这是一面战旗，可以写字！"

STRINGS.NAMES.MK_CLOUD = '筋斗云'
STRINGS.RECIPE_DESC.MK_CLOUD = '一个跟头便是十万八千里'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_CLOUD = '我也能飞起来了？！！'
STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.MK_CLOUD = '俺老孙一个跟头就是十万八千里！'
STRINGS.CHARACTERS.NEZA.DESCRIBE.MKCLOUD = '这宝物灵性不小。'

STRINGS.NAMES.PEACH = "蟠桃" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACH = "这可不是一般的桃子！" 
STRINGS.NAMES.PEACH_COOKED = "烤蟠桃" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACH_COOKED = "烤熟了就变得普通了" 
STRINGS.NAMES.PEACH_BANQUET = "蟠桃大会" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACH_BANQUET = "简单的水果拼盘被这桃子赋予了魔力似的！" 
STRINGS.NAMES.PEACH_WINE = "蟠桃素酒" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACH_WINE = "这水果酒不一般！" 

STRINGS.NAMES.PEACH_SAPLING = "蟠桃树苗"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACH_SAPLING = "桃树的小树苗"

STRINGS.NAMES.HONEY_PIE = "蜂蜜素饼"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.HONEY_PIE = "粗糙的食物加了些蜜糖。" 
STRINGS.CHARACTERS.NEZA.DESCRIBE.HONEY_PIE = '美味的买路财'

STRINGS.NAMES.VEGETARIAN_FOOD = "素斋"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.VEGETARIAN_FOOD = "好清淡的味道！" 
STRINGS.CHARACTERS.NEZA.DESCRIBE.VEGETARIAN_FOOD = '若是不合喜好也不可丢弃。'

STRINGS.NAMES.CASSOCK = "袈裟"
STRINGS.RECIPE_DESC.CASSOCK = "披在身上远离凡尘"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.CASSOCK = "远离尘世。" 
STRINGS.CHARACTERS.NEZA.DESCRIBE.CASSOCK = '师父是道人。'

STRINGS.NAMES.KAM_LAN_CASSOCK = "锦襕袈裟"
STRINGS.RECIPE_DESC.KAM_LAN_CASSOCK = "披上它远离魑魅魍魉。"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.KAM_LAN_CASSOCK = "这件袈裟好闪亮！"
STRINGS.CHARACTERS.NEZA.DESCRIBE.KAM_LAN_CASSOCK = '...好生华丽！'

STRINGS.NAMES.PEACHTREE = "蟠桃树" 
STRINGS.CHARACTERS.GENERIC.DESCRIBE.PEACHTREE =  {  --桃树
	GENERIC = "传说中这神树三千年才开一次花，三千年才结一次果!",
	CHOPPED = "砍掉太可惜了。",
	BURNT = "完全毁了。",
	FIRE = "别烧！别烧我的树！",
}

STRINGS.NAMES.ALCHMY_FUR = "炼丹炉" 
STRINGS.RECIPE_DESC.ALCHMY_FUR = "只有这个炉子才能控制三昧真火"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.ALCHMY_FUR =  {  
	EMPTY = "东方传说中的炼丹炉？",
	GENERIC = "我的天，那火焰高温无法想象！",
	DONE = "这丹药在这炉子里经历了什么？！",
}

STRINGS.NAMES.XZHAT_MK = "行者帽"
STRINGS.RECIPE_DESC.XZHAT_MK = "做个西行的行者"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.XZHAT_MK = "好舒适的帽子!"

STRINGS.NAMES.BIGPEACH = "大蟠桃"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.BIGPEACH = "这个桃子比其他的大！"
STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.BIGPEACH = '好大一蟠桃，归俺老孙了！'
STRINGS.CHARACTERS.NEZA.DESCRIBE.BIGPEACH = '好桃！定馋坏那泼猴。'

STRINGS.NAMES.MK_FLOWERFEATHER = "花翎"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_FLOWERFEATHER = "好漂亮的长翎！"

STRINGS.NAMES.MK_ROCK = "火猿石心"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_ROCK = "一颗烫手的石心！"

STRINGS.NAMES.MK_DRAGONSCALE = "龙皮绸缎"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.MK_DRAGONSCALE = "炽热的绸缎！"


STRINGS.NAMES.NZ_LANCE ="火尖枪"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.NZ_LANCE = "这天下少有人能吃得消的"	
STRINGS.NAMES.NZ_DAMASK ="混天绫"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.NZ_DAMASK = "所缠何物？命也"	
STRINGS.NAMES.NZ_RING ="乾坤圈"
STRINGS.CHARACTERS.GENERIC.DESCRIBE.NZ_RING = "还有甚么，都过来！"

STRINGS.RECIPE_DESC.LOTUS_FLOWER = "割肉还母，剔骨还父"

STRINGS.MONKEY_COOK = "炼丹"
--STRINGS.MJ_JGB = "太沉了！这可不是我能拿得起的！"
STRINGS.MKONEATMEAT = "酒肉穿肠过"
STRINGS.MKINSANDSTORM = "这该死的花粉!"
STRINGS.MKINWIND = "风好大!我睁不开眼睛了"
STRINGS.MKDROPWEAPON = "这兵器太轻了"

STRINGS.UI.MONKEYKING_MOD_DLCWARNING = '[神话书说]\n警告: 这个存档未兼容哈姆雷特DLC,\n无法制作筋斗云和莲花,避寒丹无法防水.'

end

AddMinimapAtlas("images/map_icons/monkey_king.xml")  
AddMinimapAtlas("images/map_icons/peachtree.xml")  
AddMinimapAtlas("images/map_icons/mk_battle_flag.xml") 
AddMinimapAtlas("images/map_icons/alchmy_fur.xml")
AddMinimapAtlas("images/map_icons/mk_jgb.xml")
AddMinimapAtlas("images/map_icons/neza.xml")
AddMinimapAtlas("images/map_icons/nz_lance.xml")
AddMinimapAtlas("images/map_icons/nz_ring.xml")
AddMinimapAtlas("images/map_icons/nz_damask.xml")
AddMinimapAtlas("images/map_icons/nz_wheel.xml")
AddMinimapAtlas("images/map_icons/laozi.xml")
AddMinimapAtlas("images/map_icons/white_bone.xml")

AddModCharacter("monkey_king", "MALE") 
AddModCharacter("neza", "MALE")
AddModCharacter("white_bone", "FEMALE")

AddPrefabPostInit('krampus',function(inst)
	inst.components.lootdropper:AddLoot('peach')
	inst.components.lootdropper:AddChanceLoot('peach',.33)
	--inst.components.lootdropper:AddChanceLoot('peach',.5)
end)
AddPrefabPostInit('lotus',function(inst)
	local old_pick = inst.components.pickable.onpickedfn
	inst.components.pickable.onpickedfn = function(inst, picker, ...)
		local player = picker
		if player and player.prefab == 'neza' then
			player.components.sanity:DoDelta(-5)
			player.components.combat:GetAttacked(inst,5)
			player.components.talker:Say(MK_MOD_LANGUAGE_SETTING and "I didn't mean to hurt you." or "本是同根生, 相煎何太急?")
		end
		old_pick(inst, picker, ...)
	end
end)
AddPrefabPostInit('redgem',function(inst)
	inst:AddComponent('fuel')
	inst.components.fuel.fueltype = "这都是些什么沙雕设定啊?"
	inst.components.fuel.fuelvalue = 3.5*480
end)
AddPrefabPostInit('lotus_flower',function(inst)
	inst:AddComponent('fuel')
	inst.components.fuel.fueltype = "LILYPAD_FLOWER"
	inst.components.fuel.fuelvalue = 10
end)
AddPrefabPostInit('primeape',function(inst)
	local old_getfn = inst.components.trader.onaccept
	local old_test = inst.components.trader.test
	inst.components.trader.onaccept = function(inst, giver, item)
		if item.prefab == "peach" then
			if inst.components.combat.target and inst.components.combat.target == giver then
				inst.components.combat:SetTarget(nil)
			elseif giver.components.leader then
				inst.sg:GoToState("befriend")
				inst.SoundEmitter:PlaySound("dontstarve/common/makeFriend")
				giver.components.leader:AddFollower(inst)
				inst.components.follower:AddLoyaltyTime(item.components.edible:GetHunger() * TUNING.PRIMEAPE_LOYALTY_PER_HUNGER)
			end
			if inst.components.sleeper:IsAsleep() then
				inst.components.sleeper:WakeUp()
			end
		end
		old_getfn(inst,giver,item)
	end
	inst.components.trader.test = function (inst,item)
		if inst.components.sleeper:IsAsleep() then
        	return false
    	end
    	if item.prefab == 'peach' then
    		return true
    	else
    		return old_test(inst,item)
    	end
    end
end)

for _,v in pairs({'crawlinghorror','terrorbeak','crawlingnightmare','nightmarebeak','swimminghorror',})do
AddPrefabPostInit(v,function(inst)
	local notags = inst.components.combat.notags or {}
    table.insert(notags,'mk_ignoreshadow')
    inst.components.combat.notags = notags

    inst:ListenForEvent('attacked',function(inst,data)
        if data and data.attacker == GetPlayer() then
            inst.components.combat.notags = nil
            inst.components.combat:SetTarget(GetPlayer())
        end
    end)
end)
end

local mk_mod_prefabs = {
	'mk_jgb','mk_jgb_fx','mk_jgb_sp','mk_jgb_rec','heat_resistant_pill','cold_resistant_pill','dust_resistant_pill','fly_pill','bloodthirsty_pill','condensed_pill','mk_battle_flag','mk_battle_flag_item','mk_battle_flag_item_placer','monkey_king','neza','mk_striker','mk_striker_fx','alchmy_fur','alchmy_fur_placer','mk_firefx','mk_firefxdie','mk_firefire','mk_firefire2','mk_halloween_firepuff_1','mk_halloween_firepuff_2','mk_halloween_firepuff_3','mk_halloween_firepuff_cold_1','mk_halloween_firepuff_cold_2','mk_halloween_firepuff_cold_3','mk_cloudpuff','mk_cloudpuff_small','reticuleline','reticulelineping','mk_cloud','mk_cloudfx','peach_placer','peach','bigpeach','peach_cooked','peach_banquet','peach_wine','honey_pie','vegetarian_food','peachtree','peachtree_normal','peachtree_tall','peachtree_short','peachtree_burnt','peachtree_stump','peach_sapling','yamaraja_book','yamaraja_boss','black_wc','white_wc','yamaraja_ghost','yamaraja_light','yamaraja_mist','lavaarena_battle_buff_fx','cassock','kam_lan_cassock','golden_armor_mk','golden_hat_mk','nz_damask','nz_ring','nz_lance','nz_wheel','nz_wheel_single','xzhat_mk','mk_rock','mk_flowerfeather','mk_dragonscale',	
}
--]]
---[[
local function ShelfPostInit(inst)
	local old_set = inst.SetImage
	inst.SetImage = function(inst, ent, slot)
		old_set(inst, ent, slot)
		if table.contains(mk_mod_prefabs,ent.prefab) then
			inst.AnimState:OverrideSymbol(slot, resolvefilepath("images/monkey_king_item.xml"), ent.prefab..".tex")
		end
	end
end

--local Table = GetAllPrefabNameFromFile('prefabs/shelf')
--print([[']]..table.concat(Table,[[',']])..[[']])
for k,v in pairs({'shelves_wood','shelves_basic','shelves_marble','shelves_glass','shelves_ladder','shelves_hutch','shelves_industrial','shelves_adjustable','shelves_fridge','shelves_cinderblocks','shelves_midcentury','shelves_wallmount','shelves_aframe','shelves_crates','shelves_hooks','shelves_pipe','shelves_hattree','shelves_pallet','shelves_floating','shelves_displaycase','shelves_displaycase_metal','shelves_queen_display_1','shelves_queen_display_2','shelves_queen_display_3','shelves_queen_display_4','shelves_ruins','pedestal_key','shelves_metal'})do
	AddPrefabPostInit(v, ShelfPostInit)
end
--]]
local function blood(inst,data)
	if not inst.components.mk_timerbuff_manager:HasBuff('bloodthirsty_pill') then
		return
	end
	local delta = (data and data.damage  or 0 ) * 0.1
	if not (inst.components.health ~= nil and inst.components.health:IsDead()) then
		inst.components.health:DoDelta(delta, false, "bloodthirsty_pill_buff")
	end
end

local function thorn(inst)
	if inst.components.inventory:Has('thorns_pill',1) then
		local fx = SpawnPrefab("bramblefx")
		local x,y,z = inst.Transform:GetWorldPosition()
		if fx then
			fx.Transform:SetPosition(x,y,z)
		end

		local ents = TheSim:FindEntities(x,y,z, 4,nil,{"INLIMBO"})
		if #ents > 0 then			
			for i,ent in pairs(ents)do
				if ent.components.combat and ent ~= inst then
					local src = inst
					if ent.components.follower and ent.components.follower.leader == inst then
						src = nil
					end
					ent.components.combat:GetAttacked(src, 75, nil, "monkey_king_aoe")
				end
			end
		end
		inst.SoundEmitter:PlaySound("dontstarve_DLC002/common/armour/cactus")
	end
end

function MK_MOD_RECIPE_INIT(inst) ---非ham存档，直接在modmain添加配方会导致崩溃，所以在prefab里调用
	local MYTH_TAB={str='MYTH_TAB',sort=99,icon="myth_tab.tex",icon_atlas="images/hud/myth_tab.xml"}
    STRINGS.TABS.MYTH_TAB=language and 'myth'or '神话'

    inst.components.builder:AddRecipeTab(MYTH_TAB)

	local mk_battle_flag_item = Recipe("mk_battle_flag_item", {Ingredient("boards", 2),Ingredient("silk", 9),Ingredient("houndstooth", 6),Ingredient("rope", 2)}, MYTH_TAB, TECH.SCIENCE_TWO)
	mk_battle_flag_item.atlas = "images/monkey_king_item.xml" 
	mk_battle_flag_item.image = "mk_battle_flag_item.tex"

	local mk_alchmy_fur = Recipe("alchmy_fur",{Ingredient("thulecite", 6),Ingredient("cutstone", 6),Ingredient("dragon_scales", 1)}, MYTH_TAB, TECH.MAGIC_THREE, nil, "alchmy_fur_placer",2)
	mk_alchmy_fur.atlas = "images/monkey_king_item.xml"
	mk_alchmy_fur.image = "alchmy_fur.tex"

	local cassock = Recipe("cassock",{Ingredient("silk", 9),Ingredient("manrabbit_tail", 3),Ingredient("slurper_pelt", 3)}, MYTH_TAB, TECH.SCIENCE_TWO)
	cassock.atlas = "images/monkey_king_item.xml"
	cassock.image = "cassock.tex"
	
	local kam_lan_cassock = Recipe("kam_lan_cassock",{Ingredient("cassock", 1,"images/monkey_king_item.xml"),Ingredient("bearger_fur", 1),Ingredient("dragon_scales", 1)}, MYTH_TAB, TECH.SCIENCE_TWO)
	kam_lan_cassock.atlas = "images/monkey_king_item.xml" 
	kam_lan_cassock.image = "kam_lan_cassock.tex"

	local hat2 = Recipe("xzhat_mk",{Ingredient('silk',6),Ingredient('manrabbit_tail',2),Ingredient('beeswax',1)}, MYTH_TAB, TECH.SCIENCE_TWO)
	hat2.atlas = "images/monkey_king_item.xml"
	hat2.image = "xzhat_mk.tex"

	local gourd1 = Recipe("gourd_pill",{Ingredient("gourd", 1,"images/monkey_king_item.xml"),Ingredient("rope", 2),Ingredient("beeswax", 1)}, MYTH_TAB,  TECH.SCIENCE_TWO)
	gourd1.atlas = "images/monkey_king_item.xml"
	gourd1.image = "pill_bottle_gourd.tex"

	local gourd2 = Recipe("gourd_wine",{Ingredient("gourd", 1,"images/monkey_king_item.xml"),Ingredient("peach_wine", 5,"images/monkey_king_item.xml"),Ingredient("beeswax", 1)}, MYTH_TAB,  TECH.SCIENCE_TWO)
	gourd2.atlas = "images/monkey_king_item.xml"
	gourd2.image = "wine_bottle_gourd.tex"

	if inst.prefab == 'monkey_king' then
		local mirror = Recipe("skinmirror", {Ingredient('goldnugget', 4), Ingredient('feather_robin', 1)},MYTH_TAB, TECH.NONE)
		mirror.atlas = 'images/monkey_king_item.xml'
	end

	if not IsDLCEnabled(PORKLAND_DLC) then
		return 
	end

	local cloud = Recipe("mk_cloud",{Ingredient("nitre", 6),Ingredient("fly_pill", 3, "images/monkey_king_item.xml"),Ingredient(CHARACTER_INGREDIENT.SANITY, 20)}, MYTH_TAB, TECH.MAGIC_THREE)
	cloud.atlas = "images/monkey_king_item.xml"
	cloud.image = "mk_cloud.tex"

	if inst.prefab == 'neza' then
		local lotus = Recipe("lotus_flower", {Ingredient(CHARACTER_INGREDIENT.HEALTH, 10)}, MYTH_TAB, {SCIENCE = 0, MAGIC = 0, ANCIENT = 0})
	end
	if inst.prefab == 'monkey_king' then
		local jgb = Recipe('mk_jgb_rec',{Ingredient(CHARACTER_INGREDIENT.SANITY, 50)}, MYTH_TAB ,{SCIENCE = 0, MAGIC = 0, ANCIENT = 0})
		jgb.atlas = 'images/monkey_king_item.xml'
		jgb.image = 'mk_jgb_rec.tex'
		jgb.mk_testfn = function(inst)
			return inst.prefab == 'monkey_king' and not inst.components.inventory:Has('mk_jgb',1) and not inst.components.inventory:EquipHasTag('mk_jgb')
		end
	end
end	

local OnlyForModChar = true --@--
local OnlyForModChar = GetModConfigData('myth for mod')

local function HealthAbsorb(inst)
	local old_delta = inst.components.health.DoDelta 
	inst.components.health.DoDelta = function(self, delta, ...)
		if self.mk_absorb and delta < 0 then
			delta = delta * (1 - self.mk_absorb)
		end
		return old_delta(self, delta, ...)
	end
end

local function newcomponents(inst)
	inst:AddComponent("bloomer")
	inst:AddComponent("colouradder")
	inst:AddComponent("mk_invbuff_manager")
	inst:AddComponent("mk_timerbuff_manager")
	inst:AddComponent("yamarajabuff")
	inst:AddComponent("mk_dynamicmusic")
	inst:AddComponent("laozitimer")
	
	inst:ListenForEvent("onhitother", blood)
	inst:ListenForEvent("blocked", thorn)
	inst:ListenForEvent("attacked", thorn)
	HealthAbsorb(inst)

	if OnlyForModChar and inst.prefab ~= 'monkey_king' and inst.prefab ~= 'neza' and inst.prefab ~= 'white_bone' then
		return
	end
	MK_MOD_RECIPE_INIT(inst)
end
AddPlayerPostInit(newcomponents)

local function trade(inst)
	if not inst.components.tradable then
		inst:AddComponent('tradable')
	end
end

local tradableitems = {
	featherfan = {bananafan = 1},
    tropicalfan = {bananafan = 1},

    amulet = {armor_pill = 3},
    blueamulet = {fly_pill = 3},
    purpleamulet = {bloodthirsty_pill = 3},

    ruinshat = {ruinshat = 1},
    armorruins = {armorruins = 1},
    ruins_bat = {ruins_bat = 1},

    nz_wheel = {nz_wheel = 1},
    golden_armor_mk = {golden_armor_mk = 1},
    golden_hat_mk = {golden_hat_mk = 1},

    deerclops_eyeball = {randompill = 1},
    dragon_scales = {randompill = 3},
    bearger_fur = {randompill = 1},
}

for k in pairs(tradableitems)do
	AddPrefabPostInit(k, trade)
end

