local function apply(inst)
    inst:DoTaskInTime(0,function (inst)inst.components.mk_invbuff_manager:Apply()end)
end

local BuffManager = Class(function(self, inst)
    self.inst = inst
    self.enabled_buffs = {}

    inst:ListenForEvent('itemget',apply)
    inst:ListenForEvent('itemlose',apply)
    inst:ListenForEvent('setoverflow',apply)
    inst:ListenForEvent('containergotitem',apply)
    apply(inst)
end)

function BuffManager:Apply() --print(self.inst.prefab..'  1')
    local inv = self.inst.components.inventory
    local con = self.inst.components.container
    local items = inv and inv:FindItems(function(inst)return inst:HasTag('mk_invbuff')end) or con:FindItems(function(inst)return inst:HasTag('mk_invbuff')end)
    local enabled_buffs = {}  -- k 预制物名   v 对应实体
    for _,v in pairs(items)do
        if not enabled_buffs[v.prefab] then
            enabled_buffs[v.prefab] = v
        end
    end
    for prefab,ent in pairs(enabled_buffs)do
        if not self.enabled_buffs[prefab] then --新buff
            self:AddBuff(ent)
        end
    end
    for prefab,ent in pairs(self.enabled_buffs)do
        if not enabled_buffs[prefab] then  --移除的buff
            self:RemoveBuff(ent)
        end
    end
    self.enabled_buffs = enabled_buffs
end

function BuffManager:HasBuff(name)
    return self.enabled_buffs[name]
end

function BuffManager:AddBuff(item)
    if item.mk_bufffn and item.mk_bufffn.on then
        item.mk_bufffn.on(item,self.inst)
    end
end

function BuffManager:RemoveBuff(item)
    if item.mk_bufffn and item.mk_bufffn.off then
        item.mk_bufffn.off(item,self.inst)
    end
end

function BuffManager:GetDebugString()
    local str = 'Buffs: '
    for k,v in pairs(self.enabled_buffs)do
        str = str..' '..k
    end
    return str
end

return BuffManager
