
local MonkeyFriend = Class(function(self, inst)
    self.inst = inst
    self.inst:AddTag('mythTag_monkeyfriend')

    inst:ListenForEvent('attacked',function(i,data) self:OnAttacked(data)end)
    inst:ListenForEvent('entity_death',function(i,data) self:OnMonkeyDie(data) end, GetWorld())
end)

function MonkeyFriend:OnAttacked(data)
    local atk = data and data.attacker
    if atk and not atk.prefab == 'primeape' and not atk.prefab == 'monkey' then
        local x, y, z = self.inst:GetPosition():Get()
        local ents = TheSim:FindEntities(x, y, z, 15, {'combat'})
        for _, v in pairs(ents) do
            if v.prefab == 'primeape' or v.prefab == 'monkey' then
                if not v.components.health:IsDead() then
                    v.components.combat:SuggestTarget(atk)
                end
            end
        end
    end
end

function MonkeyFriend:OnMonkeyDie(data)
    if data.inst and (data.inst.prefab == 'primeape' or data.inst.prefab == 'monkey') then
        if self.inst:IsNear(data.inst, 20) then
            self.inst.components.sanity:DoDelta(-30)
            self.inst.components.talker:Say(MK_MOD_LANGUAGE_SETTING and "Oooo..." or "猴儿...你死的好惨啊")
        end
    end
end

return MonkeyFriend
