local L = MK_MOD_LANGUAGE_SETTING
local str = {
	SUMMON = L and '' or '',
	FOG = '',
	RANGED = '',
	DAMAGE = ''
}
local fn = {
	SUMMON = nil,
	FOG = nil,
	RANGED = nil,
	DAMAGE = nil,
}


local  Reticule = Class(function(self, inst)
	self.inst = inst
	self.spellfn = nil
	self.canspell = true

	self.reticule_prefab = 'myth_reticule_line'
	self.trigger_action = ACTIONS.MK_LUNGE

	self.inst:ListenForEvent('unequipped',function()self:KillReticule();end)
end)

function Reticule:CanCast(doer)
	if doer.components.driver and doer.components.driver:GetIsDriving() then
		return false
	end
	return self.canspell
end

function Reticule:SetCanSpell(enabled)
    self.canspell = enabled
    if not enabled then
    	self:HideReticule()
    end
end

function Reticule:SetSpellFn(fn)
    self.spellfn = fn
end

function Reticule:CastSpell(doer, pos)
    if self.spellfn ~= nil then
        self.spellfn(self.inst,doer, pos)
	end
	self:HideReticule()
end

function Reticule:ShowReticule()
	self.shown = true
	if self.reticule and self.reticule:IsValid() then
		self.reticule:Show()
	else
		self.reticule = SpawnPrefab(self.reticule_prefab) --SetDebugEntity(self.reticule)
		self.reticule:DoPeriodicTask(0,function(inst)
			inst:UpdatePosition(self.inst:GetPosition(), self.inst:GetAngleToPoint(TheInput:GetWorldPosition()))
		end)
	end
end

function Reticule:HideReticule()
	self.shown = false
	if self.reticule and self.reticule:IsValid() then
		self.reticule:Hide()
	else
		self.reticule = nil
	end
end

function Reticule:OnRightClick(canshow)
	if self.shown then
		self:HideReticule()
	elseif canshow and self:CanCast(self.inst) then
		self:ShowReticule()
	end
end

function Reticule:KillReticule()
	self.shown = false
	if self.reticule then
		self.reticule:Remove()
		self.reticule = nil
	end
end

function Reticule:OnRemoveEntity()
	self:KillReticule()
end

function Reticule:CollectPointActions(doer, pos, actions, right)
	if not right and self:CanCast(doer) and self.shown then
		table.insert(actions, self.trigger_action)
	end
end

function Reticule:CollectEquippedActions(doer, target, actions, right)
	local pos = target:GetPosition()
	if pos then
		return self:CollectPointActions(doer, pos, actions, right)
	end
end
return Reticule


