

local function ondone(self, done)
    if done then
        self.inst:AddTag("donecooking_fur")
    else
        self.inst:RemoveTag("donecooking_fur")
    end
end

local function oncheckready(inst)
    if inst.components.container ~= nil and
        not inst.components.container:IsOpen() and
        inst.components.container:IsFull() then
        inst:AddTag("readytocook_fur")
    end
end

local function onnotready(inst)
    inst:RemoveTag("readytocook_fur")
end

local Stewer_Fur = Class(function(self, inst)
    self.inst = inst

    self.done = nil
    self.targettime = nil
    self.task = nil
	self.puff = nil
    self.product = nil
    self.spoiledproduct = "spoiled_food"


    inst:ListenForEvent("itemget", oncheckready)
    inst:ListenForEvent("onclose", oncheckready)

    inst:ListenForEvent("itemlose", onnotready)
    inst:ListenForEvent("onopen", onnotready)

end,
nil,
{
    done = ondone,
})

function Stewer_Fur:OnRemoveFromEntity()
    self.inst:RemoveTag("donecooking_fur")
    self.inst:RemoveTag("readytocook_fur")
end

local function cookcook(inst)
	if inst:Has("minotaurhorn", 1) and inst:Has("bluegem", 1) and inst:Has("foliage", 1) and inst:Has("nitre", 1) then
		return "heat_resistant_pill" , 960  --避暑  
	elseif inst:Has("minotaurhorn", 1) and inst:Has("redgem", 1) and inst:Has("foliage", 1) and inst:Has("nitre", 1) then
		return "cold_resistant_pill" , 960  --避寒丹
	elseif inst:Has("minotaurhorn", 1) and inst:Has("yellowgem", 1) and inst:Has("foliage", 1) and inst:Has("nitre", 1) then
		return "dust_resistant_pill" , 960 --避尘丹
	elseif inst:Has("nitre", 1) and inst:Has("dragonfruit", 1) and inst:Has("honey", 1) and inst:Has("nightmarefuel", 1) then
		return "fly_pill" , 180 --腾云
	elseif inst:Has("purplegem", 1) and inst:Has("livinglog", 1) and inst:Has("batwing", 1) and inst:Has("nightmarefuel", 1) then
		return "bloodthirsty_pill" , 180 --嗜血
	elseif inst:Has("gunpowder", 1) and inst:Has("stinger", 1) and inst:Has("durian", 1) and inst:Has("nightmarefuel", 1) then
		return "condensed_pill" , 180 --凝神	
    elseif inst:Has("nz_wheel", 1) and inst:Has("redgem", 3) then
        return "nz_wheel", 60, true --风火轮
    elseif inst:Has('mk_flowerfeather',2) and inst:Has('ruinshat',1) and inst:Has('tigereye',1) then
        return "golden_hat_mk", 240 --紫金冠
    elseif inst:Has('redgem',1) and inst:Has('goose_feather',3) then
        return 'mk_flowerfeather', 60 --花翎
    elseif inst:Has('mk_dragonscale',1) and inst:Has('mk_rock',1) and inst:Has('armorruins',1) and inst:Has('walrus_tusk',1) then
        return 'golden_armor_mk', 240 --锁子甲
    elseif inst:Has('dragon_scales',2) and inst:Has('bearger_fur',1 ) and inst:Has('shark_gills',1) then
        return 'mk_dragonscale', 60 --龙仔皮
    elseif inst:Has('bigpeach',1) and inst:Has('rocks',2) and inst:Has('dragoonheart',1) then
        return 'mk_rock', 60 --石猴
    elseif inst:Has('golden_armor_mk',1) and inst:Has('redgem',1) and inst:Has('bluegem',1) and inst:Has('purplegem',1) then
        return 'golden_armor_mk', 60, true --锁子甲2
    elseif inst:Has('golden_hat_mk',1) and inst:Has('redgem',1) and inst:Has('bluegem',1) and inst:Has('purplegem',1) then
        return 'golden_hat_mk', 60, true --头2
    elseif inst:Has('venomgland', 2) and inst:Has('watermelon', 1) and inst:Has('honey', 1) then
        return 'detoxic_pill', 40 --解毒-
    elseif inst:Has('boneshard',1) and inst:Has('snake_bone',2) and inst:Has("rocks", 1) then
        return 'armor_pill', 60 --骨
    elseif inst:Has('cactus_flower',2) and inst:Has('bramble_bulb',2) then
        return 'thorns_pill', 180 --反伤
    elseif inst:Has('papyrus',2) and inst:Has('petals',1) and inst:Has('featherpencil',1) then
        return 'laozi_sp', 10 --太上老君
	end
	return nil , 1.5
end


local function dostew(inst, self) --over
    self.task = nil
    if self.puff ~= nil then
        self.puff:Cancel()
		self.puff = nil
    end	
    self.targettime = nil
    
    if self.ondonecooking ~= nil then
        self.ondonecooking(inst)
    end
    self.done = true
end

local function dobad(inst, self) --over
    self.task = nil
    if self.puff ~= nil then
        self.puff:Cancel()
		self.puff = nil
    end	
    self.targettime = nil
    
    if self.ondobad ~= nil then
        self.ondobad(inst)
    end
    self.done = nil
	if inst.components.container then
		inst.components.container.canbeopened = true
        for k,v in pairs(inst.components.container.slots)do
            if not v:HasTag('irreplaceable') then
                inst.components.container:RemoveItemBySlot(k)
                local ash = SpawnPrefab("ash")
                inst.components.container:GiveItem(ash,k)
            end
        end
        inst.components.container:DropEverything()
	end
end


local function dopuff(inst, self)
    local pt = Vector3(inst.Transform:GetWorldPosition())
    local mk_cloudpuff = SpawnPrefab( "mk_cloudpuff" )
    mk_cloudpuff.Transform:SetPosition( pt.x , pt.y + 1, pt.z)
    if self:IsCooking() then
	   self.puff = inst:DoTaskInTime(math.random(5,8), dopuff, self)    
    end
end

function Stewer_Fur:IsDone()
    return self.done
end

function Stewer_Fur:IsCooking()
    return not self.done and self.targettime ~= nil
end

function Stewer_Fur:GetTimeToCook()
    return not self.done and self.targettime ~= nil and self.targettime - GetTime() or 0
end

function Stewer_Fur:CanCook()
    return self.inst.components.container ~= nil and self.inst.components.container:IsFull()
end

function Stewer_Fur:StartCooking()
    if self.targettime == nil and self.inst.components.container ~= nil then
        self.done = nil

        if self.onstartcooking ~= nil then 
            self.onstartcooking(self.inst)
        end
        local cooktime = 1
		self.product, cooktime, self.refresh = cookcook(self.inst.components.container) --"kabobs" ,  60 -- cooking.CalculateRecipe(self.inst.prefab, ings)
        if self.product ~= nil then
		print(self.product)
		self.targettime = GetTime() + cooktime
        if self.task ~= nil then
            self.task:Cancel()
        end
        self.task = self.inst:DoTaskInTime(cooktime, dostew, self)
		
        if self.puff ~= nil then
            self.puff:Cancel()
        end
        self.puff = self.inst:DoTaskInTime(math.random(5,8), dopuff, self)
        for k = 1, self.inst.components.container.numslots do
            local item = self.inst.components.container:GetItemInSlot(k)
            if item and (not self.refresh or item.prefab ~= self.product) then
                self.inst.components.container:RemoveItemBySlot(k):Remove()
            end
        end
    
		else
		self.targettime = 1.5
		self.product = nil
		
        if self.task ~= nil then
            self.task:Cancel()
        end
		
        if self.puff ~= nil then
            self.puff:Cancel()
        end
        self.task = self.inst:DoTaskInTime(1.5, dobad, self)
		end
        self.inst.components.container:Close()
        self.inst.components.container.canbeopened = false
    end
end

local function StopProductPhysics(prod)
    prod.Physics:Stop()
end

function Stewer_Fur:OnSave()
    local remainingtime = self.targettime ~= nil and self.targettime - GetTime() or 0
    return
    {
        done = self.done,
        product = self.product,
        refresh = self.refresh,
        remainingtime = remainingtime > 0 and remainingtime or nil,
    }
end

function Stewer_Fur:OnLoad(data)
    if data.product ~= nil then
        self.done = data.done or nil
        self.product = data.product
        self.refresh = data.refresh


        if self.task ~= nil then
            self.task:Cancel()
            self.task = nil
        end
        if self.puff ~= nil then
            self.puff:Cancel()
            self.puff = nil
        end
        self.targettime = nil

        if data.remainingtime ~= nil then
            self.targettime = GetTime() + math.max(0, data.remainingtime)
            if self.done then
                --self.task = self.inst:DoTaskInTime(data.remainingtime, dospoil, self)
                if self.oncontinuedone ~= nil then
                    self.oncontinuedone(self.inst)
                end
            else
                self.task = self.inst:DoTaskInTime(data.remainingtime, dostew, self)
				self.puff = self.inst:DoTaskInTime(math.random(5,8), dopuff, self)
				
                if self.oncontinuecooking ~= nil then
                    self.oncontinuecooking(self.inst)
                end
            end
        elseif self.product ~= self.spoiledproduct  then
            self.targettime = GetTime()
            self.task = self.inst:DoTaskInTime(0, dostew, self)
            if self.oncontinuecooking ~= nil then
                self.oncontinuecooking(self.inst)
            end
        elseif self.oncontinuedone ~= nil then
            self.oncontinuedone(self.inst)
        end

        if self.inst.components.container ~= nil then
            self.inst.components.container.canbeopened = false
        end
    end
end

function Stewer_Fur:GetDebugString()
    local status = (self:IsCooking() and "COOKING")
                or (self:IsDone() and "FULL")
                or "EMPTY"

    return string.format("%s %s timetocook: %.2f",
            self.product or "<none>",
            status,
            self:GetTimeToCook())
end

function Stewer_Fur:Harvest(harvester)
    if self.done then
        if self.onharvest ~= nil then
            self.onharvest(self.inst)
        end

        if self.product ~= nil then
            local loot
            if self.refresh then
                loot = self.inst.components.container:FindItem(function()return true end)
            else
                loot = SpawnPrefab(self.product)
            end
            if loot ~= nil then
				local stacksize =  1
				if stacksize > 1 then
					loot.components.stackable:SetStackSize(stacksize)
				end
                if harvester then
                    --loot.Transform:SetPosition(harvester.Transform:GetWorldPosition())
                end
                if loot.prefab == 'nz_wheel' then
                    loot.components.fueled:SetPercent(1)
                    loot:SetHot()
                elseif loot.prefab == 'golden_armor_mk' then
                    loot.components.armor:SetPercent(1)
                elseif loot.prefab == 'golden_hat_mk' then
                    loot.components.fueled:SetPercent(1)
                end
                if harvester ~= nil and harvester.components.inventory ~= nil then
                    harvester.components.inventory:GiveItem(loot, nil, Vector3(TheSim:GetScreenPos(self.inst.Transform:GetWorldPosition())))
                else
                    --LaunchAt(loot, self.inst, nil, 1, 1)
                end
            end
            self.product = nil
            self.refresh = nil
        end

        if self.task ~= nil then
            self.task:Cancel()
            self.task = nil
        end
        if self.puff ~= nil then
            self.puff:Cancel()
            self.puff = nil
        end
        self.targettime = nil
        self.done = nil

        if self.inst.components.container ~= nil then      
            self.inst.components.container.canbeopened = true
        end
        return true
    end
end

function Stewer_Fur:CollectSceneActions(doer, actions, right)
    if not doer.components.rider or not doer.components.rider:IsRiding() then
        if not self.inst:HasTag("burnt") then
            if self.done then
                table.insert(actions, ACTIONS.HARVEST)
            elseif right and self:CanCook() then
                table.insert(actions, ACTIONS.COOK)
            end
        end
    end
end

function Stewer_Fur:LongUpdate(dt)
    if self:IsCooking() then
        if self.task ~= nil then
            self.task:Cancel()
        end
        if self.task ~= nil then
            self.task:Cancel()
        end
        if self.targettime - dt > GetTime() then
            self.targettime = self.targettime - dt
            self.task = self.inst:DoTaskInTime(self.targettime - GetTime(), dostew, self)
			
			if self.targettime - GetTime() >= 5 then
				self.puff = self.inst:DoTaskInTime(math.random(5,8), dopuff, self)
			end
			
            dt = 0            
        else
            dt = dt - self.targettime + GetTime()
            dostew(self.inst, self)
        end
    end
end

return Stewer_Fur
