
local BoneHealer = Class(function(self, inst)
	self.inst = inst
	self.value = 30
end)

function BoneHealer:SetValue(val)
	self.value = val
end

function BoneHealer:Use()
	if self.inst.components.stackable then
		self.inst.components.stackable:Get():Remove()
	else
		self.inst:Remove()
	end
	return self.value
end

function BoneHealer:CollectUseActions(doer, target, actions)
	if doer and doer.prefab == 'white_bone' then
		if target.prefab == 'wb_blade' 
		or target.prefab == 'wb_knife'
		or target.prefab == 'wb_staff'
		or target.prefab == 'wb_whip'
		or target.prefab == 'wb_skeleton' then
			table.insert(actions, ACTIONS.WB_BONE_FIX)
		end
	end
end

function BoneHealer:CollectInventoryActions(doer, actions)
	if doer and doer.prefab == 'white_bone' then
		table.insert(actions, ACTIONS.WB_BONE_FIX)
	end
end


return BoneHealer