local Knife = Class(function (self, inst)
	self.inst = inst
end)

local smallmeat_prod = {boneshard = 1, tinymeat = 2}
local smallmeat_cooked_prod = {boneshard = 1, tinymeat_cooked = 2}
local fish_prod = {spoiled_fish = 1, tinymeat = 2}
local fish_cooked_prod = {spoiled_fish = 1, tinymeat_cooked = 2}
local fish_prod2 = {spoiled_fish = 1, tinymeat = 4}
local fish_cooked_prod2 = {spoiled_fish = 1, tinymeat_cooked = 4}

local meats = {
	meat = {boneshard = 1, tinymeat = 5}, --大肉
	cookedmeat = {boneshard = 1, tinymeat_cooked = 5},
	monstermeat = {boneshard = 1, tinymeat = 4,},--怪物肉
	cookedmonstermeat = {boneshard = 1, tinymeat = 4},
	smallmeat = smallmeat_prod, --小肉
	cookedsmallmeat = smallmeat_cooked_prod,
	drumstick = smallmeat_prod, --鸡腿
	drumstick_cooked = smallmeat_cooked_prod,
	batwing = smallmeat_prod,   --蝙蝠
	batwing_cooked = smallmeat_cooked_prod,
	froglegs = smallmeat_prod, froglegs_poison = smallmeat_prod,  --青蛙腿
	froglegs_cooked = smallmeat_cooked_prod, froglegs_poison_cooked = smallmeat_cooked_prod,
	fish = fish_prod, --鱼
	fish_cooked = fish_cooked_prod,
	tropical_fish = fish_prod, --热带鱼(老鱼人)
	eel = fish_prod,  --鳗鱼
	eel_cooked = fish_cooked_prod,
	dead_swordfish = fish_prod2, --剑鱼
	fish_med = fish_prod2,     --死狗鱼
	fish_med_cooked = fish_cooked_prod2,
	fish_raw = fish_prod2,     --生鱼片
	fish_raw_cooked = fish_cooked_prod2,
	fish_raw_small = fish_prod, --小鱼块
	fish_raw_small_cooked = fish_cooked_prod,
	fish3 = fish_prod, fish3_cooked = fish_cooked_prod, --五彩斑斓鱼
	fish4 = fish_prod, fish4_cooked = fish_cooked_prod,
	fish5 = fish_prod, fish5_cooked = fish_cooked_prod,
}

function Knife:CollectUseActions(doer, target, actions)
	if doer and doer.prefab == 'white_bone' and target and self:IsValidMeat(target) then
        table.insert(actions, ACTIONS.WB_CUT)
    end
end

function Knife:IsValidMeat(target)
	for k in pairs(meats)do if k == target.prefab then return true end end
end

function Knife:CutMeat(doer, meat)
	if not doer or not meat then
		return
	end
	local oldmeat = meat
	self.inst.components.finiteuses:Use(1)

	if meat.components.stackable then
		meat = meat.components.stackable:Get(1)
	end

	local fresh = meat.components.perishable and meat.components.perishable:GetPercent() or 1
	local prod = meats[meat.prefab]
	for name, num in pairs(prod) do
		name = (name == 'boneshard' or name == 'spoiled_fish') and name or 'wb_'..name
		while num > 0 do
			local item = SpawnPrefab(name) --这里没有写保护
			if item.components.stackable then
				item.components.stackable:SetStackSize(num)
				num = 0
			else
				num = num - 1
			end
			if item.components.perishable then
				item.components.perishable:SetPercent(fresh)
			end
			if doer.components.inventory then
				doer.components.inventory:GiveItem(item)
			else
				item.Transform:SetPosition(doer:GetPosition():Get())
			end
		end
	end
	meat:Remove()

	if self.inst:IsValid() and oldmeat:IsValid() 
		and doer.components.inventory and doer.components.inventory:GetActiveItem() == self.inst then
		-- doer, target, action, invobject
		doer:DoTaskInTime(0, function()
			if not doer.bufferedaction then
				doer:PushBufferedAction(BufferedAction(doer, oldmeat, ACTIONS.WB_CUT, self.inst))
			end
		end)
	end

	return true
end

return Knife




