
--在灵魂状态下, san值归0, 结束游戏
local sanity = Class(function(self, inst)
	self.inst = inst

	inst:ListenForEvent('wbEvent_changetoghost', function()self:StartUpdating() end)
	inst:ListenForEvent('wbEvent_changetohuman', function()self:StopUpdating() end)
	inst:ListenForEvent('sanitydelta', function(_,data)self:OnSanityDelta(data)end)
end)

local alpha_speed = 0.5
local plus_scale  = 0.2

function sanity:OnUpdate(dt)
	local inst = self.inst
	local san = inst.components.sanity.current
	local p = inst.components.sanity:GetPercent()
	if inst._isghost then
		if san <= 0 then
			inst:PushEvent('death', {cause = 'nopower'})
			self:StopUpdating()
		end
	end
	local alpha_base = Remap(p, 1, 0, 1.5, 0.3)
	local alpha_plus = math.sin(GetTime()*alpha_speed)*plus_scale
	if alpha_base > 1-plus_scale then
		inst.AnimState:SetMultColour(1,1,1,1)
	else
		inst.AnimState:SetMultColour(1,1,1,alpha_base+alpha_plus)
		--print('set->', alpha_base+alpha_plus)
	end
end

local function _say(inst, p)
	inst.components.talker:StopIgnoringAll()
	inst.components.talker:Say(p)
end

function sanity:OnSanityDelta(data)
	if not self.inst._isghost then return end
	local old = data.oldpercent * self.inst.components.sanity.max
	local new = data.newpercent * self.inst.components.sanity.max
	if old > 40 and new <= 40 then
		_say(self.inst, '该死, 法力正在消散!')
	elseif old > 20 and new <= 20 then
		_say(self.inst, '不!快给我一副新的躯体!')
	elseif old > 10 and new <= 10 then
		_say(self.inst, '就要灰飞烟灭了!我不甘!')
	end

end

function sanity:StartUpdating()
	self.inst:StartUpdatingComponent(self)
end

function sanity:StopUpdating()
	self.inst.AnimState:SetMultColour(1,1,1,1)
	self.inst:StopUpdatingComponent(self)
end

return sanity