local Wined = Class(function(self, inst)
	self.inst = inst
	self.max = 5
	self.current = 5
end)

function Wined:OnSave()
	return {current = self.current}
end

function Wined:OnLoad(data)
	if data then
		self.current = data.current or self.current
	end
end

function Wined:Drink()
	self.current = self.current - 1
	self.inst:PushEvent('percentusedchange',{percent = self.current/self.max})
end

function Wined:Add(p)
	self.current = self.current + p
	self.current = math.min(self.max, self.current)
	self.inst:PushEvent('percentusedchange',{percent = self.current/self.max})
end

function Wined:GetLeft()
	return self.max - self.current
end

function Wined:IsFull()
	return self.max == self.current
end

function Wined:CollectInventoryActions(doer, actions, right)
    if doer.components.eater and self.current > 0 then
		table.insert(actions, ACTIONS.MK_DRINK)
    end
end

return Wined