---依附于玩家
---负责复活机制的改动记录及boss的生成

local YamarajaManager = Class(function(self, inst)
    self.inst = inst
    self.hasbuff = false ---指自动复活是否被激活
    self.boss = nil

    self.cooldown = 480*5

    self.check_task = inst:DoPeriodicTask(1,function()self:UpdateTask()end)
end)

local function ValidateBoss(self)
    if self.boss and not self.boss:IsValid() then
        self.boss = nil
        return false
    end
    return self.boss
end

function YamarajaManager:UpdateTask()  ---间隔为1s
    if self.cooldown == nil then
        self.cooldown = 0
    elseif self.cooldown >= 0 then
        self.cooldown = self.cooldown - 1
    end
    local boss = ValidateBoss(self)
    if boss then
        if boss:IsAsleep() then 
         --boss:靠近玩家
        end
    else
        if self:CanSpawnBoss() then
            local boss = SpawnPrefab('yamaraja_boss')
            boss:NewSpawnFn()
            self.boss = boss
            SetDebugEntity(boss)
        end
    end
end

function YamarajaManager:CanSpawnBoss()
    if self.cooldown >= 0 then return false end
    if not GetClock():IsDay() or GetWorld():IsCave() then
    	local player = GetPlayer()
    	if player.components.sanity:GetPercent() <= 0.4 and player.components.health:GetPercent() <= 0.1 then
    		return true
    	end
    end
end

function YamarajaManager:OnBossDefeated()
    self.cooldown = math.max(10* 480, self.cooldown)
end

function YamarajaManager:AddColdDown(time)
    self.cooldown = self.cooldown + time
end

function YamarajaManager:LoadPostPass(ents, data)
	if data and data.bossGUID and ents[data.bossGUID] then
		self.boss = ents[data.bossGUID].entity
	end
end

function YamarajaManager:OnLoad(data)
    if data then
    	self.hasbuff = data.hasbuff
    	self.cooldown = data.cooldown or 0
    end
end

function YamarajaManager:OnSave()
    return {bossGUID = self.boss and self.boss.GUID, cooldown = self.cooldown, hasbuff = self.hasbuff},
    {self.boss and self.boss.GUID}
end

function YamarajaManager:LongUpdate(dt)
    self.cooldown = self.cooldown - dt
end


function EnterState()
    GetPlayer().components.sanity:SetPercent(0.01)
    GetPlayer().components.health.absorb = 1
    GetPlayer().components.health:SetPercent(0.05)
end

return YamarajaManager
