

local function cassockonequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_body", "cassock", "swap_body")  
    if owner.components.hunger ~= nil then
        owner.components.hunger:AddBurnRateModifier(inst, -0.2)
    end
    if inst.components.fueled ~= nil then
        inst.components.fueled:StartConsuming()
    end
end

local function cassockonunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    if owner.components.hunger ~= nil then
        owner.components.hunger:RemoveBurnRateModifier(inst)
    end
    if inst.components.fueled ~= nil then
        inst.components.fueled:StopConsuming()
    end
end

local function kamcassockonequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_body", "kam_Lan_cassock", "swap_body")  
    if owner.components.hunger ~= nil then
        owner.components.hunger:AddBurnRateModifier(inst, -0.2)
    end
    if inst.components.fueled ~= nil then
        inst.components.fueled:StartConsuming()
    end
    owner:AddTag('mk_ignoreshadow')
end

local function kamcassockonunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    if owner.components.hunger ~= nil then
        owner.components.hunger:RemoveBurnRateModifier(inst)
    end
    if inst.components.fueled ~= nil then
        inst.components.fueled:StopConsuming()
    end
    owner:RemoveTag('mk_ignoreshadow')
end

local function unfreeze(inst)
	inst:DoTaskInTime(0,function()
		inst.components.freezable:Unfreeze()
		inst.sg:GoToState('idle')
	end)
end

local function goldenonequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_body", "golden_armor_mk", "swap_body")  
    if owner.prefab == "monkey_king"  then
        --owner.AnimState:AddOverrideBuild("mk_golden_armor")
        owner.AnimState:OverrideSymbol("foot", "mk_golden_armor", "foot")
        owner.AnimState:OverrideSymbol("arm_upper", "mk_golden_armor", "arm_upper")
    end

	if inst.components.armor:GetPercent() > 0 then
		owner:AddTag("not_hit_stunned")
		if owner.components.combat then
			owner.components.combat:AddDamageModifier(inst,0.15)
		end
	end
	owner:AddTag('fireeye_boost_mk')
	owner:ListenForEvent('freeze',unfreeze)
end

local function goldenonunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")
    if owner.prefab == "monkey_king"  then
        --owner.AnimState:ClearOverrideBuild("mk_golden_armor")
        owner.AnimState:ClearOverrideSymbol('foot')
        owner.AnimState:ClearOverrideSymbol('arm_upper')
    end
	
	if owner.components.combat then
		owner.components.combat:RemoveDamageModifier(inst)
	end
	owner:RemoveTag("not_hit_stunned")
	owner:RemoveTag('fireeye_boost_mk')
	owner:RemoveEventCallback('freeze',unfreeze)
end


local function cassockfn(inst)
		inst.components.equippable:SetOnEquip(cassockonequip)
		inst.components.equippable:SetOnUnequip(cassockonunequip)
		inst.components.equippable.dapperness = 6/60
end
local function kamcassockfn(inst)
		inst.components.equippable:SetOnEquip(kamcassockonequip)
		inst.components.equippable:SetOnUnequip(kamcassockonunequip)
		inst.components.equippable.dapperness = 9/60
end

local function goldenfn(inst)
		inst.components.equippable:SetOnEquip(goldenonequip)
		inst.components.equippable:SetOnUnequip(goldenonunequip)
		inst:AddComponent("armor")
		inst.components.armor:InitCondition(4000, 0.85)	
		inst.components.armor.dontremove = true

		inst:ListenForEvent('percentusedchange',function(_,data)
			local p = data.percent
			if p <= 0 then
				GetPlayer():RemoveTag('not_hit_stunned')
				GetPlayer().components.combat:RemoveDamageModifier(inst)
			end
		end)
 
end
local function armor(name,masterfn)
	local assets =
	{
		Asset("ANIM", "anim/"..name..".zip"),
		Asset("ANIM", "anim/mk_golden_armor.zip"),
	}

	local function fn()
		local inst = CreateEntity()

		inst.entity:AddTransform()
		inst.entity:AddAnimState()

		MakeInventoryPhysics(inst)
		MakeInventoryFloatable(inst, 'anim', 'anim')
		--MK_MOD_UTIL.MakeFloatable(inst,'yamaraja_book')

		inst.AnimState:SetBank(name)
		inst.AnimState:SetBuild(name)
		inst.AnimState:PlayAnimation("anim")

		inst:AddComponent("inspectable")

		inst:AddComponent("inventoryitem")
		inst.components.inventoryitem.imagename = name
		inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"

		if name ~= 'golden_armor_mk' then
        inst:AddComponent("fueled")
        inst.components.fueled.fueltype = 'USAGE'
        inst.components.fueled:InitializeFuelLevel(TUNING.AUTOSAVE_INTERVAL* 8)
        inst.components.fueled:SetDepletedFn(inst.Remove)
		end

		inst:AddComponent("equippable")
		inst.components.equippable.equipslot = EQUIPSLOTS.BODY
		
		masterfn(inst)

		return inst
	end

	return Prefab(name, fn, assets)

end

return armor("cassock",cassockfn),
		armor("kam_lan_cassock",kamcassockfn,true),
		armor("golden_armor_mk",goldenfn)