
local assets = 
{
	Asset("ANIM", "anim/nz_damask.zip"),
	Asset("ANIM", "anim/white_vortex_cloak_fx.zip"),
}

local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_body", "nz_damask", "swap_body")  
    
end

local function onunequip(inst, owner) 
    owner.AnimState:ClearOverrideSymbol("swap_body")  
end

local function commonperish(inst)
	inst:Remove()
end

local function Fx()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	inst.AnimState:SetBank('vortex_cloak_fx')
	inst.AnimState:SetBuild('white_vortex_cloak_fx')
	inst.AnimState:PlayAnimation('idle')

	inst.AnimState:SetMultColour(0.7,0,0,0.5) --粉

	inst:ListenForEvent('animover',inst.Remove)

	return inst
end

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	inst:AddTag('irreplaceable')

	inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon("nz_damask.tex")

	MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, 'idle_water', 'idle')

	inst.AnimState:SetBank('nz_damask')
	inst.AnimState:SetBuild('nz_damask')
	inst.AnimState:PlayAnimation("idle")

	inst:AddComponent("inspectable")

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"


	inst:AddComponent("fueled")
	inst.components.fueled.accepting = true
	inst.components.fueled.fueltype = 'LILYPAD_FLOWER'
	inst.components.fueled:InitializeFuelLevel(100)

	local attacked_cool_down = 5*FRAMES
	inst:AddComponent('armor')
	inst.components.armor:InitCondition(1,1)
	inst.components.armor.last_take_damage_time = 0
	inst.components.armor.GetPercent = function(...)
		return inst.components.fueled:GetPercent()
	end
	inst.components.armor.TakeDamage = function(self,damage_amount,...)
		if damage_amount == 0 then
			return 0
		end
		if self.inst.components.fueled:IsEmpty() then
			return damage_amount
		end
		if GetTime()- self.last_take_damage_time <= attacked_cool_down then
			return 0
		else
			self.last_take_damage_time = GetTime()
			self.inst.components.fueled:DoDelta(-10)
			Fx().Transform:SetPosition(self.inst:GetPosition():Get())
			return 0
		end
	end

	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.BODY
	inst.components.equippable.walkspeedmult = 0.1
	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)

	return inst
end
--'Sky Muddling Damask'
return Prefab('nz_damask',fn,assets)