--[[
丹药葫芦pill bottle gourd，可以永久储存14格丹药，丹药在葫芦中不消耗耐久也不起作用。 2本科技神话栏，材料葫芦*1，绳子*2，蜂蜡*1，描述：将丹药存入葫芦中
]]

require "prefabs/veggies"
local assets=
{
	Asset("ANIM", "anim/seeds.zip"),
    Asset("ANIM", "anim/gourd.zip"),
    Asset("ANIM", 'anim/gourd_items.zip'),
}

local prefabs =
{
    "seeds_cooked",
    "spoiled_food",
} 

if MK_MOD_LANGUAGE_SETTING then
    STRINGS.NAMES.GOURD = "gourd"
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD = "It's a good vegetable."

    STRINGS.NAMES.GOURD_COOKED = 'cooked gourd'
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD_COOKED = 'More fragrant.'

    STRINGS.NAMES.GOURD_WINE = 'wine gourd'
    STRINGS.RECIPE_DESC.GOURD_WINE = 'Good wine, good gourd'
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD_WINE = 'I smelled the smell of wine.'

    STRINGS.NAMES.GOURD_SEEDS = "Gourd Seed"

	STRINGS.NAMES.GOURD_SOUP = "Gourd Soup"
	STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD_SOUP = "Delicious."

    STRINGS.NAMES.GOURD_PILL = 'pill gourd'
    STRINGS.RECIPE_DESC.GOURD_PILL = 'Store the pills in the gourd'
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD_PILL = 'For pills.'

	STRINGS.NAMES.GOURD_OMELET = "Gourd Waffles"
	STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD_OMELET = "It's a delicious little dish."

else
    STRINGS.NAMES.GOURD = "葫芦"
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD = "是种好蔬菜"
    STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.GOURD = '神仙就好这种作物'

    STRINGS.NAMES.GOURD_COOKED = '烤葫芦'
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD_COOKED = "更香了"
    STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.GOURD_COOKED = '嗯，闻起来有些意思~'

    STRINGS.NAMES.GOURD_WINE = '酒葫芦'
    STRINGS.RECIPE_DESC.GOURD_WINE = '好酒好葫芦'
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD_WINE = '我闻到了酒香'
    STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.GOURD_WINE = '好酒好葫芦'

    STRINGS.NAMES.GOURD_PILL = '丹药葫芦'
    STRINGS.RECIPE_DESC.GOURD_PILL = '将丹药存入葫芦中'
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD_PILL = '用来盛丹药'
    STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.GOURD_PILL = '想当年我一葫芦一葫芦地下肚'

    STRINGS.NAMES.GOURD_SEEDS = "葫芦种子"

	STRINGS.NAMES.GOURD_SOUP = "葫芦汤"
	STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD_SOUP = "可口"
	STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.GOURD_SOUP = '这汤不错'

	STRINGS.NAMES.GOURD_OMELET = "葫芦鸡蛋饼"
	STRINGS.CHARACTERS.GENERIC.DESCRIBE.GOURD_OMELET = "是道可口的小菜"
	STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.GOURD_OMELET = '有禽蛋味'
end

local function MakeVegStats(seedweight, hunger, health, perish_time, sanity, cooked_hunger, cooked_health, cooked_perish_time, cooked_sanity)
	return {
		health = health,
		hunger = hunger,
		cooked_health = cooked_health,
		cooked_hunger = cooked_hunger,
		seed_weight = seedweight,
		perishtime = perish_time,
		cooked_perishtime = cooked_perish_time,
		sanity = sanity,
		cooked_sanity = cooked_sanity

	}
end

local UNCOMMON = 1
local gourd = MakeVegStats(UNCOMMON, 37.5, 3, 10*480, 0, 37.5, 8, 6*480, 0)
VEGGIES['gourd'] = gourd

local function raw()
		local inst = SpawnPrefab('seeds')
		inst:SetPrefabName('gourd_seeds')

		inst.components.inventoryitem.atlasname = 'images/monkey_king_item.xml'

		inst.components.plantable.product = 'gourd'
		return inst
end

local function wine()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, 'wine', 'wine')
    MakeSmallBurnable(inst, TUNING.SMALL_BURNTIME)
    MakeSmallPropagator(inst)
    
    inst.AnimState:SetBank("gourd_items")
    inst.AnimState:SetBuild("gourd_items")
    inst.AnimState:PlayAnimation("wine")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "wine_bottle_gourd"
	inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"

	inst:AddComponent("wined")

	inst:AddComponent("tradable")

	inst:AddComponent('finiteuses')
	inst.components.finiteuses.GetPercent = function()
		return inst.components.wined.current/inst.components.wined.max 
	end

    return inst
end

local slotpos = {}
for y = 0, 3 do
	table.insert(slotpos, Vector3(-162, -y*75 + 114 ,0))
	table.insert(slotpos, Vector3(-162 +75, -y*75 + 114 ,0))
end

local function itemtest(inst, item, slot)
	return item.prefab and item.prefab:find('_pill')
end

local pill = function()
	local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, 'pill', 'pill')
    MakeSmallBurnable(inst, TUNING.SMALL_BURNTIME)
    MakeSmallPropagator(inst)
    
    inst.AnimState:SetBank("gourd_items")
    inst.AnimState:SetBuild("gourd_items")
    inst.AnimState:PlayAnimation("pill")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "pill_bottle_gourd"
	inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"

	inst:AddComponent("tradable")

	inst:AddComponent("container")
    inst.components.container:SetNumSlots(#slotpos)
    inst.components.container.widgetslotpos = slotpos
    inst.components.container.widgetanimbank = "ui_backpack_2x4"
    inst.components.container.widgetanimbuild = "ui_backpack_2x4"
    inst.components.container.widgetpos = Vector3(0,200,0)
    inst.components.container.itemtestfn = itemtest
	inst.components.container.side_align_tip = 160
    --inst.components.container.side_widget = true
    --inst.components.container.type = "mk_pill"
    inst:ListenForEvent('ondropped', function(inst) inst.components.container:Close()end)

    return inst
end

local function pill_bb()
    local inst = SpawnPrefab('gourd_pill')
    local pillchoice = {
        'fly_pill', 'bloodthirsty_pill', 'condensed_pill', 'armor_pill',
    }
    for _, v in ipairs(pillchoice)do
        local num = math.random(2)
        for i = 1, num do
            local pill = SpawnPrefab(v)
            inst.components.container:GiveItem(pill)
        end
    end
    return inst
end

return Prefab('gourd_seeds', raw, assets),Prefab('gourd_wine', wine, assets),Prefab('gourd_pill',pill,assets), Prefab('gourd_pill_blackbear', pill_bb),
MakePlacer( "gourd_seeds_placer", "plant_normal", "plant_normal", "placer" )
