
local assets=
{
	Asset("ANIM", "anim/golden_hat_mk.zip"),
    Asset("ANIM", "anim/mk_golden_hat.zip"),
}

local function OnKill(inst,data)
	if data and data.victim and data.victim:HasTag("monster") 
		and inst.components.sanity and inst.components.health and not inst.components.health:IsDead() then
		inst.components.sanity:DoDelta(10)
	end
end

local function onequiphat(inst, owner)
    if owner.prefab == "monkey_king"  then
        owner.AnimState:AddOverrideBuild("mk_golden_hat")
        if inst.components.fueled:GetPercent() > 0 then
        	owner:AddTag('fireeye_boost_mk')
        	owner:AddTag('skill_boost_mk')
        end
	else
        owner.AnimState:OverrideSymbol("swap_hat", "golden_hat_mk", "swap_hat")
        owner.AnimState:Show("HAT")
        owner.AnimState:Hide("HAIR_HAT")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")
		
		if owner:HasTag("player") then
			owner.AnimState:Show("HEAD")
			owner.AnimState:Hide("HEAD_HAIR")
		end
    end
	
    --if inst.components.fueled ~= nil then
    --    inst.components.fueled:StartConsuming()
    --end	

    --owner:AddTag('skill_boost_mk')

	inst:ListenForEvent("killed", OnKill, owner)
end

local function onunequiphat(inst, owner)
    if owner.prefab == "monkey_king"  then
        owner.AnimState:ClearOverrideBuild("mk_golden_hat")
        owner:RemoveTag('fireeye_boost_mk')
        owner:RemoveTag('skill_boost_mk')
	else
        owner.AnimState:ClearOverrideSymbol("swap_hat")
        owner.AnimState:Hide("HAT")
        owner.AnimState:Hide("HAIR_HAT")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")

        if owner:HasTag("player") then
            owner.AnimState:Show("HEAD")
            owner.AnimState:Hide("HEAD_HAIR")
        end
    end
    --if inst.components.fueled ~= nil then
    --    inst.components.fueled:StopConsuming()
    --end	
	inst:RemoveEventCallback("killed", OnKill, owner)

	--owner:RemoveTag('skill_boost_mk')
	
end

local function checkfireeye(inst)
    local owner = inst.components.equippable.owner
    if owner and owner.prefab == 'monkey_king' and owner.fireeye then
        inst.components.fueled:DoDelta(-0.1)
    end
end



local function fn(Sim)

	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("golden_hat_mk")
	inst.AnimState:SetBuild("golden_hat_mk")
	inst.AnimState:PlayAnimation("anim")
	MakeInventoryFloatable(inst, 'anim', 'anim')

	inst:AddTag("hat")
	inst:AddTag("golden_hat_mk")
	
	inst:AddComponent("tradable")
	
    inst:AddComponent("inspectable")
		
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "golden_hat_mk"
	inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"
	
	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
	inst.components.equippable:SetOnEquip( onequiphat )
	inst.components.equippable:SetOnUnequip( onunequiphat )
	
    inst:AddComponent("fueled")
    inst.components.fueled:InitializeFuelLevel(5*480)
    --inst.components.fueled:SetDepletedFn(inst.Remove)
    inst:DoPeriodicTask(0.1, checkfireeye)
    
	return inst
end 

return Prefab( "golden_hat_mk", fn, assets)