local assets =
{
    Asset("ANIM", "anim/mk_jgb.zip"),
}

local prefabs =
{
    "mk_jgb_fx",
}
local function DeerclopsFootstep(inst)
    local player = GetClosestInstWithTag("player", inst, 30)
    if player then
        player.components.playercontroller:ShakeCamera(inst, "VERTICAL", 0.5, 0.03, 2, 30)
    end
end

local function DoDrop(inst)
    inst:StartThread(function()
        if MK_MOD_SKINS.getplayerskin() == 'monkey_king_sea' then
            inst.AnimState:OverrideSymbol('drop', 'mk_jgb', 'drop_sea')
        end
        inst.AnimState:SetDeltaTimeMultiplier(1.5)
        Sleep(2)
        inst.AnimState:PlayAnimation("drop")
        Sleep(0.5/1.5)
        inst.components.groundpounder:GroundPound()
        DeerclopsFootstep(inst)
        return true
    end)
end

local function pickupfn(inst, guy)
    if guy.components and guy.components.inventory then
        print(inst.jgb or "NO ITEM LINKED")
        local potitem = inst.jgb or SpawnPrefab("mk_jgb")
        potitem.spawn_by_sp = true 
        guy.components.inventory:GiveItem(potitem)
        inst:Remove()
        return true
    end
end

local function fn() 
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon("mk_jgb.tex")

    MakeObstaclePhysics(inst, .25)

    inst.AnimState:SetBank("swap_mk_jgb")
    inst.AnimState:SetBuild("mk_jgb")
    --inst.AnimState:PlayAnimation("drop")--水上?

    DoDrop(inst)

    inst:AddComponent("groundpounder")
    inst.components.groundpounder.destroyer = true
    inst.components.groundpounder.damageRings = 2
    inst.components.groundpounder.destructionRings = 3
    inst.components.groundpounder.numRings = 3

    inst:AddComponent("combat")
    inst.components.combat.defaultdamage = 100
    inst.components.combat.notags = {'player'}

    inst:AddComponent("inspectable")

    inst:AddComponent("pickupable")
    inst.components.pickupable:SetOnPickupFn(pickupfn)
    inst.components.pickupable.canpickupfn = function() return true end

    return inst
end

local RADIUS = 1.0

local function DoDamage(inst, targets, doer, weapon)
	local x, y, z = inst.Transform:GetWorldPosition()
    if inst.AnimState ~= nil then
		inst.AnimState:PlayAnimation("idle")
		inst:Show()
		inst:DoTaskInTime(0.7 + 2 * FRAMES, inst.Remove)
    else
        inst:DoTaskInTime(2 * FRAMES, inst.Remove)
	end
    for i, v in ipairs(TheSim:FindEntities(x, 0, z, RADIUS + 3, nil, {"INLIMBO", "player","companion","wall" })) do
        if not targets[v] and v:IsValid() and not v:IsInLimbo() and not (v.components.health ~= nil and v.components.health:IsDead()) then
			if inst:IsNear(v, 2 + (v.Physics and v.Physics:GetRadius() or 0)) then
                if doer ~= nil and doer:IsValid() and doer.components.combat and doer.components.combat:CanTarget(v) then
                    targets[v] = true
					doer:PushEvent("onareaattackother", { target = v, weapon = weapon or nil, stimuli = "mk_jgb_skill" })
					v.components.combat:GetAttacked(doer, 100, weapon, "mk_jgb_skill")
                end
            end
        end
    end
end

local function RecipeFn()
    local inst = CreateEntity()
    inst.entity:AddTransform()

    --inst:AddComponent('inventoryitem')

    inst:DoTaskInTime(0,function()

    local jgb
    for k,v in pairs(Ents)do
        if v.prefab == 'mk_jgb' and v:IsValid() and v.components.inventoryitem:GetGrandOwner() ~= GetPlayer() then
            jgb = v
            break
        end
    end
    for k,v in pairs(Ents)do
        if v.prefab == 'mk_jgb_sp' and v:IsValid() then
            jgb = v
            break
        end
    end
    --优先搜索捅地上的那根

    if not jgb then
        jgb = SpawnPrefab('mk_jgb')
    end
    if not jgb:HasTag('INLIMBO') then
        SpawnPrefab('small_puff').Transform:SetPosition(jgb:GetPosition():Get())
    end   
    jgb:RemoveFromScene()

    local owner = GetPlayer()
    local r, theta = 3 * math.random(), 2*PI*math.random()
    local pos = owner:GetPosition() + Vector3(math.cos(theta)*r,0,math.sin(theta)*r)
    local rod = SpawnPrefab('mk_jgb_sp')
    rod.Transform:SetPosition(pos:Get())
    
    rod.jgb = jgb.jgb or jgb
    
    inst:Remove()
    end)

    return inst
end

return Prefab("mk_jgb_sp", fn, assets),Prefab("mk_jgb_rec", RecipeFn, assets)

