local assets=
{
	Asset("ANIM", "anim/laozi.zip"),
}

local offsets_lz = {}
for i = 1,12 do table.insert(offsets_lz,Vector3(math.cos(i*6.283/12),0.5,math.sin(i*6.283/12)))end
for i = 1,6 do table.insert(offsets_lz,Vector3(0.5*math.cos(i*6.283/6),0.5,0.5*math.sin(i*6.283/6)))end

if MK_MOD_LANGUAGE_SETTING then
    STRINGS.NAMES.LAOZI_SP = "Lao zi paper"
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.LAOZI_SP = "Invite the Lord Lao Zi."

    STRINGS.NAMES.LAOZI = 'Lao Zi'
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.LAOZI = 'This is an old Oriental god!'

else
    STRINGS.NAMES.LAOZI_SP = "急急如律令"
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.LAOZI_SP = "太上老君，急急如律令"
    STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.LAOZI_SP = '老倌儿在否？'

    STRINGS.NAMES.LAOZI = '太上老君'
    STRINGS.CHARACTERS.GENERIC.DESCRIBE.LAOZI = "这是东方老神仙！"
    STRINGS.CHARACTERS.MONKEY_KING.DESCRIBE.LAOZI = '嘿嘿！老倌儿！许久不见~'
    STRINGS.CHARACTERS.NEZA.DESCRIBE.LAOZI = '拜见师祖'
end

local prefabs = 
{
	"goldnugget",
}

local LootTable = {
    featherfan = {bananafan = 1},
    tropicalfan = {bananafan = 1},

    amulet = {armor_pill = 3},
    blueamulet = {fly_pill = 3},
    purpleamulet = {bloodthirsty_pill = 3},

    ruinshat = {ruinshat = 1},
    armorruins = {armorruins = 1},
    ruins_bat = {ruins_bat = 1},

    nz_wheel = {nz_wheel = 1},
    golden_armor_mk = {golden_armor_mk = 1},
    golden_hat_mk = {golden_hat_mk = 1},

    deerclops_eyeball = {randompill = 1},
    dragon_scales = {randompill = 3},
    bearger_fur = {randompill = 1},
}
local randompills = {
    "fly_pill",
    "bloodthirsty_pill",
    "condensed_pill",
    "detoxic_pill",
    "armor_pill",
}

local function OnGetItemFromPlayer(inst, giver, item)
    if giver and giver.prefab == 'white_bone' then
        inst.components.talker:Say(MK_MOD_LANGUAGE_SETTING and 'Don\'t push your luck.' or '妖精莫要得寸进尺')
        GetSeasonManager():DoLightningStrike(giver:GetPosition(), true)
    else
        local pos = inst:GetPosition()
        local prefab = item and item.prefab
        local loots = prefab and LootTable[prefab]
        if loots then
            for name, num in pairs(loots)do
                for i = 1, num do
                    local item
                    if name == 'randompill' then
                        item = SpawnPrefab(randompills[math.random(#randompills)])
                    elseif name == 'nz_wheel' then
                        item = SpawnPrefab(name)
                        item.components.fueled:SetPercent(1)
                        item:SetHot()
                    else
                        item = SpawnPrefab(name)
                    end

                    if item then
                        local targpos = pos + Vector3(GetRandomMinMax(-3,3), 0, GetRandomMinMax(-3,3))
                        item.Transform:SetPosition(targpos:Get())
                        local fx = SpawnPrefab('mk_cloudpuff')
                        fx.Transform:SetScale(.7,.7,.7)
                        fx.Transform:SetPosition(targpos:Get())
                    end
                end
            end
        end
    end

    inst:DoTaskInTime(1, inst.Despawn)

end

local function OnRefuseItem(inst, giver, item)
    inst.components.talker:Say(MK_MOD_LANGUAGE_SETTING and 'Are you joking?' or '你可是在说笑...')
end

local function OnAttacked(inst,data)
    inst.components.talker:Say(MK_MOD_LANGUAGE_SETTING and 'Behave yourself!' or "休得放肆!")
    if data.attacker and data.attacker:IsValid() then
        local pos = data.attacker.Transform and data.attacker:GetPosition()
        if pos then
            GetSeasonManager():DoLightningStrike(pos, true)
        end
        if data.attacker == GetPlayer() then
            local weapon = data.attacker.components.inventory:GetEquippedItem(EQUIPSLOTS.HANDS)
            if weapon then
                data.attacker.components.inventory:DropItem(weapon)
            end
        end
    end
end


local function Despawn(inst)
    if inst.persists == false then
        return
    end
    local fx = SpawnPrefab('mk_cloudpuff')
    fx.Transform:SetScale(2.2,2.2,2.2)
    fx.Transform:SetPosition(inst:GetPosition():Get())

    inst.persists = false
    inst:AddTag("NOCLICK")
    inst:AddTag("notarget")
    inst:AddComponent('colourtweener')
    inst.components.colourtweener:StartTween({1,1,1,0},1,inst.Remove)
    --inst.components.mk_cloudfxspawner:StartTween({1,1,1,0},0.8)
end

local function fn(Sim)
    
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
    inst.entity:AddPhysics()
	inst.entity:AddDynamicShadow()
    inst.entity:AddMiniMapEntity()
	inst.DynamicShadow:SetSize( 10, 5 )
    inst.MiniMapEntity:SetIcon("laozi.tex")
    inst.MiniMapEntity:SetPriority(4)
    
    inst.Transform:SetScale(0.8,0.8,0.8)
    
    inst.AnimState:SetBank("laozi")
    inst.AnimState:SetBuild("laozi")
    inst.AnimState:PlayAnimation("anim", true)
    
    inst:AddComponent("inspectable")

    inst:AddComponent("talker")
    inst.components.talker.fontsize = 35
    inst.components.talker.font = TALKINGFONT
    inst.components.talker.colour = Vector3(255/255, 255/255, 20/255)
    inst.components.talker.offset = Vector3(0,-800,0)

    inst:AddComponent("health")
    inst.components.health.canheal = false
    inst.components.health.absorb = 2
    inst.components.health:SetInvincible(true)

    inst:AddComponent("combat")
    inst.components.combat.canbeattackedfn = function(inst, atk) return atk == GetPlayer() end
    inst:ListenForEvent('blocked', OnAttacked)
    inst:ListenForEvent('attacked', OnAttacked)

    inst:AddComponent("trader")

    --inst:AddComponent("mk_cloudfxspawner")
    for k, v in pairs(offsets_lz)do
        local min, max = 3, 4
        local fx = SpawnPrefab('mk_cloud_child')
        fx.Transform:SetPosition((v*1.4):Get())
        fx.AnimState:SetDeltaTimeMultiplier(GetRandomMinMax(.9,1.1))
        fx.AnimState:SetTime(math.random())
        fx.entity:SetParent(inst.entity)
    end

	inst.components.trader:SetAcceptTest(
		function(inst, item)
			return item and item.prefab and LootTable[item.prefab] ~= nil
		end)

    inst.components.trader.onaccept = OnGetItemFromPlayer
    inst.components.trader.onrefuse = OnRefuseItem

    inst:AddComponent('timer')
    inst:ListenForEvent('timerdone', Despawn)

    inst.Despawn = Despawn

    return inst
end

return Prefab( "common/objects/laozi", fn, assets, prefabs) 
