local assets=
{
	Asset("ANIM", "anim/laozi.zip"),
}

local function Spawn(inst)
    if GetPlayer().components.laozitimer.canspawn == false then
        GetPlayer().components.talker:Say('天上一日, 人间千年')
    else
        GetPlayer().components.laozitimer.canspawn = false
        local pos = inst:GetPosition() == Vector3(0,0,0) and GetPlayer():GetPosition() or inst:GetPosition()
        local fx = SpawnPrefab('mk_cloudpuff')
        fx.Transform:SetScale(2.2,2.2,2.2)
        fx.Transform:SetPosition(pos:Get())
    	fx:DoTaskInTime(1, function()
    		local lz  = SpawnPrefab('laozi')
    		lz.components.timer:StartTimer('despawn', 480)
    		lz.Transform:SetPosition(pos:Get())
    		if GetPlayer().prefab == 'monkey_king' then
    			lz.components.talker:Say('大圣唤老夫有何贵干?')
    		end
    		GetPlayer().components.laozitimer:OnSpawn()
    	end)
    end

    inst:DoTaskInTime(0, inst.Remove)
end

local function fn(Sim)
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()
    inst.entity:AddDynamicShadow()
    inst.DynamicShadow:SetSize( 2, 1 )
    
    inst.AnimState:SetBank("laozi_sp")
    inst.AnimState:SetBuild("laozi")
    inst.AnimState:PlayAnimation("idle", true)

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, "idle", "idle")
    MakeBlowInHurricane(inst, TUNING.WINDBLOWN_SCALE_MIN.LIGHT, TUNING.WINDBLOWN_SCALE_MAX.LIGHT)
    
    inst:AddComponent("stackable")
	inst.components.stackable.maxsize = TUNING.STACK_SIZE_SMALLITEM

    inst:AddComponent("inspectable")
    
    inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.SMALL_FUEL
    inst.components.fuel:SetOnTakenFn(Spawn)

    inst:AddComponent("appeasement")
    inst.components.appeasement.appeasementvalue = TUNING.WRATH_SMALL

    inst:AddComponent("tradable")
    
	MakeSmallBurnable(inst, TUNING.SMALL_BURNTIME)
    MakeSmallPropagator(inst)
    inst.components.burnable:MakeDragonflyBait(3)
    inst.components.burnable.onburnt = Spawn
    
    
    inst:AddComponent("inventoryitem")
    inst.components.inventoryitem.atlasname = 'images/monkey_king_item.xml'
    

    return inst
end

return Prefab( "common/inventory/laozi_sp", fn, assets) 
