require "prefabutil"

local assets =
{
    Asset("ANIM", "anim/mk_battle_flag.zip"),
    --Asset("ANIM", "anim/ui_board_5x3.zip"), --ui  待定哦
}

local prefabs =
{
    "collapse_big",
	"mk_battle_flag_item",
}

local function onhammered(inst, worker)
    inst.components.lootdropper:DropLoot()
    local fx = SpawnPrefab("collapse_big")
    fx.Transform:SetPosition(inst.Transform:GetWorldPosition())
    inst:Remove()
end

local function onhit(inst, worker)
    inst.AnimState:PlayAnimation("hit")
    inst.AnimState:PushAnimation("flag", false)
end

local function ondeploy(inst, pt, deployer)
    local ent = SpawnPrefab("mk_battle_flag")
	if ent then
		ent.Transform:SetPosition(pt:Get())
		ent.SoundEmitter:PlaySound("dontstarve/common/sign_craft")
		if ent.components.fueled  then
			local percent = inst.components.fueled and inst.components.fueled:GetPercent() or 1
			ent.components.fueled:SetPercent(percent)
		end
	end
	inst:Remove()
end


local function onsave(inst,data)
	
end

local function onload(inst,data)
	
end

local function pickupfn(inst, guy)
	if guy.components and guy.components.inventory then
		local fueled  = inst.components.fueled and inst.components.fueled:GetPercent() or 1
		local potitem = SpawnPrefab("mk_battle_flag_item")
		if potitem.components.fueled then
			potitem.components.fueled:SetPercent(fueled)
		end
		guy.components.inventory:GiveItem(potitem)
		inst:Remove()
		return true
	end
end

local function sanitydelate(inst)
	if inst.components.health and not inst.components.health:IsDead() and inst.components.sanity then
		inst.components.sanity:DoDelta(6/60, true)
	end
end

local function addbufffx(inst)
	if inst:HasTag('player') and not inst.components.combat.mk_battle_flag_bufffx then
		local fx = SpawnPrefab('lavaarena_battle_buff_fx')
		fx.entity:SetParent(inst.entity)
		fx.Transform:SetScale(1.2,1.2,1.2)
		inst.components.combat.mk_battle_flag_bufffx = fx
	end
end

local function removebufffx(inst)
	if inst:HasTag('player') and inst.components.combat.mk_battle_flag_bufffx then
		inst.components.combat.mk_battle_flag_bufffx:Remove()
		inst.components.combat.mk_battle_flag_bufffx = nil
	end
end

local function Oncheckbuff(inst) --print(1)
	local x, y, z = inst.Transform:GetWorldPosition() 
	local ents = TheSim:FindEntities(x, y, z, 15,{ "combat"},{"mk_battle_flag_buff","INLIMBO"}) 
	for i, v in ipairs(ents) do
		if not inst.addbuff[v] and (v:HasTag('player') or v.components.follower and v.components.follower.leader and v.components.follower.leader:HasTag('player'))then
			inst.addbuff[v] = true --print(2)
			addbufffx(v)
			v:AddTag("mk_battle_flag_buff")
			v.components.combat:AddDamageModifier("mk_battle_flag", 0.15)
			if v.components.locomotor then
				v.components.locomotor:AddSpeedModifier_Mult("mk_battle_flag", 0.15)
			end
		end
	end
    for v, _ in pairs(inst.addbuff) do
    	sanitydelate(v)
		--if  v  and v.components.health and v.components.combat and v.components.locomotor  then 
			if v.components.health:IsDead() or v:GetDistanceSqToInst(inst) >  225  then
				inst.addbuff[v] = nil
				if v.components.locomotor then
					v.components.locomotor:RemoveSpeedModifier_Mult("mk_battle_flag")
				end
				v.components.combat:RemoveDamageModifier("mk_battle_flag")	
				v:RemoveTag("mk_battle_flag_buff")
				removebufffx(v)
			end
		--end
    end
end

local function onremove(inst)
    for v, _ in pairs(inst.addbuff) do
		--if  v  and v.components.health  and v.components.combat and v.components.locomotor  then 
			--inst.addbuff[v] = nil
			if  v.components.locomotor then
				v.components.locomotor:RemoveSpeedModifier_Mult("mk_battle_flag")
			end
			v.components.combat:RemoveDamageModifier("mk_battle_flag")	
			v:RemoveTag("mk_battle_flag_buff")
			removebufffx(v)
		--end
    end
    inst.addbuff = {}
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    inst.entity:AddMiniMapEntity()

    MakeObstaclePhysics(inst, .3)

    inst.MiniMapEntity:SetIcon("mk_battle_flag.tex")

    inst.AnimState:SetBank("mk_battle_flag")
    inst.AnimState:SetBuild("mk_battle_flag")
    inst.AnimState:PlayAnimation("flag")
	
	inst.AnimState:SetScale(1.5, 1.5, 1.5)
    inst:AddTag("structure")

    inst:AddComponent("inspectable")
	
    inst:AddComponent("lootdropper")
	
	inst.addbuff = {}
    inst.buffs = inst:DoPeriodicTask(0.5, Oncheckbuff)
	inst.owner = nil
	
	inst:AddComponent("fueled")
    inst.components.fueled:InitializeFuelLevel(960) --10
    inst.components.fueled:SetDepletedFn(onhammered)
	inst.components.fueled:StartConsuming()

	inst:AddComponent("flagpickupable")
	inst.components.flagpickupable:SetOnPickupFn(pickupfn)
	
	inst:ListenForEvent("onremove", onremove)
	
    inst.OnSave = onsave
    inst.OnLoad = onload
	
    return inst
end

local function item_fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, 'idle', 'idle')

    inst.AnimState:SetBank("mk_battle_flag")
    inst.AnimState:SetBuild("mk_battle_flag")
    inst.AnimState:PlayAnimation("idle")
	
    inst:AddComponent("inspectable")
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "mk_battle_flag_item"
	inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"
	
    inst:AddComponent("deployable")
    inst.components.deployable.ondeploy = ondeploy
    inst.components.deployable.min_spacing = 2

    --MakeSmallBurnable(inst)
    --MakeSmallPropagator(inst)
	MakeSmallBurnable(inst, nil, nil, true)
	MakeSmallPropagator(inst)

    inst:AddComponent("fuel")
    inst.components.fuel.fuelvalue = TUNING.MED_FUEL
	
	inst:AddComponent("fueled")
    inst.components.fueled.fueltype = "USAGE"
	inst.components.fueled:SetDepletedFn(inst.Remove)
    inst.components.fueled:InitializeFuelLevel(960)
    inst.OnSave = onsave
    inst.OnLoad = onload
	
    return inst
end
return Prefab("mk_battle_flag", fn, assets, prefabs),
	Prefab("mk_battle_flag_item", item_fn, assets),
    MakePlacer("mk_battle_flag_item_placer", "mk_battle_flag", "mk_battle_flag", "flag",nil,nil,nil,1.5)
