
local assets =
{
	Asset("ANIM", "anim/mk_firefx.zip"),
}

local fxassets =
{
	Asset("ANIM", "anim/die.zip"),
}

local fireassets =
{
    Asset("ANIM", "anim/dst_myth/deer_fire_flakes_myth.zip"),
}
local halloween_embers_assets = 
{
    Asset("ANIM", "anim/dst_myth/halloween_embers_myth.zip"),
    Asset("ANIM", "anim/dst_myth/halloween_embers_cold_myth.zip"),
}

local function onremove(inst)
	local x, y, z = inst.Transform:GetWorldPosition()
    SpawnPrefab("houndfire").Transform:SetPosition(x, 0, z)
	inst:Remove()
end

local function KillFX(inst)
    inst.AnimState:PlayAnimation("pst")
    inst:ListenForEvent('animover', inst.Remove)
end

local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddLight()

	inst:AddTag("FX")
	
    MakeInventoryPhysics(inst)
    RemovePhysicsColliders(inst)
	
    inst.AnimState:SetBank("mk_firefx")
    inst.AnimState:SetBuild("mk_firefx")
    inst.AnimState:PlayAnimation("idle_loop",true)
    inst.AnimState:SetFinalOffset(2)
	inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")
	
	local scale = math.random(4,8) * 0.1
	
	inst.Transform:SetScale(scale, scale, scale)	
    inst.Light:SetFalloff(0.7)
    inst.Light:SetIntensity(.5)
    inst.Light:SetRadius(0.5)
    inst.Light:SetColour(197/255, 126/255, 126/255)
    inst.Light:Enable(true)	

	inst.persists = false
	inst.firetask = inst:DoTaskInTime(1, onremove)
	return inst
end

local function fxfn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter() 

    inst.AnimState:SetBank("die_fx")
    inst.AnimState:SetBuild("die")
	inst.AnimState:PlayAnimation("large")
	inst.AnimState:SetMultColour(239/255, 184/255, 16/255, 1)
	
	inst:AddTag("fx")
	inst.SoundEmitter:PlaySound("dontstarve/creatures/slurtle/mound_explode")
	
    inst:AddTag("NOBLOCK")

	inst.persists = false
	inst:ListenForEvent("animover", inst.Remove)
    return inst
end

local function firefn()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    
    inst.AnimState:SetBank("deer_fire_flakes")
    inst.AnimState:SetBuild("deer_fire_flakes_myth")
    inst.AnimState:PlayAnimation("pre")
    inst.AnimState:SetLightOverride(1)
    inst.AnimState:SetFinalOffset(1)

    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

    inst:AddTag("FX")

    inst.persists = false
    inst.AnimState:PushAnimation("loop",true)

    inst.KillFX = KillFX
    return inst
end

local function firefn2()
    local inst = SpawnPrefab('mk_firefire')
    inst.Transform:SetScale(.7,.7,.7)
    inst.prefab = 'mk_firefire2'
    inst:DoTaskInTime(1,inst.KillFX)

    return inst
end

----DST 

local function halloween_embers(num,cold)
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddSoundEmitter()
    
    inst.AnimState:SetBank("halloween_embers"..(cold and '_cold' or ''))
    inst.AnimState:SetBuild("halloween_embers"..(cold and '_cold' or '')..'_myth')
    inst.AnimState:PlayAnimation("puff_"..tostring(num) )
    inst.AnimState:SetLightOverride(1)
    inst.AnimState:SetFinalOffset(3)
    inst.AnimState:SetBloomEffectHandle("shaders/anim.ksh")

    inst.SoundEmitter:PlaySound('dontstarve/common/fireAddFuel')

    inst:AddTag("FX")
    inst:AddTag("NOCLICK")

    inst:ListenForEvent('animover',inst.Remove)
    inst.persists = false
    
    return inst
end

return Prefab("mk_firefx", fn, assets),
		Prefab("mk_firefxdie", fxfn, fxassets),
		Prefab("mk_firefire", firefn, fireassets),
        Prefab("mk_firefire2", firefn2, fireassets),
        Prefab("mk_halloween_firepuff_1",function() return halloween_embers(1) end, halloween_embers_assets),
        Prefab("mk_halloween_firepuff_2",function() return halloween_embers(2) end, halloween_embers_assets),
        Prefab("mk_halloween_firepuff_3",function() return halloween_embers(3) end, halloween_embers_assets),
        Prefab("mk_halloween_firepuff_cold_1",function() return halloween_embers(1,1) end, halloween_embers_assets),
        Prefab("mk_halloween_firepuff_cold_2",function() return halloween_embers(2,2) end, halloween_embers_assets),
        Prefab("mk_halloween_firepuff_cold_3",function() return halloween_embers(3,3) end, halloween_embers_assets)
