
local function makeitem(name,floatable,anim1,anim2,image,stack)
	local assets = {Asset("ANIM", 'anim/mk_items.zip')}
	local function fn()
		local inst = CreateEntity()

		inst.entity:AddTransform()
		inst.entity:AddAnimState()
		inst.entity:AddSoundEmitter()

		if name == 'mk_rock' then
			inst.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
			inst.Transform:SetScale(0.8,0.8,0.8)
		end

		MakeInventoryPhysics(inst)
		if floatable then
			MakeInventoryFloatable(inst, anim2, anim1)
		end

		inst.AnimState:SetBank("mk_items")
		inst.AnimState:SetBuild("mk_items")
		inst.AnimState:PlayAnimation(anim1)
		
		inst:AddComponent("tradable")

		inst:AddComponent("inspectable")

		inst:AddComponent("inventoryitem")
		inst.components.inventoryitem.imagename = anim1
		inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"

		if stack then
			inst:AddComponent("stackable")
        	inst.components.stackable.maxsize = stack
        end

		return inst
	end
	return Prefab(name, fn, assets)
end
return  makeitem("mk_rock",false,'mk_huoyuan','mk_huoyuan','',TUNING.STACK_SIZE_LARGEITEM), --石心
		makeitem("mk_flowerfeather",true,'mk_hualing','water1','',TUNING.STACK_SIZE_LARGEITEM), --花翎
		makeitem("mk_dragonscale",true,'mk_longpi','water2','',TUNING.STACK_SIZE_LARGEITEM)--鳞片
		