
local assets = {
    Asset("ANIM", "anim/nz_lance.zip"),
}

local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_object", "nz_lance", "swap_object")
	owner.AnimState:Show("ARM_carry")
	owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
	owner.AnimState:ClearOverrideSymbol("swap_object")
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddMiniMapEntity()
    inst.MiniMapEntity:SetIcon("nz_lance.tex")

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, 'idle_water', 'idle')

    inst.AnimState:SetBank("nz_lance")
    inst.AnimState:SetBuild("nz_lance")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("sharp")
    inst:AddTag("pointy")

    inst:AddTag("rechargeable")
    inst:AddTag("irreplaceable")

    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(51)

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "nz_lance"
	inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

	inst:AddComponent("myth_weaponreticule")
	inst.components.myth_weaponreticule:SetSpellFn(function() end)
    inst.components.myth_weaponreticule.trigger_action = ACTIONS.NZ_36
    inst.components.myth_weaponreticule.reticule_prefab = 'myth_reticule_aoe'
	
	inst:AddComponent("myth_rechargeable")
	inst.components.myth_rechargeable:SetRechargeTime(20)

	--inst:DoTaskInTime(0,function()if GetPlayer().prefab ~= 'neza' then inst:Remove()end end)

    return inst
end

return Prefab("nz_lance", fn, assets)
		