
local L = MK_MOD_LANGUAGE_SETTING

local function createUI()
	local ctrl = GetPlayer().HUD and GetPlayer().HUD.controls
	local ui = ctrl and ctrl.lw_skinchanger
	if ui then
		ui:Show()
	end
end

local function delUI()
	local ctrl = GetPlayer().HUD and GetPlayer().HUD.controls
	local ui = ctrl and ctrl.lw_skinchanger
	if ui then
		ui:Hide()
	end
end

local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_object", 'skinmirror', 'swap')
	owner.AnimState:Show("ARM_carry")
	owner.AnimState:Hide("ARM_normal")
	createUI()
end

local function onunequip(inst, owner)
	owner.AnimState:ClearOverrideSymbol("swap_object")
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
    delUI()
end

local assets = {
	Asset("ANIM", 'anim/skinmirror.zip'),
}

STRINGS.NAMES.SKINMIRROR = L and 'Mirror' or '照妖镜'
STRINGS.RECIPE_DESC.SKINMIRROR = L and 'It will reveal your another face.' or '照射出你的另一张面孔'

local function fn()
	local inst = CreateEntity()
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	inst:AddTag('irreplaceable')

	MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, 'idle_water', 'idle')

	inst.AnimState:SetBank('skinmirror')
	inst.AnimState:SetBuild('skinmirror')
	inst.AnimState:PlayAnimation("idle")

	inst:AddComponent("inspectable")

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"

	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HANDS
	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)

	return inst
end

return Prefab('skinmirror',fn,assets)