
local L = MK_MOD_LANGUAGE_SETTING
STRINGS.NAMES.WB_STAFF = L and 'Bone staff' or '骨杖'
STRINGS.RECIPE_DESC.WB_STAFF = L and 'The thorn of undead breaks through the earth.' or'破土而出尸者的利刺'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WB_STAFF = L and "A magic staff." or '巴啦啦能量! 沙卡拉卡,... 咳咳...'

local assets = {
    Asset("ANIM", "anim/bone_wand.zip"),
    Asset("ANIM", "anim/dst_myth/spider_spike_myth_build.zip"),
}

local function onequip(inst, owner)
	owner.AnimState:OverrideSymbol("swap_object", "bone_wand", "swap_bone_wand")
	owner.AnimState:Show("ARM_carry")
	owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
	owner.AnimState:ClearOverrideSymbol("swap_object")
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end
--[[
local function summonfn(inst, caster, pos)
    local num = 10
    local interval = 24*FRAMES
    local radius = 5
    local lightr = radius * 0.7
    local scale = radius * 0.4

    local function _skeleton()
        if num == 0 then return false end
        for i = 1, 10 do
            local a = 2*PI * math.random()
            local r = radius * math.random() --@--
            local offset = Point(r*math.sin(a), 0, r*math.cos(a))
            if MK_MOD_UTIL.IsOnGround(offset + pos) then
                num = num - 1
                local sk = SpawnPrefab('wb_skeleton')
                sk.Transform:SetPosition((offset + pos):Get())
                --caster.components.leader:AddFollower(sk)
                GetPlayer().components.leader:AddFollower(sk)--@--
                sk:SpawnBySpell()
                return true
            end
        end
        return true
    end

    local ring = MK_MOD_UTIL.MakeFxAt(pos, 'wb_spellring', 'wb_spellring', 'ring')
    ring.AnimState:SetMultColour(100/255, 30/255, 255/255, 0.5)
    ring.AnimState:SetSortOrder(3)
    ring.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    ring.AnimState:SetLayer(LAYER_BACKGROUND)
    ring.Transform:SetScale(scale, scale, scale)
    ring.entity:AddSoundEmitter()
    ring.SoundEmitter:PlaySound('mythwords_bgm/whitebone/spell', nil, 0.3)--@--
    ring:AddComponent('colourtweener')
    ring:AddComponent('sizetweener')

    ring.TurnOff = function(ring)
        ring.components.colourtweener:StartTween({1,1,1,0}, FRAMES*15, ring.Remove)
        ring.components.sizetweener:StartTween(0.4, FRAMES*15) --变大?
    end

    local circle = MK_MOD_UTIL.MakeFxAt(pos, 'wb_spellring', 'wb_spellring', 'circle')
    circle.AnimState:SetMultColour(200/255, 150/255, 255/255, 0.1)
    circle.AnimState:SetSortOrder(2)
    circle.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)
    circle.AnimState:SetLayer(LAYER_BACKGROUND)
    circle.Transform:SetScale(scale, scale, scale)
    circle:AddComponent('colourtweener')
    circle:AddComponent('sizetweener')
    circle.TurnOff = ring.TurnOff

    local light = MK_MOD_UTIL.MakeFxAt(pos, 'cavelight', 'cave_exit_lightsource')
    light.entity:AddLight()
    light.Light:Enable(true)
    light.Transform:SetScale(2,2,1)
    light.AnimState:PlayAnimation("on")
    light.AnimState:PushAnimation("idle_loop", false)
    light.Light:SetColour(250/255, 250/255, 255/255)
    light:AddComponent('lighttweener')
    light.components.lighttweener:StartTween(light.Light, 0, .9, .9, nil, 0)    
    light.components.lighttweener:StartTween(light.Light, lightr, nil, nil, nil, FRAMES*6)
    light.TurnOff = function(light)
        light.AnimState:PlayAnimation("off")
        light.components.lighttweener:StartTween(light.Light, 0, nil, nil, nil, FRAMES*6)
        light:ListenForEvent("animover", light.Remove)   
    end

    ---执行
    ring.task = ring:DoPeriodicTask(interval, function()
        if not _skeleton() then
            ring.task:Cancel()
            ring:TurnOff()
            light:TurnOff()
            circle:TurnOff()
        end
    end)
end
--]]
local function createspike(pos)
    local inst = CreateEntity()
    local trans = inst.entity:AddTransform()
    local anim = inst.entity:AddAnimState()
    MakeObstaclePhysics(inst, .4)

    inst.is_wb_spike = true
    inst.prefab = ''

    anim:SetBank('spider_spike')
    anim:SetBuild('spider_spike_myth')
    anim:OverrideSymbol('spike01', 'spider_spike_myth_build', 'spike0'.. math.random(9))
    anim:PlayAnimation('spike_pre')
    anim:PushAnimation("spike_loop")
    if math.random(2) == 2 then anim:SetScale(-1,1) end

    trans:SetPosition(pos:Get())

    inst:AddComponent('combat')
    inst:AddComponent('health')
    inst.components.health:SetMaxHealth(100)
    --inst:AddComponent('inspectable')

    inst.persists = false

    local function _doattack(damage)
        for _, v in pairs(TheSim:FindEntities(pos.x, 0, pos.z, 1.5, {'combat'}, {'FX', 'NOCLICK', 'INLIMBO', 'player', 'wb_skeleton'})) do
            if v.components.health and not v.components.health:IsDead() and v.is_wb_spike == nil then
                v.components.combat:GetAttacked(inst, damage)
            end
        end
    end

    inst:DoTaskInTime(0.1, function() _doattack(25) end)
    inst:DoTaskInTime(10 + math.random(), inst.PushEvent, 'death')

    inst:ListenForEvent('death', function()
        if not inst.dead then
            inst.dead = true
            _doattack(10)
            inst:AddTag('FX')
            inst:AddTag('NOCLICK')
            anim:PlayAnimation('spike_pst')
            inst:DoTaskInTime(anim:GetCurrentAnimationLength() + FRAMES, inst.Remove)
        end
    end)
end
        
local function spikefn(inst, caster, pos)
    local caster = GetPlayer()--debug
    local sanity = caster.components.sanity
    local num = sanity:GetPercent() * 20 + 10 --10~30
    local mindistSq = 1*1
    local distancemodifier = 5
    local positions = {}
    --copy from components/minionspawner.lua
    for i = 1, 100 do
        local s = i/32.0
        local a = math.sqrt(s*512.0)
        local b = math.sqrt(s)
        table.insert(positions, Vector3(math.sin(a)*b, 0, math.cos(a)*b))
    end
    
    local useablepositions = {}
    local pt = pos
    local ground = GetWorld()
    for k,v in pairs(positions) do
        local offset = Vector3(v.x * distancemodifier, 0, v.z * distancemodifier)
        local try_pos = offset + pt
        if not (ground.Map and ground.Map:GetTileAtPoint(try_pos.x, try_pos.y, try_pos.z) == GROUND.IMPASSABLE or ground:GetIsOnWater(try_pos) ) then 
            table.insert(useablepositions, try_pos)
            if #useablepositions >= num then 
                break
            end

        end
    end
    
    for _,p in pairs(useablepositions)do
        createspike(p)
    end
    sanity:DoDelta(-30)
    inst.components.finiteuses:Use(10)
end

local function fn()
    local inst = CreateEntity()

    inst.entity:AddTransform()
    inst.entity:AddAnimState()

    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, 'idle_water', 'idle')

    inst.AnimState:SetBank("bone_wand")
    inst.AnimState:SetBuild("bone_wand")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("nopunch")
    inst:AddTag("irreplaceable")

    inst:AddComponent("inspectable")

    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"

    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    inst:AddComponent("spellcaster")
    inst.components.spellcaster:SetSpellFn(spikefn)
    inst.components.spellcaster:SetSpellTestFn(function() return true end)
    inst.components.spellcaster.canuseonpoint = true
    inst.components.spellcaster.canusefrominventory = false

    inst:AddComponent('finiteuses')
    inst.components.finiteuses:SetMaxUses(100)
    inst.components.finiteuses:SetUses(100)
    inst.components.finiteuses:SetOnFinished(inst.Remove)

    inst.DoFix = function(inst, value)
        value = math.min(value, inst.components.finiteuses.total - inst.components.finiteuses:GetUses())
        inst.components.finiteuses:Use(-value)
    end
	inst:DoTaskInTime(0,function()if GetPlayer().prefab ~= 'white_bone' then inst:Remove()end end)

    return inst
end

return Prefab("wb_staff", fn, assets)
		