
local L = MK_MOD_LANGUAGE_SETTING
--因为骨质武器只用于白骨夫人角色, 因此检查描述只写了一个
STRINGS.NAMES.WB_KNIFE = L and 'Bone knife' or '骨刃'
STRINGS.RECIPE_DESC.WB_KNIFE = L and 'Double hand for cooking and killing.' or'上得了战场,\n下得了厨房'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WB_KNIFE = L and "It's not a bad idea to kill the stupid monk with this knife." or '腰藏三寸锋, 弑君七尺命'

STRINGS.NAMES.WB_BLADE = L and 'Bone blade' or '骨剑'
STRINGS.RECIPE_DESC.WB_BLADE = L and "A river of blood!" or '血流成河!'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WB_BLADE = L and 'No mercy.' or '夺尔之命, 养吾之体.'

STRINGS.NAMES.WB_WHIP = L and 'Bone whip' or '骨鞭'
STRINGS.RECIPE_DESC.WB_WHIP = L and 'Take away the flesh' or'文犀饰首, 错乱珠明.'
STRINGS.CHARACTERS.GENERIC.DESCRIBE.WB_WHIP = L and 'It smells grim.' or"散发着阴森的气息!"

local assets = {
    Asset("ANIM", "anim/bone_blade.zip"),
    Asset("ANIM", "anim/bone_whip.zip"),
    Asset("ANIM", "anim/swap_bone_whip.zip"),
    Asset("ANIM", "anim/wb_knife.zip"),
}

local prefabs = {}

local function dofix(inst, value)
    value = math.min(value, inst.components.finiteuses.total - inst.components.finiteuses:GetUses())
    inst.components.finiteuses:Use(-value)
end

local function blood(p)
    local function onhitother(inst,data)
        if data and data.target then
            local damage = (data.damage or 0) *(p or 0.05)
            if inst.components.health ~= nil and inst.components.health:GetPercent() < 1 and not (data.target:HasTag("wall") or data.target:HasTag("engineering")) then
                inst.components.health:DoDelta(damage, nil)
            end
        end
    end
    return onhitother
end
local blood_blade = blood(0.1)
local blood_whip = blood(0.05)

local function commonweapon()
    local inst = CreateEntity()
    inst.entity:AddTransform()
    inst.entity:AddAnimState()
    inst.entity:AddMiniMapEntity()
    MakeInventoryPhysics(inst)
    MakeInventoryFloatable(inst, 'idle', 'idle')

    inst:AddComponent('weapon')
    inst:AddComponent('inspectable')
    inst:AddComponent('inventoryitem')
    inst.components.inventoryitem.atlasname = 'images/monkey_king_item.xml'
    inst:AddComponent('equippable')
    --inst:AddComponent('characterspecific')
    --inst.components.characterspecific:SetOwner('white_bone')

    inst.DoFix = dofix

    return inst
end

----剑-----

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "bone_blade", "swap_bone_blade")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
    inst:ListenForEvent("onhitother", blood_blade, owner)
end

local function onunequip(inst, owner)
    owner.AnimState:ClearOverrideSymbol("swap_object")
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
    inst:RemoveEventCallback("onhitother", blood_blade, owner)
end


local function fn()
    local inst = commonweapon()
    inst.AnimState:SetBank("bone_blade")
    inst.AnimState:SetBuild("bone_blade")
    inst.AnimState:PlayAnimation("idle")

    inst:AddTag("sharp")
    inst:AddTag("pointy")

    inst.components.weapon:SetDamage(68)
    inst.components.weapon:SetRange(0.5)

    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(50)
    inst.components.finiteuses:SetUses(50)
    inst.components.finiteuses:SetOnFinished(inst.Remove)

    return inst
end

table.insert(prefabs, Prefab('wb_blade', fn, assets))

----鞭子----
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_bone_whip", "swap_whip")
    owner.AnimState:OverrideSymbol("whipline", "swap_bone_whip", "whipline")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
    inst:ListenForEvent("onhitother", blood_whip, owner)
end

local function onunequip(inst, owner)
    owner.AnimState:ClearOverrideSymbol("swap_object")
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
    inst:RemoveEventCallback("onhitother", blood_whip, owner)
end

local function fn()
    local inst = commonweapon()
    inst.AnimState:SetBank("bone_whip")
    inst.AnimState:SetBuild("bone_whip")
    inst.AnimState:PlayAnimation("idle")

    inst.components.weapon:SetDamage(41)
    inst.components.weapon:SetRange(2)

    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(100)
    inst.components.finiteuses:SetUses(100)
    inst.components.finiteuses:SetOnFinished(inst.Remove)

    inst.components.weapon.attackwear = 0 --应该在sg里扣耐久

    return inst
end

table.insert(prefabs, Prefab('wb_whip', fn, assets))

---小刀----
local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "wb_knife", "swap_object")
    owner.AnimState:Show("ARM_carry")
    owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
    owner.AnimState:ClearOverrideSymbol("swap_object")
    owner.AnimState:Hide("ARM_carry")
    owner.AnimState:Show("ARM_normal")
end
--[[
local function fn()
    local inst = commonweapon()
    inst.AnimState:SetBank('wb_knife')
    inst.AnimState:SetBuild('wb_knife')
    inst.AnimState:PlayAnimation('idle')

    inst.components.weapon:SetDamage(34)

    inst.components.equippable:SetOnEquip(onequip)
    inst.components.equippable:SetOnUnequip(onunequip)
    inst.components.equippable.walkspeedmult = 0.1 --手杖0.25

    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(100)
    inst.components.finiteuses:SetUses(100)
    inst.components.finiteuses:SetOnFinished(inst.Remove)

    inst:AddComponent('wb_meatcutter')

    return inst
end
--]]
--table.insert(prefabs, Prefab('wb_knife', fn, assets))
local function fn()
    local inst = CreateEntity()
    inst.entity:AddTransform()

    inst:AddComponent('inventoryitem')
    inst.components.inventoryitem.atlasname = 'images/monkey_king_item.xml'
    inst.components.inventoryitem.imagename = 'bonelock'
    inst.components.inventoryitem:SetOnDroppedFn(inst.Remove)

    inst:AddComponent('equippable')
    inst.components.equippable.myth_unequipable = true
    inst.components.equippable.un_unequipable = true
    inst.components.equippable.CollectInventoryActions = function() end

    inst.name = ''
    inst.persists = false
    inst:AddTag('cantdrop')
    inst:AddTag('notslippery')
    inst:AddTag("NOBLOCK")
    
    print('111')
    return inst
end
table.insert(prefabs, Prefab('wb_bonelock', fn, assets))

return unpack(prefabs)
		