
local assets=
{
    Asset("ANIM", "anim/xzhat_mk.zip"),
}

local function onequiphat(inst, owner)
		owner.AnimState:OverrideSymbol("swap_hat", "xzhat_mk",  "swap_hat")
        owner.AnimState:Show("HAT")
        owner.AnimState:Show("HAIR_HAT")
        owner.AnimState:Hide("HAIR_NOHAT")
        owner.AnimState:Hide("HAIR")

        if owner:HasTag("player") then
            owner.AnimState:Hide("HEAD")
            owner.AnimState:Show("HEAD_HAIR")
        end

        if inst.components.fueled ~= nil then
            inst.components.fueled:StartConsuming()
        end

        owner:AddTag('fireeye_boost_mk')
end

local function onunequiphat(inst, owner)
        owner.AnimState:ClearOverrideSymbol("swap_hat")
        owner.AnimState:Hide("HAT")
        owner.AnimState:Hide("HAIR_HAT")
        owner.AnimState:Show("HAIR_NOHAT")
        owner.AnimState:Show("HAIR")

        if owner:HasTag("player") then
            owner.AnimState:Show("HEAD")
            owner.AnimState:Hide("HEAD_HAIR")
        end

        if inst.components.fueled ~= nil then
            inst.components.fueled:StopConsuming()
        end

        owner:RemoveTag('fireeye_boost_mk')
end

local function fn(Sim)
	local inst = CreateEntity()
	
	inst.entity:AddTransform()
	inst.entity:AddAnimState()

	MakeInventoryPhysics(inst)
	MakeInventoryFloatable(inst,'idle_water','idle')

	inst.AnimState:SetBank("xzhat_mk")
	inst.AnimState:SetBuild("xzhat_mk")
	inst.AnimState:PlayAnimation("idle")

	inst:AddTag("hat")
	inst:AddTag("xzhat_mk")
	
	inst:AddComponent("tradable")
	
    inst:AddComponent("inspectable")
		
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "xzhat_mk"
	inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"
	
	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HEAD
	inst.components.equippable:SetOnEquip( onequiphat )
	inst.components.equippable:SetOnUnequip( onunequiphat )
	inst.components.equippable.dapperness = TUNING.DAPPERNESS_LARGE

    inst:AddComponent("insulator")
    inst.components.insulator:SetInsulation(TUNING.INSULATION_LARGE)
	
    inst:AddComponent("fueled")
    inst.components.fueled.fueltype = 'USAGE'
    inst.components.fueled:InitializeFuelLevel(TUNING.HAWAIIANSHIRT_PERISHTIME) --15天
    inst.components.fueled:SetDepletedFn(inst.Remove)
    
	return inst
end 

return Prefab( "xzhat_mk", fn, assets)