local assets =
{
	Asset("ANIM", "anim/yamaraja_book.zip"),
    Asset("ANIM", "anim/lw_floatable.zip"),
    Asset("ATLAS", "images/monkey_king_item.xml" ),
}
 
local prefabs = {}    

local function onread(inst, reader)
    if reader.components.yamarajabuff then
        reader.components.yamarajabuff.hasbuff = true
    end
    if reader.components.talker then
        reader:DoTaskInTime(0.5,function()
            if not MK_MOD_LANGUAGE_SETTING then
                reader.components.talker:Say("这样我就可以摆脱一次死亡了!")
            end
        end)
    end
    SpawnPrefab('mk_halloween_firepuff_cold_'..math.random(3)).Transform:SetPosition(reader:GetPosition():Get())
    return true
end

local function onfinished(inst)
    inst:Remove()
end

function MakeBook(name, usefn, bookuses )

    local function fn(Sim)
    	local inst = CreateEntity()
    	local trans = inst.entity:AddTransform()
    	local anim = inst.entity:AddAnimState()
        local sound = inst.entity:AddSoundEmitter()

        MK_MOD_UTIL.MakeFloatable(inst,'yamaraja_book')
        MakeInventoryPhysics(inst)
        
        -----------------------------------
        
        inst:AddComponent("inspectable")
        inst:AddComponent("book")
        inst.components.book.onread = usefn
        
        inst:AddComponent("inventoryitem")
        inst.components.inventoryitem.atlasname = "images/monkey_king_item.xml"

        inst:AddComponent("finiteuses")
        inst.components.finiteuses:SetMaxUses(1)
        inst.components.finiteuses:SetUses(1)
        inst.components.finiteuses:SetOnFinished(onfinished)

        MakeSmallBurnable(inst)
        MakeSmallPropagator(inst)

        inst:AddTag('irreplaceable')

        inst:DoTaskInTime(0, function()
            if GetPlayer().components.yamarajabuff.hasbuff then
                inst:Remove()
            end
            for k, v in pairs(Ents)do 
                if v.prefab == 'yamaraja_book' and v ~= inst and v:IsValid() then
                    v:Remove()
                end
            end
        end)

        return inst
    end

    return Prefab( name, fn, assets, prefabs) 
end


return MakeBook("yamaraja_book",onread,1)
