local L = MK_MOD_LANGUAGE_SETTING
local KEY = KEY_H --???

local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local Text = require "widgets/text"

local WB = Class(Widget, function(self, owner)

	Widget._ctor(self, "WB")
	self.owner = owner
	self.inst.entity:AddSoundEmitter()

	self.badge = self:AddChild(UIAnim())
    self.badge:GetAnimState():SetBank("monkey_kingui")
    self.badge:GetAnimState():SetBuild("monkey_kingui")
    self.badge:GetAnimState():PlayAnimation('turn_'.. (self.owner.fireeye and 'on' or 'off'))
    self.badge:SetScale(.26)
    SetDebugEntity(self.badge.inst)
    --self.name = self:AddChild(Text(BODYTEXTFONT,25,(L and "disguise" or "伪装")..' (H)'))--技能名字
    self.name = self:AddChild(Text(BODYTEXTFONT,25,(L and "fire eye (H)" or "火眼金睛 (H)")))
    self.name:SetPosition(0,-50,0)
    self.name:Hide()

    self.timer = 5
	self:StartUpdating()

	owner.TriggerFireEyeUI = function()
		self:OnControl(-1)
	end

	--self.inst:ListenForEvent('')
end)

function WB:OnGainFocus()
    WB._base.OnGainFocus(self)
    self.name:Show()
end

function WB:OnLoseFocus() 
	WB._base.OnLoseFocus(self)
	self.name:Hide()
	self:ScaleTo(1, 1, 0)
end

function WB:CanResponse()
	return self.owner and not self.owner.components.health:IsDead()
end

function WB:OnControl(control, down) 
	if not self:CanResponse() then return end
	if control == -1 then
		self.badge:GetAnimState():PlayAnimation('turn_'..(self.owner.fireeye and 'off' or 'on'))
		self.owner:TriggerFireEye()
		return true
	end

	if not self:IsEnabled() or not self.focus then return end
	if control == CONTROL_ACCEPT then
		if down then
			self:ScaleTo(1,0.9,1/15)
			self.down = true
			TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/click_move")
		elseif self.down then
			self:ScaleTo(0.9,1,1/15)
			self.down = false

			self.badge:GetAnimState():PlayAnimation('turn_'..(self.owner.fireeye and 'off' or 'on'))
			self.owner:TriggerFireEye()
		end
		return true
	end
end

function WB:Shake()
	--
end
function WB:OnUpdate(dt)

end

return WB