local L = MK_MOD_LANGUAGE_SETTING
local KEY = KEY_H --???

local UIAnim = require "widgets/uianim"
local Widget = require "widgets/widget"
local Text = require "widgets/text"

local WB = Class(Widget, function(self, owner)

	Widget._ctor(self, "WB")
	self.owner = owner
	self.inst.entity:AddSoundEmitter()

	self.badge = self:AddChild(UIAnim())
    self.badge:GetAnimState():SetBank("white_boneui")
    self.badge:GetAnimState():SetBuild("white_boneui")
    self.badge:GetAnimState():PlayAnimation("idle")
    self.badge:SetScale(.26)
    
    --self.name = self:AddChild(Text(BODYTEXTFONT,25,(L and "disguise" or "伪装")..' (H)'))--技能名字
    self.name = self:AddChild(Text(BODYTEXTFONT,25,(L and "disguise (H)" or "伪装 (H)")))
    self.name:SetPosition(0,-50,0)
    self.name:Hide()

    self.timer = 5
	self:StartUpdating()

	self.owner.TriggerDisguiseUI = function()
		self:OnControl(-1)
	end
end)

function WB:OnGainFocus()
    WB._base.OnGainFocus(self)
    self.name:Show()
end

function WB:OnLoseFocus() 
	WB._base.OnLoseFocus(self)
	self.name:Hide()
	self:ScaleTo(1, 1, 0)
end

function WB:CanResponse()
	return self.owner and not(
		self.owner.sg:HasStateTag('wb_2ghost') or
		self.owner.sg:HasStateTag('wb_2beauty') or 
		self.owner._isghost
	)
end

function WB:OnControl(control, down) 
	if not self:CanResponse() then return end
	if control == -1 then
		self.badge:GetAnimState():PlayAnimation('click')
		self.badge:GetAnimState():PushAnimation('idle', false)
		self.owner:TriggerDisguise()
		return true
	end

	if not self:IsEnabled() or not self.focus then return end
	if control == CONTROL_ACCEPT then
		if down then
			self:ScaleTo(1,0.9,1/15)
			self.down = true
			TheFrontEnd:GetSound():PlaySound("dontstarve/HUD/click_move")
		elseif self.down then
			self:ScaleTo(0.9,1,1/15)
			self.down = false	
			self.badge:GetAnimState():PlayAnimation('click')
			self.badge:GetAnimState():PushAnimation('idle', false)
			self.owner:TriggerDisguise()
		end
		return true
	end
end

function WB:Shake()
	--
end
function WB:OnUpdate(dt)

end

return WB